﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using DivulgacionCientifica.CapaNegocio;
using System.Data.SqlClient;

namespace DivulgacionCientifica
{
    public partial class AnadirObservacion : System.Web.UI.Page
    {
        string idCurrentUser = HttpContext.Current.User.Identity.Name;
        Publicacion not;

        protected void Page_Load(object sender, EventArgs e)
        {
            LabelCorrecto.Text = "";
            LabelError.Text = "";
            if (idCurrentUser.Equals(""))
            {
                Response.Redirect("~\\SolicitarAutenticacion.aspx");
            }
            else if (Request.Params[0] == null)
            {
                Response.Redirect("~\\Inicio.aspx");
            }
            else
            {
                try
                {
                    not = new Publicacion(Int32.Parse(Request.Params["id"]));
                    hpVolver.NavigateUrl = "VisualizarPublicacion.aspx?id="+not.getID();
                    LabelTitulo.Text = not.getTitulo();
                }
                catch (SqlException)
                {
                    LabelError.Text = "ERROR. Se ha producido un error al cargar la publicación.";
                }
            }
        }

        protected void btEnviar_Click(object sender, EventArgs e)
        {
            try
                {
                    Publicacion not = new Publicacion(Int32.Parse(Request.Params[0]));
                    if (TextBoxDescripcion.Text.Length > 5000)
                    {
                        LabelError.Text = "El texto no puede exceder de 5000 caracteres.";
                    }
                    else
                    {
                        Comentario obs = new Comentario(TextBoxDescripcion.Text, new Usuario(idCurrentUser), new Publicacion(not.getID()));
                        obs.almacenar();
                        LabelCorrecto.Text = "El comentario ha sido enviado con ÉXITO.";
                        PanelComment.Visible = false;
                    }
                }
                catch (SqlException)
                {
                    LabelError.Text = "ERROR. Se ha producido un error al cargar la publicación.";
                }
            
        }
    }
}
