﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.IO;
using System.Data.SqlClient;
using System.Collections.Generic;

namespace DivulgacionCientifica.CapaNegocio
{
    public class Archivo
    {
        string idCurrentUser = HttpContext.Current.User.Identity.Name;
        int id;
        private string ruta;
        private Usuario subidoPor;
        private Publicacion publicac;
        private bool validado;

        public Archivo(string ruta, Usuario subidoPor, Publicacion publ)
        {
            this.id = -1; //Todavía no ha sido almacenado
            this.ruta = ruta;
            this.subidoPor = subidoPor;
            this.publicac = publ;
        }

        public Archivo(int id, string ruta, Usuario subidoPor, Publicacion publ, bool validado)
        {
            this.id = id;
            this.ruta = ruta;
            this.subidoPor = subidoPor;
            this.publicac = publ;
            this.validado = validado;
        }

        public Archivo(int id)
        {
            this.id = id;
            string idCreador = "";
            if (id != -1) //Si id es -1 no esta asociado a ninguna publicacion
            {
                string sentencia = "SELECT * FROM ARCHIVOS WHERE ID = " + id;
                System.Data.SqlClient.SqlConnection cnn = new System.Data.SqlClient.SqlConnection();
                cnn.ConnectionString = Estatica.getConnectionBD;
                cnn.Open();
                SqlCommand com = new SqlCommand(sentencia, cnn);
                SqlDataReader dr = com.ExecuteReader();

                int idPublic = -1;
                if (dr.Read())
                {
                    this.ruta = dr.GetString(1);
                    idCreador = dr.GetString(2);
                    idPublic = dr.GetInt32(3);
                }
                dr.Close();
                cnn.Close();
                this.publicac = new Publicacion(idPublic);
                this.subidoPor = new Usuario(idCreador); //Lo hago asi pq ya habia una conexion con la bd abierta y este constructor abre otra
            }

        }

        public int getID() { return id; }

        public string getRuta() { return ruta; }

        public Usuario getSubidoPor() { return subidoPor; }

        public Publicacion getPublicac() { return publicac; }

        private int maxID()
        {
            Int32 newId = 0;
            string sql = "SELECT * FROM Archivos";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sql, cnn);
            SqlDataReader dr = com.ExecuteReader();

            bool hayDatos;
            if (dr.Read()) //Hay noticias almacenadas
            {
                hayDatos = true;
            }
            else
            {
                hayDatos = false;
            }
            cnn.Close();

            if (hayDatos)
            {
                string sql2 = "SELECT MAX(ID) FROM Archivos";
                SqlConnection cnn2 = new SqlConnection();
                cnn2.ConnectionString = Estatica.getConnectionBD;
                cnn2.Open();
                SqlCommand com2 = new SqlCommand(sql2, cnn2);
                newId = (Int32)com2.ExecuteScalar();
                cnn2.Close();
            }
            return newId;
        }
        
        public string almacenar()
        {
            //Almacena en BD y en Archivos
            int id = maxID() + 1;

            string nombre = ruta.Substring(ruta.LastIndexOf(Path.DirectorySeparatorChar) + 1);
            string rutaDest = Estatica.getRutaProyecto + "Archivos" + Path.DirectorySeparatorChar + id + "_" + nombre;
            if (File.Exists(rutaDest)) //Aunq va precedido de un id unico y no deberia existir en la carpeta puede que exista si se ha producido un error anteriormente
            {
                File.Delete(rutaDest);
            }
            File.Move(ruta, rutaDest);

            string idNotic; if (publicac.getID() < 1) { idNotic = "NULL"; } else { idNotic = publicac.getID().ToString(); }
            string rutaBD = Estatica.getRutaProyecto + "Archivos\\"+Path.DirectorySeparatorChar+ id + "_" + nombre;
            string strSQL = "INSERT INTO Archivos VALUES (" + id + ", '" + rutaBD + "', '"+idCurrentUser+"', "+idNotic+", 'no')";
            
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(strSQL, cnn);
            com.ExecuteNonQuery();
            cnn.Close();

            this.id = id;
            this.ruta = rutaDest;
            return id + "_" + nombre;
        }

        public string almacenarBD(bool validado)
        {
            //Almacena solo en la BD
            string val = "no"; if (validado) { val = "no"; } 
            int id = maxID() + 1;

            string nombre = ruta.Substring(ruta.LastIndexOf(Path.DirectorySeparatorChar) + 1);
            string rutaFinal = Estatica.getRutaProyecto + "Archivos" + Path.DirectorySeparatorChar + id + "_" + nombre;

            string idNotic; if (publicac.getID() == -1) { idNotic = "NULL"; } else { idNotic = publicac.getID().ToString(); }
            string strSQL = "INSERT INTO Archivos VALUES (" + id + ", '" + rutaFinal + "', '" + subidoPor.getId() + "', " + idNotic + ", '"+val+"')";
            
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(strSQL, cnn);
            com.ExecuteNonQuery();
            cnn.Close();

            this.id = id;
            this.ruta = rutaFinal;
            return id + "_" + nombre;
        }

        public void eliminar()
        {
            File.Delete(ruta);

            string strSQL = "DELETE FROM ARCHIVOS WHERE ID = " + id;
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(strSQL, cnn);
            com.ExecuteNonQuery();
            cnn.Close();
        }

        private static List<Archivo> getArchivos()
        { //Asociados a cualquier publicacion

            string sentencia = "SELECT A.Id, A.Ruta, A.subidoPor, A.Publicacion FROM ARCHIVOS A JOIN Publicaciones N " +
                " ON (A.Publicacion = N.ID) AND N.ELIMINADA = 'no' AND A.Validado = 'si'";
            List<Archivo> lista = new List<Archivo>();
            
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                Archivo a = new Archivo(dr.GetInt32(0), dr.GetString(1), new Usuario(dr.GetString(2)),
                    new Publicacion(dr.GetInt32(3)), true);
                lista.Add(a);
            }
            dr.Close();
            cnn.Close();
            return lista;
        }

        public static Archivo getImagen()
        {
            List<Archivo> archs = getArchivos();
            if (archs.Count == 0)
            {
                return null;
            }
            else
            {
                Random rd = new Random();
                int i = rd.Next(archs.Count - 1);
                string nombre = archs[i].getRuta().Substring(archs[i].getRuta().LastIndexOf(Path.DirectorySeparatorChar) + 1);
                while ((archs.Count > 0 && !nombre.ToLower().EndsWith("jpg") && !nombre.Contains("_vp_")) ||
                    (archs.Count > 0 && !nombre.ToLower().EndsWith("jpeg") && !nombre.Contains("_vp_")) ||
                    (archs.Count > 0 && !nombre.ToLower().EndsWith("bmp") && !nombre.Contains("_vp_")) ||
                    (archs.Count > 0 && !nombre.ToLower().EndsWith("tiff") && !nombre.Contains("_vp_")) ||
                    (archs.Count > 0 && !nombre.ToLower().EndsWith("tif") && !nombre.Contains("_vp_")) ||
                    (archs.Count > 0 && !nombre.ToLower().EndsWith("gif") && !nombre.Contains("_vp_")) ||
                    (archs.Count > 0 && !nombre.ToLower().EndsWith("png") && !nombre.Contains("_vp_")))
                {
                    archs.Remove(archs[i]);
                    if (archs.Count == 0) { return null; } //Por si habia uno y al eliminar quedan cero, daria fallo en Next
                    i = rd.Next(archs.Count - 1);
                    nombre = archs[i].getRuta().Substring(archs[i].getRuta().LastIndexOf(Path.DirectorySeparatorChar) + 1);
                }
                if (archs.Count == 0) //Sale y no habia imagenes
                {
                    return null;
                }
                else //Devuelvo la imagen aleatoria
                {
                    return archs[i];
                }
            }
        }
       
        
    }
}