﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Collections.Generic;
using System.IO;
using System.Drawing;
using System.Drawing.Imaging;
using System.Data.SqlClient;

namespace DivulgacionCientifica.CapaNegocio
{
    public class Auxiliares
    {
        public static DateTime StringAFecha(string cad)
        {
            int ano = Int32.Parse(cad.Substring(1, 4));
            int mes;
            int dia;
            if (cad.Substring(7, 1).Equals("-")) //el mes tiene un digito
            {
                mes = Int32.Parse(cad.Substring(6, 1));
                if (cad.Substring(9, 1).Equals(" ")) //el dia tiene un digito
                {
                    dia = Int32.Parse(cad.Substring(8, 1));
                }
                else
                {
                    dia = Int32.Parse(cad.Substring(8, 2));
                }
            }
            else
            {
                mes = Int32.Parse(cad.Substring(6, 2));
                if (cad.Substring(10, 1).Equals(" ")) //el dia tiene un digito
                {
                    dia = Int32.Parse(cad.Substring(9, 1));
                }
                else
                {
                    dia = Int32.Parse(cad.Substring(9, 2));
                }
            }
            return new DateTime(ano, mes, dia);
        }

        /*
        public static string vistaPrevia(string cad, int maxLineas, int maxCaract)
        {
            cad = cad.Replace("<br>", "<br />");
            cad = cad.Replace("<BR>", "<br />");
            string prev = "";
            int numSaltosLineaPermitidos = maxLineas;
            while (cad != null && !cad.Equals("") && (numSaltosLineaPermitidos > 0))
            {
                if (cad.Contains("<br />"))
                {
                    prev += cad.Substring(0, cad.IndexOf("<br />")) + "<br />";
                    cad = cad.Substring(cad.IndexOf("<br />") + 6);
                    numSaltosLineaPermitidos--;
                }
                else
                {
                    numSaltosLineaPermitidos = 0; //para que salga del while
                    prev += cad;
                } 
            }

            if (cad != null)
            {
                if (prev.Length > maxCaract)
                {
                    string vp = prev.Substring(0, maxCaract);
                    //Debo tener en cuenta que puede ser html y puedo dejar una etiquetas abiertas
                    //lo que estropearia el html de mi pagina, por ello muestro en la vista previa
                    //los parrafos completos

                    if (!vp.ToLower().Contains("<p>")) //No se edito con el avanzado
                    {
                        vp = "<p>" + vp;
                    }
                    if (vp.ToLower().Contains("<p>") && (vp.ToLower().Contains("<a"))) //Se edito con el avanzado y puede
                    //tener un href abierto, lo quito
                    {
                        vp = vp.Substring(0, vp.LastIndexOf("<a"));
                    }
                    vp += " ..." + "</p>";
                    return vp;
                }
                else if (!cad.Equals(""))
                {
                    return prev + "...";
                }
                else
                {
                    if (!prev.ToLower().Contains("<p>"))
                    {
                        return "<p>" + prev + "</p>";
                    }
                    else
                    {
                        return prev;
                    }
                }
            }
            return prev;
        }
        */
        public static string vistaPreviaTextoPlano(string cad, int maxLineas, int maxCaracteres) //Para RSS
        {
            string prev = "";
            int numSaltosLineaPermitidos = maxLineas;
            while (cad != null && !cad.Equals("") && (numSaltosLineaPermitidos > 0))
            {
                if (cad.Contains("\r\n"))
                {
                    prev += cad.Substring(0, cad.IndexOf("\r\n")) + '\n';
                    cad = cad.Substring(cad.IndexOf("\r\n") + 2);
                    numSaltosLineaPermitidos--;
                }
                else
                {
                    numSaltosLineaPermitidos = 0; //para que salga del while
                    prev += cad;
                }
                
            }
            //Solo permito 5 saltos de linea, puede pasar tambien que a pesar de no haber saltos el texto
            //sea demasiado largo por lo que controlo ahora el numero de caracteres
            //Tanto si recorto lineas como si escribo solo 700 caracteres debo poner puntos suspensivos
            if (cad != null)
            {
                if (prev.Length > maxCaracteres)
                {
                    prev = prev.Substring(0, maxCaracteres) + " ...";
                }
                else if (!cad.Equals(""))
                {
                    prev = prev + "...";
                }
            }
            return prev;
        }

        public static string textoPlanoAHtml(string contenido)
        {
            return contenido.Replace('\n'.ToString(), "<br />");
        }

        public static string htmlATextoPlano(string contenido)
        {
            string sinCont = "";
            contenido = contenido.Replace("<br />", '\n'.ToString());
            contenido = contenido.Replace("<br>", '\n'.ToString());//Para que no me elimine los intros sino que los tome como \n
            while (contenido != null && !contenido.Equals(""))
            {
                if (contenido.StartsWith("<"))
                {
                    while (!contenido.StartsWith(">"))
                    {
                        contenido = contenido.Substring(1);
                    }
                }
                else
                {
                    sinCont += contenido.Substring(0, 1);
                }
                contenido = contenido.Substring(1);
            }
            return sinCont;
        }

        public static void cargarReferencias(Panel p, List<Referencia> refers)
        {
            p.Controls.Add(new LiteralControl("<div class=\"vprevia\" style=\"margin-right: 70px; margin-left: 70px;\">"));
            p.Controls.Add(new LiteralControl("<br />"));
            for (int i = 0; i < refers.Count; i++)
            {
                if (refers[i].getReferencia().StartsWith("http://"))
                {
                    HyperLink hp = new HyperLink();
                    hp.ID = "hp" + i;
                    hp.NavigateUrl = refers[i].getReferencia();
                    hp.Text = refers[i].getReferencia();
                    p.Controls.Add(new LiteralControl("[" + (i + 1) + "] "));
                    p.Controls.Add(hp);
                    p.Controls.Add(new LiteralControl("<br />"));
                }
                else
                {
                    p.Controls.Add(new LiteralControl("[" + (i + 1) + "] " + refers[i].getReferencia() + "<br />"));
                }
            }
            p.Controls.Add(new LiteralControl("</div>"));
        }

        public static void cargarArchivos(Panel p, List<Archivo> archs)
        {
            p.Controls.Add(new LiteralControl("<div style=\"text-align: center;\">"));
            foreach (Archivo arch in archs)
            {
                string nombre = arch.getRuta().Substring(arch.getRuta().LastIndexOf(Path.DirectorySeparatorChar) + 1);

                if (arch.getRuta().ToLower().EndsWith(".jpg") || arch.getRuta().ToLower().EndsWith(".jpeg") ||
                        arch.getRuta().ToLower().EndsWith(".bmp") || arch.getRuta().ToLower().EndsWith(".gif") ||
                        arch.getRuta().ToLower().EndsWith(".png") || arch.getRuta().ToLower().EndsWith(".tiff") ||
                        arch.getRuta().ToLower().EndsWith(".tif"))
                {
                    p.Controls.Add(new LiteralControl("<a href=\"" + Estatica.getUrlProyecto + "Archivos/" +
                        nombre + "\" rel=\"lightbox[roadtrip1]\">"));
                    p.Controls.Add(new LiteralControl("<img src=\"" + Estatica.getUrlProyecto + "Archivos/" +
                        nombre + "\" width=\"100\" height=\"100\" />"));
                    p.Controls.Add(new LiteralControl("</a>&nbsp;&nbsp;&nbsp;&nbsp;"));
                }
            }
            p.Controls.Add(new LiteralControl("</div>"));
            p.Controls.Add(new LiteralControl("<div style=\"text-align: center;\">"));
            //Hago dos barridos para sacar primero todas las imagenes y luego el resto
            foreach (Archivo arch in archs)
            {
                string nombre = arch.getRuta().Substring(arch.getRuta().LastIndexOf(Path.DirectorySeparatorChar) + 1);
                if (arch.getRuta().ToLower().EndsWith(".wmv") || arch.getRuta().ToLower().EndsWith(".avi") ||
                    arch.getRuta().ToLower().EndsWith(".mpg") || arch.getRuta().ToLower().EndsWith(".mpeg") ||
                    arch.getRuta().ToLower().EndsWith(".mov"))
                {
                    p.Controls.Add(new LiteralControl("<embed src=\"" + Estatica.getUrlProyecto + "Archivos/" + nombre + "\"" +
                        " autostart=\"false\" loop=\"false\" height=\"350\" width=\"550\" align=\"middle\">"));
                    p.Controls.Add(new LiteralControl("<noembed>Tu navegador no soporta el contenido multimedia</noembed>"));
                    p.Controls.Add(new LiteralControl("</embed><br />"));
                }
                else if (arch.getRuta().ToLower().EndsWith(".mid") || arch.getRuta().ToLower().EndsWith(".mp3") ||
                arch.getRuta().ToLower().EndsWith(".midi"))
                {
                    string src = "<embed src=\"" + Estatica.getUrlProyecto + "Archivos/" + nombre + "\"" +
                        " autostart=\"false\" loop=\"false\" height=\"25\" width=\"550\" align=\"middle\">";
                    p.Controls.Add(new LiteralControl(src));
                    p.Controls.Add(new LiteralControl("<noembed>Tu navegador no soporta el contenido multimedia</noembed>"));
                    p.Controls.Add(new LiteralControl("</embed><br />"));
                }
            }
            p.Controls.Add(new LiteralControl("</div>"));
        }

        public static bool soloNumeros(string cad)
        {
            if (cad.Equals(""))
            {
                return true;
            }
            else
            {
                bool soloNum = true;
                while (cad != null && !cad.Equals("") && soloNum)
                {
                    if (cad[0] == '0' || cad[0] == '1' || cad[0] == '2' || cad[0] == '3' || cad[0] == '4' ||
                        cad[0] == '5' || cad[0] == '6' || cad[0] == '7' || cad[0] == '8' || cad[0] == '9' || cad[0] == ' ')
                    {
                        cad = cad.Substring(1);
                    }
                    else
                    {
                        soloNum = false;
                    }
                }
                return soloNum;
            }
        }

        //Guarda la imagen origen en destino reducida hasta el tamaño width height
        public static void redimensionar(string origen, string destino, int width, int height)
        {
                System.Drawing.Image image1 = new System.Drawing.Bitmap(origen);
                int destinoWidth = image1.Width;
                int destinoHeight = image1.Height;
                while ((destinoWidth > width) || (destinoHeight > height))
                {
                    //Las redimensiono un tanto por ciento para no perder las proporciones
                    destinoWidth = destinoWidth * 80 / 100;
                    destinoHeight = destinoHeight * 80 / 100;
                }

                Bitmap Imagen2 = new Bitmap(destinoWidth, destinoHeight);
                using (Graphics g = Graphics.FromImage((System.Drawing.Image)Imagen2))
                {
                    g.DrawImage(image1, 0, 0, destinoWidth, destinoHeight);
                }
                Imagen2.Save(destino);
                Imagen2.Dispose();
                image1.Dispose();
        }

        public static bool EmailCorrecto(string email)
        {
            /* Podria hacerlo mejor */
            if (!email.Equals("") && email.Contains("@")
                && email.Contains("."))
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        public static void cargarUsuarios(DropDownList l)
        {
            String sentencia = "SELECT Nombre + ' ' + Apellidos FROM Usuarios WHERE Eliminado = 'no' AND VALIDADO = 'si'";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                l.Items.Add(dr.GetString(0));
            }
            dr.Close();
            cnn.Close();
        }

        public static void cargarUsuarios(DropDownList l, string filtro)
        {
            String sentencia = "SELECT Nombre + ' ' + Apellidos FROM Usuarios WHERE Eliminado = 'no' AND VALIDADO = 'si' and Nombre + ' ' + Apellidos LIKE '%" + filtro + "%' ";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                l.Items.Add(dr.GetString(0));
            }
            dr.Close();
            cnn.Close();
        }

        public static void cargarTemas(ListBox l)
        {
            String sentencia = "SELECT nombre FROM Temas WHERE Eliminado = 'no'";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                l.Items.Add(dr.GetString(0));
            }
            dr.Close();
            cnn.Close();
        }

        /*
        public static void cargarTemas1(DropDownList l, string filtro)
        {
            OdbcConnection cnn = new OdbcConnection(Estatica.getConnectionBD);
            String sentencia = "SELECT nombre FROM Temas WHERE Eliminado = 'no' and Nombre LIKE '%" + filtro + "%' ";
            OdbcCommand com = new OdbcCommand(sentencia, cnn);

            cnn.Open();
            OdbcDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                l.Items.Add(dr.GetString(0));
            }
            dr.Close();
            cnn.Close();
        }
        */

        public static void cargarTemas(DropDownList l)
        {
            String sentencia = "SELECT nombre FROM Temas WHERE Eliminado = 'no'";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                l.Items.Add(dr.GetString(0));
            }
            dr.Close();
            cnn.Close();

        }

    }
}
