﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using DivulgacionCientifica.CapaNegocio;

namespace DivulgacionCientifica.CapaNegocio
{
    public class Comentario
    {
        private int id;
        private string descripcion;
        private Usuario creador;
        private Publicacion pub;
        private bool revisada;
        private bool eliminada;
        private DateTime fecha;

        public Comentario(int id)
        {
            this.id = id;
        }

        public Comentario(string descr, Usuario cread, Publicacion publicac)
        {
            descripcion = descr;
            creador = cread;
            pub = publicac;
            revisada = false;
            eliminada = false;
        }

        public Comentario(int id, string desc, Usuario cread, Publicacion publicac,
            bool revisada, bool elim, DateTime fecha)
        {
            this.id = id;
            this.descripcion = desc;
            this.creador = cread;
            this.pub = publicac;
            this.revisada = revisada;
            this.eliminada = elim;
            this.fecha = fecha;
        }

        public int getID() { return id; }

        public string getDescripcion() { return descripcion; }

        public Usuario getCreador() { return creador; }

        public Publicacion getPublicacion() { return pub; }

        public bool getRevisada() { return revisada; }

        public bool getEliminada() { return eliminada; }

        public DateTime getFecha() { return fecha; }

        public void almacenar()
        {
            int id = maxId() + 1;
            string strSQL = "INSERT INTO Comentarios VALUES (" + id + ", '" + this.descripcion + "', '" + this.creador.getId()
                        + "', " + this.pub.getID() + ", 'no', 'no', GETDATE())";

            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(strSQL, cnn);
            com.ExecuteNonQuery();
            cnn.Close();
        }

        private int maxId()
        {
            Int32 newId = 0;
            string sql = "SELECT * FROM Comentarios";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sql, cnn);
            SqlDataReader dr = com.ExecuteReader();
            bool hayDatos;
            if (dr.Read()) //Hay noticias almacenadas
            {
                hayDatos = true;
            }
            else
            {
                hayDatos = false;
            }
            cnn.Close();

            if (hayDatos)
            {
                string sql2 = "SELECT MAX(ID) FROM Comentarios";
                SqlConnection cnn2 = new SqlConnection();
                cnn2.ConnectionString = Estatica.getConnectionBD;
                cnn2.Open();
                SqlCommand com2 = new SqlCommand(sql2, cnn2);
                newId = (Int32)com2.ExecuteScalar();
                cnn2.Close();
            }

            return newId;
        }

        public static long numComentariosSinLeer(Usuario usu)
        {
            
            Int32 newId = 0;
            string sql = "SELECT COUNT(n.ID) FROM Publicaciones n join usuarios u on (n.creador = u.id) "+
                "join Comentarios o on (o.publicacion = n.id) WHERE n.Creador = '" + usu.getId() + 
                "' AND Revisada = 'no' AND o.Eliminada = 'no'";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sql, cnn);
            SqlDataReader dr = com.ExecuteReader();
            bool hayDatos;
            if (dr.Read())
            {
                hayDatos = true;
            }
            else
            {
                hayDatos = false;
            }
            cnn.Close();

            if (hayDatos)
            {
                SqlConnection cnn2 = new SqlConnection();
                cnn2.ConnectionString = Estatica.getConnectionBD;
                cnn2.Open();
                SqlCommand com2 = new SqlCommand(sql, cnn2);
                newId = (Int32)com2.ExecuteScalar();
                cnn2.Close();
            }
            return (int) newId;
        }

        public static List<Comentario> getComentarios(Publicacion publicac, Usuario usu)
        {
            //Probar
            List<Comentario> coments = new List<Comentario>();
            string sentencia = "SELECT * FROM Comentarios c join Publicaciones n on (c.Publicacion = n.id) join usuarios u "+
                "on (n.creador = u.id) WHERE n.Creador = '" + usu.getId() + "' AND n.ID = "+publicac.getID() + " AND c.Eliminada = 'no' ORDER BY FECHA DESC";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                bool rev = false; if (dr.GetString(4).Equals("si")) { rev = true; }
                bool elim = false; if (dr.GetString(5).Equals("si")) { elim = true; }
                Comentario c = new Comentario(dr.GetInt32(0), dr.GetString(1), new Usuario(dr.GetString(2)), new Publicacion(dr.GetInt32(3)),
                    rev, elim, dr.GetDateTime(6));
                coments.Add(c);
            }
            dr.Close();
            cnn.Close();
            return coments;
        }

        public void eliminar()
        {
            string sentencia = "UPDATE COMENTARIOS SET ELIMINADA = 'si' WHERE ID = "+id;
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            com.ExecuteNonQuery();
            cnn.Close();
        }

        public void marcarRevisado()
        {
            string sentencia = "UPDATE COMENTARIOS SET REVISADA = 'si' WHERE ID = " + id;
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            com.ExecuteNonQuery();
            cnn.Close();
        }
    }
}
