﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Data.SqlClient;
using System.Collections.Generic;

namespace DivulgacionCientifica.CapaNegocio
{
    /* Cuando el usuario crea una noticia se crea un
     * objeto de la clase Noticia con el campo Validada = 'no' (y se almacena junto a sus
     * temas, referencias, ...)
     * El administrador recibirá un aviso de que la Noticia ha sido publicada y en caso
     * de que éste la valide será visible y 
     * se enviará un email al creador
     * indicandole que su noticia ha sido publicada, en otro caso se envía un email
     * informandole de la denegación de la publicación (y se elimina la noticia fisicamente
     * de la tabla Noticia.
     * TipoModif = {Editar, Eliminar}
     */

    /*Cuando se solicita una modificación, se crea un objeto de la clase
     * PeticionNoticia (y se almacena). Si ya existía una petición sobre una noticia, ésta
     * última petición machacará la anterior. No se pueden modificar los temas asociados, 
     * el contenido multimedia ni las referencias.
     */

    /*Los borrados de noticias ¿se deben solicitar? ¿o el creador las puede eliminar sin
     * consultar?. Sin solicitar!!!
     */

    public class EditPublic
    {
        private int id;
        private string titulo;
        private string contenido;
        private string categoria;
        private string caducidad;
        private string motivo;
        private DateTime fechaSolic;

        public EditPublic(int id, string titulo, string contenido, string categ,
            string caducidad, string motivo, DateTime fechaSolic)
        {
            this.id = id;
            this.titulo = titulo;
            this.contenido = contenido;
            this.categoria = categ;
            this.caducidad = caducidad;
            this.motivo = motivo;
            this.fechaSolic = fechaSolic;
        }

        public EditPublic(int id)
        {
            this.id = id;
            String sentencia = "SELECT * FROM ModifPublicaciones WHERE ID = " + id;
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();
            if (dr.Read())
            {
                this.titulo = dr.GetString(1);
                this.contenido = dr.GetString(2);
                this.categoria = dr.GetString(3);
                if (!dr.IsDBNull(4)) { this.caducidad = dr.GetDateTime(4).ToString(); } else { this.caducidad = "No tiene."; }
                this.motivo = dr.GetString(5);
                this.fechaSolic = dr.GetDateTime(6);
            }
            dr.Close();
            cnn.Close();
        }

        public int getID() { return id; }
        public string getTitulo() { return titulo; }
        public string getContenido() { return contenido; }
        public string getCategoria() { return categoria; }
        public string getCaducidad() { return caducidad; }
        public string getMotivo() { return motivo; }
        public DateTime getFechaSolic() { return fechaSolic; }

        public void almacenar()
        {
            eliminar(); //Por si anteriormente habia solicitada una
            //La ' da error al ser insertada en la BD pq corrompe la sentencia sql por lo que la sustituyo por \' y asi se toma literalmente 
            string strSQL = "INSERT INTO ModifPublicaciones VALUES (" + id + ", '" + titulo + "', '"+
                contenido.Replace('\''.ToString(), "\\\'") + "', '"+categoria+"', "+caducidad+", '"+ motivo + "', GETDATE())";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(strSQL, cnn);
            com.ExecuteNonQuery();
            cnn.Close();
        }

        public void eliminar()
        {
            string strSQL = "DELETE FROM ModifPublicaciones WHERE id = " + id;
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(strSQL, cnn);
            com.ExecuteNonQuery();
            cnn.Close();
        }
        
        public static List<EditPublic> getPeticionesPublic()
        {
            List<EditPublic> lista = new List<EditPublic>();
            String sentencia = "SELECT * FROM ModifPublicaciones ORDER BY FechaAccion";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                string fechaCad;
                if (!dr.IsDBNull(4)) { fechaCad = dr.GetDateTime(4).ToString(); }
                else { fechaCad = "NULL"; }
                EditPublic mn = new EditPublic(dr.GetInt32(0), dr.GetString(1), dr.GetString(2), dr.GetString(3),
                    fechaCad, dr.GetString(5), dr.GetDateTime(6));
                lista.Add(mn);
            }
            dr.Close();
            cnn.Close();
            return lista;
        }

        public List<Referencia> getReferenciasNoValidadas()
        {
            List<Referencia> lista = new List<Referencia>();

            string sentencia = "SELECT * FROM REFERENCIAS WHERE Publicacion = " + id + " AND VALIDADA = 'no'";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                bool valid = true;
                if (dr.GetString(3).Equals("no")) { valid = false; }
                Referencia r = new Referencia(dr.GetInt32(0), new Publicacion(dr.GetInt32(1)), dr.GetString(2), valid);
                lista.Add(r);
            }
            dr.Close();
            cnn.Close();

            return lista;
        }

        public List<Archivo> archivosNoValidados()
        {
            List<Archivo> lista = new List<Archivo>();

            string sentencia = "SELECT ID FROM ARCHIVOS WHERE Publicacion = " + id + " AND VALIDADO = 'no'";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                Archivo a = new Archivo(dr.GetInt32(0));
                lista.Add(a);
            }
            dr.Close();
            cnn.Close();

            return lista;
        }

    }
}
