﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Collections.Generic;
using System.Data.SqlClient;

namespace DivulgacionCientifica.CapaNegocio
{
    /*Cuando un usuario se registra se crea un objeto de la clase Usuario y se inserta en
     * la BD con el campo Validado = 'no'. Cuando el administrador lo valida le llega un
     * correo informándole de que ha sido dado de alta.
     * Si no lo valida se elimina físicamente de la BD
     */

    /*Si un usuario desea modificar sus datos se crea el objeto de la clase ModifUsuario
     * y se almacena en ModifUsuarios, cuando el admin lo valida se le informa mediante un
     * email de que han sido modificados sus datos y si no se le informa de la denegación.
     * En ambos casos se elimina físicamente de la base de datos la petición.
     */

    /*Si el usuario desea darse de baja no tiene que "pedir permiso" mediante un objeto de
     * este tipo sino que simplemente se elimina*/


    public class ModifUsuario
    { 
        private string id;
        private string nombre;
        private string apellidos;
        private string email;
        private Pais pais;
        private string sexo;
        private string ocupacion;
        private string telefono1;
        private string telefono2;
        private string observaciones;
        private DateTime fechaModif;

        public ModifUsuario(string id, string nom, string apell, string email, 
            Pais pais, string sex, string ocup, string tlf1, string tlf2, string observ)
        {
            this.id = id;
            nombre = nom;
            apellidos = apell;
            this.email = email;
            this.pais = pais;
            sexo = sex;
            ocupacion = ocup;
            telefono1 = tlf1;
            telefono2 = tlf2;
            observaciones = observ;
        }

        
        public ModifUsuario(string id, string nom, string apell, string email,
            Pais pais, string sex, string ocup, string tlf1, string tlf2, string observ,
            DateTime fecha) //Para cuando lo obtengo de la BD
        {
            this.id = id;
            nombre = nom;
            apellidos = apell;
            this.email = email;
            this.pais = pais;
            sexo = sex;
            ocupacion = ocup;
            telefono1 = tlf1;
            telefono2 = tlf2;
            observaciones = observ;
            fechaModif = fecha;
        }
        
        public ModifUsuario(string id)
        {
            this.id = id;
            
            String sentencia = "SELECT * FROM ModifUsuarios WHERE (ID = '" + id + "')";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();
            
            if (dr.Read())
            {
                id = dr.GetString(0);
                this.nombre = dr.GetString(1);
                this.apellidos = dr.GetString(2);
                this.email = dr.GetString(3);
                this.pais = new Pais(dr.GetString(4));
                this.sexo = dr.GetString(5);
                ocupacion = dr.GetString(6);
                telefono1 = dr.GetString(7);
                telefono2 = dr.GetString(8);
                observaciones = dr.GetString(9);
                fechaModif = dr.GetDateTime(10);
 
            }
            else
            {
                this.id = "";
            }
            dr.Close();
            cnn.Close();
        }

        public string getId() { return id; }
        public string getNombre() { return nombre; }
        public string getApellidos() { return apellidos; }
        public string getEmail() { return email; }
        public Pais getPais() { return pais; }
        public string getSexo() { return sexo; }
        public string getOcupacion() { return ocupacion; }
        public string getTelefono1() { return telefono1; }
        public string getTelefono2() { return telefono2; }
        public string getObservaciones() { return observaciones; }
        public DateTime getFechaModif() { return fechaModif; }

        public void almacenar()
        {
            eliminar();
            string strSQL = "INSERT INTO ModifUsuarios VALUES ('" + id + "', '" + nombre + "', '" +
                  apellidos + "', '" + email + "', '" + pais.getNombre() + "', '" + sexo + "', '" + ocupacion + "', '" +
                  telefono1 + "', '" + telefono2 + "', '" + observaciones + "', GETDATE())";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(strSQL, cnn);
            com.ExecuteNonQuery();
            cnn.Close();    
        }

        public void eliminar()
        {
            string strSQL = "Delete from ModifUsuarios where id = '" + id + "'";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(strSQL, cnn);
            com.ExecuteNonQuery();
            cnn.Close();    
        }

        public static List<ModifUsuario> getPeticionesUsuario()
        {
            List<ModifUsuario> lista = new List<ModifUsuario>();
            String sentencia = "SELECT * FROM ModifUsuarios";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                ModifUsuario mod = new ModifUsuario(dr.GetString(0), dr.GetString(1), dr.GetString(2),
                    dr.GetString(3), new Pais(dr.GetString(4)), dr.GetString(5), dr.GetString(6), dr.GetString(7),
                    dr.GetString(8), dr.GetString(9), dr.GetDateTime(10));
                lista.Add(mod);
            }
            dr.Close();
            cnn.Close();
            return lista;
        }
        
    }
}
