﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Data.SqlClient;
using System.IO;
using System.CodeDom.Compiler;
using System.Reflection;
using System.Collections.Generic;


namespace DivulgacionCientifica.CapaNegocio
{
    public class Publicacion
    {
        
        private int id;
        private Usuario creador;
        private string contenido;
        private List<Tema> temas;
        private string titulo;
        private DateTime fechaCreacion;
        private string categoria;
        private bool eliminada;
        private int importancia;
        private string caducidad;
        private bool validada;

        public Publicacion(string idCread, string contenido, List<Tema> temas,
            string titulo, string categoria, string caduc)
        {
            creador = new Usuario(idCread);
            this.contenido = contenido;
            this.temas = temas;
            this.titulo = titulo;
            this.eliminada = false;
            this.categoria = categoria;
            this.importancia = 0;
            caducidad = caduc;
            this.validada = false;
        }

        public Publicacion(int id)
        {
            String sentencia = "SELECT * FROM Publicaciones WHERE id = " + id + " AND Eliminada = 'no'";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();
            if (dr.Read())
            {
                this.id = id;
                this.creador = new Usuario(dr.GetString(1));
                this.contenido = dr.GetString(2);
                this.temas = getTemasBD();
                this.fechaCreacion = dr.GetDateTime(3);
                this.titulo = dr.GetString(5);

                if (dr.GetString(4).Equals("si"))
                {
                    this.eliminada = true;
                }
                else
                {
                    this.eliminada = false;
                }
                this.categoria = dr.GetString(6);
                this.importancia = dr.GetInt32(7);
                if (dr.IsDBNull(8)) { this.caducidad = "NULL"; }
                else {
                    DateTime fecha = dr.GetDateTime(8);
                    this.caducidad = "'" + fecha.Year.ToString() + "-" + fecha.Month.ToString() + "-" +
                        fecha.Day.ToString() + " " + fecha.Hour.ToString() +
                        ":" + fecha.Minute.ToString() + ":" + fecha.Second.ToString() + "'";
                }
                
                if (dr.GetString(9).Equals("si")) { validada = true; } else { validada = false; }
            }
            dr.Close();
            cnn.Close();
        }

        public int getID()
        {
            return id;

        }

        public Usuario getCreador(){return creador;}

        public string getContenido(){return contenido;}

        public List<Tema> getTemas(){ return temas; }

        public DateTime getFechaCreacion(){return fechaCreacion;}

        public string getTitulo(){return titulo;}

        public List<Tema> getTemasBD()
        {
            List<Tema> temas = new List<Tema>();

            String sentencia = "SELECT * FROM PublicacionesTemas WHERE Publicacion = " + id;
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                Tema t = new Tema(dr.GetString(1), "");
                temas.Add(t);
            }
            dr.Close();
            cnn.Close();

            return temas;
        }

        public string getCategoria() { return categoria; }

        public int getImportancia() { return importancia; }

        public string getCaducidad() { return caducidad; }

        public bool getValidada() { return validada; }

        public bool getEliminada() { return eliminada; }

        public void almacenarPublic()
        {
            int id = maxId() + 1;
            this.id = id;
            string eli; if (eliminada) { eli = "si"; } else { eli = "no"; }
            string val; if (validada) { val = "si"; } else { val = "no"; }
            string fechaBD; if (caducidad.Equals("NULL")) { fechaBD = "NULL"; }
            else { fechaBD = caducidad; }

            //La ' da error al ser insertada en la BD pq corrompe la sentencia sql por lo que la sustituyo por \' y asi se toma literalmente 
            string strSQL = "INSERT INTO Publicaciones VALUES (" + id + ", '" + this.creador.getId() + "', '"
                + this.contenido.Replace('\''.ToString(),"\\\'") + "', GETDATE(), '"+eli+"', '" + 
                this.titulo + "', '"+categoria+"', "+importancia+", "+fechaBD+", '"+val+"')";

            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(strSQL, cnn);
            com.ExecuteNonQuery();
            cnn.Close();

            almacenarTemasRelacionados();

        }

        public void almacenarTemasRelacionados()
        {
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            foreach (Tema tema in this.temas)
            {
                string strSQL = "INSERT INTO PublicacionesTemas VALUES (" + id + ", '" + tema.getNombre() + "')";
                SqlCommand com = new SqlCommand(strSQL, cnn);
                cnn.Open();
                com.ExecuteNonQuery();
                cnn.Close();
            }
        }

        public void eliminarPublicFisico()
        {
            //Elimino los archivos asociados a esta noticia
            eliminarArchivos(); //Si no eliminara los archivos de la base de datos aqui
            //Se eliminarian con la sentencia de abajo ya que la clave foranea esta declarada ON DELETE CASCADE

            string sentenciaSQL = "DELETE FROM Publicaciones WHERE (ID = '" + id + "')";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentenciaSQL, cnn);
            com.ExecuteNonQuery();
            cnn.Close();
            eliminarDeLosFeeds();
        }

        public void eliminarArchivos()
        {
            List<Archivo> archs = getArchivos(false);

            foreach (Archivo arch in archs)
            {
                if (File.Exists(arch.getRuta()))
                    File.Delete(arch.getRuta());
            }

            string strSQL = "DELETE FROM ARCHIVOS WHERE Publicacion = " + id;
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(strSQL, cnn);
            com.ExecuteNonQuery();
            cnn.Close();
        }

        public void añadirALosFeeds()
        {
            foreach (Tema tema in temas)
            {
                añadirAUnFeed(tema.getNombre());
            }
        }

        private void añadirAUnFeed(string tema)
        {
            string rutaIn = Estatica.getRutaProyecto + "feedsRSS" + Path.DirectorySeparatorChar + tema + ".xml";
            string rutaOut = Estatica.getRutaProyecto + "feedsRSS" + Path.DirectorySeparatorChar + tema + "Aux.xml";
            string urlPublic = Estatica.getUrlProyecto+ "VisualizarPublicacion.aspx?id=" + id;

            FileStream fichIn = new FileStream(rutaIn, FileMode.Open);
            FileStream fichOut = new FileStream(rutaOut, FileMode.Create);
            StreamReader srRd = new StreamReader(fichIn);
            StreamWriter srWr = new StreamWriter(fichOut, System.Text.Encoding.UTF8);

            string cad = srRd.ReadLine();
            while (!cad.Equals("<language>es-ES</language>"))
            {
                srWr.WriteLine(cad);
                cad = srRd.ReadLine();
            }
            srWr.WriteLine("<language>es-ES</language>"); //La escribo pq se borraba
            srWr.WriteLine("");
            srWr.WriteLine("<item><title>" + titulo + "</title><link>" + urlPublic + "</link>");
            srWr.WriteLine("<description>");
            srWr.WriteLine(Auxiliares.vistaPreviaTextoPlano(Auxiliares.htmlATextoPlano(contenido), 5, 900));
            srWr.WriteLine("</description>");
            srWr.WriteLine("</item>");


            cad = srRd.ReadToEnd();
            srWr.Write(cad);

            srRd.Close();
            srWr.Close();

            File.Delete(rutaIn);
            File.Copy(rutaOut, rutaIn);
            File.Delete(rutaOut);

            fichIn.Close();
            fichOut.Close();

        }

        public void eliminarDeLosFeeds()
        {
            foreach (Tema tema in temas)
            {
                eliminarDeUnFeed(tema.getNombre());
            }
        }

        private void eliminarDeUnFeed(string tema)
        {
            
            string rutaIn = Estatica.getRutaProyecto + "feedsRSS" + Path.DirectorySeparatorChar + tema + ".xml";
            string rutaOut = Estatica.getRutaProyecto + "feedsRSS" + Path.DirectorySeparatorChar + tema + "Aux.xml";

            if (File.Exists(rutaIn))
            {
                FileStream fichIn = new FileStream(rutaIn, FileMode.Open);
                FileStream fichOut = new FileStream(rutaOut, FileMode.Create);
                StreamReader srRd = new StreamReader(fichIn);
                StreamWriter srWr = new StreamWriter(fichOut);

                string cad = srRd.ReadLine();
                while ((cad != null) && (!cad.Contains("<link>" + Estatica.getUrlProyecto + "VisualizarPublicacion.aspx?id=" + id + "</link>")))
                {
                    srWr.WriteLine(cad);
                    cad = srRd.ReadLine();
                }

                //Si se ejecuta el cuerpo es que la encontre
                while (((cad != null) && (!cad.Equals("</item>")))) //La linea anterior a "" es </item> pongo "" para que elimine tambien esta
                {
                    //Leo hasta el final del item sin escribir en el de salida
                    cad = srRd.ReadLine();
                }
                cad = srRd.ReadLine();//Leo una nueva linea pq tampoco quiero que escriba </item> que es con la que salio del bucle

                cad = srRd.ReadToEnd();
                srWr.Write(cad);

                srRd.Close();
                srWr.Close();

                File.Delete(rutaIn);
                File.Copy(rutaOut, rutaIn);
                File.Delete(rutaOut);

                fichIn.Close();
            }
            

        }

        private static int maxId()
        {
            Int32 newId = 0;
            string sql = "SELECT * FROM Publicaciones";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sql, cnn);
            SqlDataReader dr = com.ExecuteReader();
            bool hayDatos;
            if (dr.Read()) //Hay Publicaciones almacenadas
            {
                hayDatos = true;
            }
            else
            {
                hayDatos = false;
            }
            cnn.Close();

            if (hayDatos)
            {
                string sql2 = "SELECT MAX(ID) FROM Publicaciones";
                SqlConnection cnn2 = new SqlConnection();
                cnn2.ConnectionString = Estatica.getConnectionBD;
                cnn2.Open();
                SqlCommand com2 = new SqlCommand(sql2, cnn2);
                newId = (Int32)com2.ExecuteScalar();
                cnn2.Close();
            }

            return newId;
        }

        public bool tieneComentarios()
        {
            string sql = "SELECT * FROM Comentarios WHERE publicacion = " + id + " AND eliminada = 'no'";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sql, cnn);
            SqlDataReader dr = com.ExecuteReader();
            bool hayDatos;
            if (dr.Read()) //Hay Publicaciones almacenadas
            {
                hayDatos = true;
            }
            else
            {
                hayDatos = false;
            }
            cnn.Close();
            return hayDatos;
        }

        public long numComentariosNoLeidas()
        {
            if (tieneComentarios())
            {
                Int32 num;
                string sql2 = "SELECT COUNT(ID) FROM Comentarios  WHERE publicacion = " + id +
                    " AND Revisada = 'no'";
                SqlConnection cnn2 = new SqlConnection();
                cnn2.ConnectionString = Estatica.getConnectionBD;
                cnn2.Open();
                SqlCommand com2 = new SqlCommand(sql2, cnn2);
                num = (Int32)com2.ExecuteScalar();
                cnn2.Close();
                return num;
            }
            else
            {
                return 0;
            }
        }

        public void eliminarPublicLogico() 
        {
            //Si hay una modificacion sobre esta noticia la elimino
            EditPublic modif = new EditPublic(id);
            modif.eliminar();

            string sentenciaSQL = "UPDATE Publicaciones SET Eliminada = 'si' WHERE (ID = '" + id + "')";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentenciaSQL, cnn);
            com.ExecuteNonQuery();
            cnn.Close();

            eliminarDeLosFeeds();
        }

        //para ListarPublicaciones
        public static int numPaginas(string nombreTema, string autor, string contenido,
            string categoria, int numNotPag)
        {
            string clausulaTema = "";
            if (nombreTema.Equals("Todos")) { } else { clausulaTema = "JOIN PublicacionesTemas pt ON (pt.Tema = '" + nombreTema + "')"; }

            string clausulaContenido = "";
            //Si el contenido tiene espacios hago un like para cada palabra
            if ((contenido == null) || (contenido.Equals(""))) { }
            else
            {
                char[] separador = new char[1]; separador[0] = ' ';
                string[] palabras = contenido.Split(separador);
                clausulaContenido = "AND (";
                for (int i = 0; i < palabras.Length; i++)
                {
                    clausulaContenido += "CONTENIDO LIKE '%" + palabras[i] + "%' OR ";
                }
                //Ahora le debo quitar el ultimo OR y el espacio
                clausulaContenido = clausulaContenido.Substring(0, clausulaContenido.Length - 4);
                clausulaContenido += ")";
            }

            string clausulaCategoria = "";
            if (categoria.Equals("Todas")) { } else { clausulaCategoria = "AND N.Categoria = '" + categoria + "'"; }

            string sentencia;
            if (autor.Equals("Todos") && nombreTema.Equals("Todos"))
            {
                sentencia = "SELECT n.id FROM Publicaciones n WHERE n.Eliminada = 'no' "
                    + clausulaContenido + " " + clausulaCategoria + " AND VALIDADA = 'si' ORDER BY fechacreacion desc";
            }
            else if (autor.Equals("Todos") && !nombreTema.Equals("Todos"))
            {
                clausulaTema = " AND nt.tema = '" + nombreTema + "'";
                sentencia = "SELECT n.id FROM Publicaciones n JOIN PublicacionesTemas NT ON (NT.Publicacion = N.ID) "
                    +" WHERE N.Eliminada = 'no' " + clausulaTema + " " + clausulaContenido + " " + clausulaCategoria +
                    " AND VALIDADA = 'si' ORDER BY fechacreacion desc";
            }
            else if (!autor.Equals("Todos") && nombreTema.Equals("Todos"))
            {
                sentencia = "SELECT n.id FROM Publicaciones n JOIN Usuarios u ON (n.Creador = u.ID) " +
                    "WHERE (u.Nombre + ' ' + u.Apellidos) = '" + autor + "' AND n.Eliminada = 'no' "
                    + clausulaContenido + " " + clausulaCategoria + " AND VALIDADA = 'si' ORDER BY n.fechacreacion desc";
            }
            else // !autor.Equals("Todos") && !tema.Equals("Todos")
            {
                clausulaTema = " AND nt.tema = '" + nombreTema + "'";
                sentencia = "SELECT n.id FROM Publicaciones n JOIN Usuarios u ON (n.Creador = u.ID) JOIN PublicacionesTemas NT ON (NT.Publicacion = N.ID) " +
                    " WHERE (u.Nombre + ' ' + u.Apellidos) = '" + autor + "' AND n.Eliminada = 'no' " + clausulaTema +
                    " " + clausulaContenido + " " + clausulaCategoria + " AND VALIDADA = 'si' ORDER BY n.fechacreacion desc";
            }
            List<Publicacion> lista = new List<Publicacion>();
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                Publicacion not = new Publicacion(dr.GetInt32(0));
                if (!not.caducada())
                {
                    lista.Add(not);
                }
            }
            dr.Close();
            cnn.Close();

            Int32 numPubs = lista.Count;
            int numeroPubsPagina = numNotPag;
            Int32 numPaginas = (Int32)numPubs / numeroPubsPagina;
            //Si numNoticias < numNoticiasPagina => numPaginas es cero y daria error de division por cero al calcular el modulo
            if (numPubs < numeroPubsPagina)
            {
                numPaginas = 1;
            }
            else
            {
                if ((numPubs % numNotPag) != 0)
                {
                    numPaginas++;
                }
            }
            return numPaginas;
        }
 
        //para MisPublicaciones
        public static int numPaginas(string nombreTema, string idUsu, int numNotPag, string todas)
        {
            string clausulaTema = "";
            string clausulaTema2 = "";
            if (nombreTema.Equals("Todos")) { }
            else
            {
                clausulaTema = "JOIN PublicacionesTemas pt ON (pt.publicacion = n.id)";
                clausulaTema2 = " and pt.tema = '" + nombreTema + "' ";
            }

            string sentencia;
            if ((todas == null) || (todas.Equals("si")))
            {
                sentencia = "SELECT n.id FROM Publicaciones n " +clausulaTema + " WHERE n.Eliminada = 'no' "
                    + " AND VALIDADA = 'si' AND n.creador = '" + idUsu + "' " + clausulaTema2
                    + "ORDER BY fechacreacion desc";
            }
            else
            {
                sentencia = "SELECT n.id FROM Publicaciones n JOIN Comentarios c ON (c.publicacion = n.id) "+ clausulaTema +
                    " WHERE c.revisada = 'no' AND n.Eliminada = 'no'" + clausulaTema2 + "AND n.VALIDADA = 'si' AND n.creador = '" + idUsu
                    + "' ORDER BY fechacreacion desc";
            }
            List<Publicacion> lista = new List<Publicacion>();
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                Publicacion not = new Publicacion(dr.GetInt32(0));
                if (!not.caducada())
                {
                    lista.Add(not);
                }
            }
            dr.Close();
            cnn.Close();

            Int32 numPubs = lista.Count;
            Int32 numPaginas = (Int32)numPubs / numNotPag;
            //Si numNoticias < numNoticiasPagina => numPaginas es cero y daria error de division por cero al calcular el modulo
            if (numPubs < numNotPag)
            {
                numPaginas = 1;
            }
            else
            {
                if ((numPubs % numNotPag) != 0)
                {
                    numPaginas++;
                }
            }
            return numPaginas;
        }
        
        //para ListarPublicaciones
        public static List<Publicacion> getPublics(int pag, string tema, string autor,
            string contenido, string categoria, int numNotPag)
        {
            string clausulaTema = "";
            if (tema.Equals("Todos")) { } else { clausulaTema = "JOIN PublicacionesTemas pt ON (pt.Tema = '" + tema + "')"; }

            string clausulaContenido = "";
            //Si el contenido tiene espacios hago un like para cada palabra
            if ((contenido == null) || (contenido.Equals(""))) { }
            else
            {
                char[] separador = new char[1]; separador[0] = ' ';
                string[] palabras = contenido.Split(separador);
                clausulaContenido = "AND (";
                for (int i = 0; i < palabras.Length; i++)
                {
                    clausulaContenido += "CONTENIDO LIKE '%" + palabras[i] + "%' OR ";
                }
                //Ahora le debo quitar el ultimo OR y el espacio
                clausulaContenido = clausulaContenido.Substring(0, clausulaContenido.Length - 4);
                clausulaContenido += ")";
            }
            string clausulaCategoria = "";
            if (categoria.Equals("Todas")) { } else { clausulaCategoria = "AND N.Categoria = '" + categoria + "'"; }
            
            string sentencia;
            if (autor.Equals("Todos") && tema.Equals("Todos"))
            {

                /*
                 sentencia = "SELECT * FROM (SELECT ROW_NUMBER() OVER(ORDER BY FechaCreacion DESC) AS rn, n.ID FROM Publicaciones AS n " +
                    clausulaTema + " WHERE n.Eliminada = 'no' " + " AND VALIDADA = 'si' AND n.creador = '" + idUsu +"' "
                    + clausulaTema2 + ") AS sub WHERE ( rn > " + pagSelecc * Int32.Parse(numNotPag)+" AND rn <= "+(pagSelecc * Int32.Parse(numNotPag)+Int32.Parse(numNotPag))+")";
                 */

                sentencia = "SELECT * FROM (SELECT ROW_NUMBER() OVER(ORDER BY FechaCreacion DESC) AS rn, n.ID FROM Publicaciones AS n "+
                    "WHERE n.Eliminada = 'no' " + clausulaContenido + " " + clausulaCategoria +
                    " AND VALIDADA = 'si' ) AS sub WHERE ( rn > " + pag * numNotPag + " AND rn <= " + (pag * numNotPag + numNotPag) + ")";
            }
            else if (autor.Equals("Todos") && !tema.Equals("Todos"))
            {
                clausulaTema = " AND nt.tema = '" + tema + "'";
                sentencia = "SELECT * FROM (SELECT ROW_NUMBER() OVER(ORDER BY FechaCreacion DESC) AS rn, n.ID FROM Publicaciones AS n "+
                    "JOIN PublicacionesTemas AS NT ON (NT.Publicacion = N.ID) WHERE N.Eliminada = 'no' "
                    + clausulaTema + " " + clausulaContenido + " " + clausulaCategoria + " AND VALIDADA = 'si' ) AS sub "+
                    "WHERE ( rn > " + pag * numNotPag + " AND rn <= " + (pag * numNotPag + numNotPag) + ")";
            }
            else if (!autor.Equals("Todos") && tema.Equals("Todos"))
            {
                sentencia = "SELECT * FROM (SELECT ROW_NUMBER() OVER(ORDER BY FechaCreacion DESC) AS rn, n.ID FROM Publicaciones AS n "+
                    "JOIN Usuarios AS u ON (n.Creador = u.ID) " +
                    "WHERE u.Nombre + ' ' + u.Apellidos = '" + autor + "' AND n.Eliminada = 'no' "
                    + clausulaContenido + " " + clausulaCategoria + " AND VALIDADA = 'si' ) AS sub " +
                    "WHERE ( rn > " + pag * numNotPag + " AND rn <= " + (pag * numNotPag + numNotPag) + ")";
            }
            else // !autor.Equals("Todos") && !tema.Equals("Todos")
            {
                clausulaTema = " AND nt.tema = '" + tema + "'";
                sentencia = "SELECT * FROM (SELECT ROW_NUMBER() OVER(ORDER BY FechaCreacion DESC) AS rn, n.ID "+
                    "FROM Publicaciones n JOIN Usuarios u ON (n.Creador = u.ID) JOIN PublicacionesTemas NT ON (NT.Publicacion = N.ID) " +
                    " WHERE u.Nombre + ' ' + u.Apellidos = '" + autor + "' AND n.Eliminada = 'no' " + clausulaTema +
                    " " + clausulaContenido + " " + clausulaCategoria + " AND VALIDADA = 'si' ) AS sub " +
                    "WHERE ( rn > " + pag * numNotPag + " AND rn <= " + (pag * numNotPag + numNotPag) + ")";
            }
            
            List<Publicacion> lista = new List<Publicacion>();
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                Publicacion not = new Publicacion(dr.GetInt32(1));
                if (!not.caducada())
                {
                    lista.Add(not);
                }
            }
            dr.Close();
            cnn.Close();
            return lista; 
        }
        
        //para MisPublicaciones
        public static List<Publicacion> getPublics(string tema, int pagSelecc,
            string numNotPag, string todas, string idUsu)
        {

            string clausulaTema = "";
            string clausulaTema2 = "";
            if (tema.Equals("Todos")) { } else { clausulaTema = "JOIN PublicacionesTemas pt ON (pt.publicacion = n.id)";
                                                 clausulaTema2 = " and pt.tema = '" + tema + "' "; }

            string sentencia;
            if ((todas == null) || (todas.Equals("si")))
            { //Me da todas las publicaciones

                sentencia = "SELECT * FROM (SELECT ROW_NUMBER() OVER(ORDER BY FechaCreacion DESC) AS rn, n.ID FROM Publicaciones AS n " +
                    clausulaTema + " WHERE n.Eliminada = 'no' " + " AND VALIDADA = 'si' AND n.creador = '" + idUsu +"' "
                    + clausulaTema2 + ") AS sub WHERE ( rn > " + pagSelecc * Int32.Parse(numNotPag)+" AND rn <= "+(pagSelecc * Int32.Parse(numNotPag)+Int32.Parse(numNotPag))+")";
            }
            else
            { //Me da solo las publicaciones que tienen comentarios no leidos
                sentencia = "SELECT * FROM (SELECT DISTINCT ROW_NUMBER() OVER(ORDER BY FechaCreacion DESC) AS rn, n.ID FROM Publicaciones AS n "+
                    "JOIN Comentarios AS c ON (c.publicacion = n.id) " + clausulaTema +
                    " WHERE c.revisada = 'no' AND n.Eliminada = 'no' " + clausulaTema2 + " AND n.VALIDADA = 'si' AND n.creador = '" + idUsu
                    + "') AS sub WHERE ( rn > " + pagSelecc * Int32.Parse(numNotPag) + " AND rn <= " + (pagSelecc * Int32.Parse(numNotPag)+Int32.Parse(numNotPag)) + ")";
            }
            List<Publicacion> lista = new List<Publicacion>();
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                Publicacion not = new Publicacion(dr.GetInt32(1));
                if (!not.caducada() && !lista.Contains(not))
                {
                    lista.Add(not);
                }
            }
            dr.Close();
            cnn.Close();
            return lista;
        }

        public override bool Equals(object o)
        {

            if (o == null)

                return this == null;

            else

                return (o is Publicacion) && (this.id == ((Publicacion)o).id);

        }

        public List<Archivo> getArchivos(bool incluirVistaPrevia)
        {
            List<Archivo> lista = new List<Archivo>();

            string sentencia = "SELECT ID FROM ARCHIVOS WHERE Publicacion = " + id + " AND VALIDADO = 'si'";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                Archivo a = new Archivo(dr.GetInt32(0));

                if (incluirVistaPrevia == false && a.getRuta().Contains("_vp_"))
                {
                }
                else
                {
                    lista.Add(a);
                }
            }
            dr.Close();
            cnn.Close();

            return lista;
        }

        public List<Archivo> getArchivosNoValidados(bool incluirVistaPrevia)
        {
            List<Archivo> lista = new List<Archivo>();

            List<Int32> listaIds = new List<Int32>();
            string sentencia = "SELECT ID, RUTA FROM ARCHIVOS WHERE Publicacion = " + id + " AND VALIDADO = 'no'";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                if (incluirVistaPrevia == false && dr.GetString(1).Contains("_vp_"))
                {
                }
                else
                {
                    Archivo a = new Archivo(dr.GetInt32(0));
                    lista.Add(a);
                }
            }
            dr.Close();
            cnn.Close();
            return lista;
        }

        public static List<Publicacion> getNoValidadas()
        {
            string sentencia = "Select * from Publicaciones where Eliminada= 'no' and Validada='no'";
            List<Publicacion> lista = new List<Publicacion>();
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                Publicacion not = new Publicacion(dr.GetInt32(0));
                lista.Add(not);
            }
            dr.Close();
            cnn.Close();
            return lista; 
        }

        public void validarYAsingarImportancia(int import)
        {
            
            string sentencia = "Update Publicaciones set validada = 'si', importancia="+
                import+" where id =" + id;
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            com.ExecuteNonQuery();
            cnn.Close();
            validarArchivos();
            validarReferencias();
        }

        public bool caducada()
        {
            if (caducidad == null || caducidad.Equals("NULL"))
            {
                return false;
            }
            else{
                int ano = Int32.Parse(caducidad.Substring(1, 4));
                int mes;
                int dia;
                if (caducidad.Substring(7, 1).Equals("-")) //el mes tiene un digito
                {
                    mes = Int32.Parse(caducidad.Substring(6, 1));
                    if (caducidad.Substring(9, 1).Equals(" ")) //el dia tiene un digito
                    {
                        dia = Int32.Parse(caducidad.Substring(8,1));
                    }
                    else
                    {
                        dia = Int32.Parse(caducidad.Substring(8,2));
                    }
                }
                else
                {
                    mes = Int32.Parse(caducidad.Substring(6, 2));
                    if (caducidad.Substring(10, 1).Equals(" ")) //el dia tiene un digito
                    {
                        dia = Int32.Parse(caducidad.Substring(9,1));
                    }
                    else
                    {
                        dia = Int32.Parse(caducidad.Substring(9,2));
                    }
                }
                DateTime fech = new DateTime(ano, mes, dia);
                if (fech.CompareTo(DateTime.Now) < 0)
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
        }

        public void validarReferencias()
        {
            string sentencia = "UPDATE REFERENCIAS SET VALIDADA = 'si' WHERE Publicacion = " + id;
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            com.ExecuteNonQuery();
            cnn.Close();
        }

        public void eliminarReferenciasNoValidadas()
        {
            foreach (Referencia refer in getReferencias(false))
            {
                if (!refer.getValidada())
                {
                    refer.eliminar();
                }
            }
        }
        
        public List<Referencia> getReferencias(bool validadas)
        {
            //Segun el atributo validadas devolvera las validadas o las que no estan validadas

            List<Referencia> lista = new List<Referencia>();
            string val = "si";
            if (!validadas) { val = "no"; }


            string sentencia = "SELECT * FROM REFERENCIAS WHERE Publicacion = " + id + " AND VALIDADA = '" + val + "'";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                Referencia r = new Referencia(dr.GetInt32(0), new Publicacion(dr.GetInt32(1)), dr.GetString(2), validadas);
                lista.Add(r);
            }
            dr.Close();
            cnn.Close();

            return lista;
        }

        public void validarArchivos()
        {
            string strSQL = "UPDATE ARCHIVOS SET VALIDADO = 'si' WHERE Publicacion = " + id;
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(strSQL, cnn);
            com.ExecuteNonQuery();
            cnn.Close();
        }

        public void eliminarArchivosNoValidados()
        {
            string strSQL = "DELETE FROM ARCHIVOS WHERE Publicacion = " + id + " AND VALIDADO = 'no'";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(strSQL, cnn);
            com.ExecuteNonQuery();
            cnn.Close();
        }

        public void anadirTema(Tema tema)
        {
            string sentencia = "INSERT INTO PublicacionesTEMAS VALUES (" + id + ", '"+tema.getNombre()+"')";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            com.ExecuteNonQuery();
            cnn.Close();

            this.temas.Add(tema);
        }

        public void eliminarTema(Tema tema)
        {
            string sentencia = "DELETE FROM PublicacionesTEMAS WHERE Publicacion=" + id + " AND TEMA= '" + tema.getNombre() + "'";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            com.ExecuteNonQuery();
            cnn.Close();

            this.temas.Remove(tema);
        }

        public void modificarCategoria(string categoria)
        {
            string sentencia = "UPDATE Publicaciones SET CATEGORIA = '" + categoria + "' WHERE ID = " + id;
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            com.ExecuteNonQuery();
            cnn.Close();

            this.categoria = categoria;
        }

        public void modificarTitulo(string titulo)
        {
            string sentencia = "UPDATE Publicaciones SET Titulo = '" + titulo + "' WHERE ID = " + id;
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            com.ExecuteNonQuery();
            cnn.Close();

            this.titulo = titulo;
        }

        public void modificarCaducidad(string caducidad)
        {
            string sentencia = "UPDATE Publicaciones SET FechaCaducidad = " + caducidad + " WHERE ID = " + id;
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            com.ExecuteNonQuery();
            cnn.Close();

            this.caducidad = caducidad;
        }

        public void modificarContenido(string contenido)
        {
            string sentencia = "UPDATE Publicaciones SET Contenido = '" + contenido.Replace('\''.ToString(), "\\\'") + "' WHERE ID = " + id;
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            com.ExecuteNonQuery();
            cnn.Close();

            this.contenido = contenido;

        }

        public static Publicacion getAleatoria(string categoria)
        {
            string sentencia = "SELECT * FROM Publicaciones WHERE ELIMINADA = 'no' AND VALIDADA = 'si' AND IMPORTANCIA = 1 AND CATEGORIA = '"
                +categoria+"'";
            List<Publicacion> lista = new List<Publicacion>();
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                Publicacion not = new Publicacion(dr.GetInt32(0));
                if (!not.caducada())
                {
                    lista.Add(not);
                }
            }
            dr.Close();
            cnn.Close();
            Random rd = new Random();
            if (lista.Count == 0)
            {
                return null;
            }
            else
            {
                int numAleat = rd.Next(lista.Count-1);
                return lista.ElementAt(numAleat);
            }
        }

        public string getImagen()
        {//Devuelve la URL de una vista previa si existe

            List<Archivo> archs = getArchivos(true);
            if (archs.Count == 0)
            {
                return null;
            }
            else
            {
                Random rd = new Random();
                int i = rd.Next(archs.Count - 1);
                string nombre = archs[i].getRuta().Substring(archs[i].getRuta().LastIndexOf(Path.DirectorySeparatorChar) + 1);
                while ((archs.Count > 0 && !nombre.ToLower().EndsWith("jpg") && !nombre.Contains("_vp_")) || 
                    (archs.Count > 0 && !nombre.ToLower().EndsWith("jpeg") && !nombre.Contains("_vp_")) || 
                    (archs.Count > 0 && !nombre.ToLower().EndsWith("bmp") && !nombre.Contains("_vp_")) || 
                    (archs.Count > 0 && !nombre.ToLower().EndsWith("tiff") && !nombre.Contains("_vp_")) || 
                    (archs.Count > 0 && !nombre.ToLower().EndsWith("tif") && !nombre.Contains("_vp_")) ||
                    (archs.Count > 0 && !nombre.ToLower().EndsWith("gif") && !nombre.Contains("_vp_")) ||
                    (archs.Count > 0 && !nombre.ToLower().EndsWith("png") && !nombre.Contains("_vp_")))
                {
                    archs.Remove(archs[i]);
                    if (archs.Count == 0) { return null; } //Por si habia uno y al eliminar quedan cero, daria fallo en Next
                    i = rd.Next(archs.Count - 1);
                    nombre = archs[i].getRuta().Substring(archs[i].getRuta().LastIndexOf(Path.DirectorySeparatorChar) + 1);
                }
                if (archs.Count == 0) //Sale y no habia imagenes
                {
                    return null;
                }
                else //Devuelvo la imagen la imagen aleatoria
                {
                    int id2 = Int32.Parse(nombre.Substring(0, nombre.IndexOf("_")))+1;
                    return Estatica.getUrlProyecto+"Archivos/"+nombre;
                }
            }
        }

    }
}