﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Data.SqlClient;

namespace DivulgacionCientifica.CapaNegocio
{
    public class Referencia
    {
        int id;
        Publicacion publicacion;
        string referencia;
        bool validada;

        public Referencia(int id, Publicacion publ, string refer, bool valid)
        {
            this.id = id;
            this.publicacion = publ;
            this.referencia = refer;
            this.validada = valid;
        }

        public Referencia(string referencia, Publicacion publicacion)
        {
            this.referencia = referencia;
            this.publicacion = publicacion;
            validada = false;
        }

        public int getId() { return id; }

        public Publicacion getPublicacion() { return publicacion; }

        public string getReferencia() { return referencia; }

        public bool getValidada() { return validada; }

        public void almacenar()
        {
            this.id = maxId() + 1;
            string val = "no"; if (validada) val = "si";
            string sentencia = "INSERT INTO REFERENCIAS VALUES ("+id+", "+publicacion.getID()+", '"+
                referencia+"', '"+val+"')";

            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            com.ExecuteNonQuery();
            cnn.Close();
        }

        public void almacenarAdmin()
        {
            validada = true;
            almacenar();
        }

        private int maxId()
        {
            Int32 newId = 0;
            string sql = "SELECT * FROM Referencias";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sql, cnn);
            SqlDataReader dr = com.ExecuteReader();
            bool hayDatos;
            if (dr.Read()) //Hay Publicacions almacenadas
            {
                hayDatos = true;
            }
            else
            {
                hayDatos = false;
            }
            cnn.Close();

            if (hayDatos)
            {
                string sql2 = "SELECT MAX(ID) FROM Referencias";
                SqlConnection cnn2 = new SqlConnection();
                cnn2.ConnectionString = Estatica.getConnectionBD;
                cnn2.Open();
                SqlCommand com2 = new SqlCommand(sql2, cnn2);
                newId = (Int32)com2.ExecuteScalar();
                cnn2.Close();
            }

            return newId;
        }

        public void eliminar()
        {
            string sentencia = "DELETE FROM REFERENCIAS WHERE REFERENCIA = '"
                +referencia+"' AND Publicacion = " + publicacion.getID();

            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            com.ExecuteNonQuery();
            cnn.Close();
        }

        public bool existeEnBD()
        {
            string sql = "SELECT * FROM Referencias WHERE Referencia = '"+referencia+
                "' AND Publicacion = " + publicacion.getID();
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sql, cnn);
            SqlDataReader dr = com.ExecuteReader();
            bool hayDatos;
            if (dr.Read()) //Hay Publicacions almacenadas
            {
                hayDatos = true;
            }
            else
            {
                hayDatos = false;
            }
            cnn.Close();
            return hayDatos;
        }
        
    }
}
