﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Data.SqlClient;
using System.IO;
using System.Collections.Generic;


namespace DivulgacionCientifica.CapaNegocio
{
    public class Tema
    {
        private string nombre;
        private string descripcion;
        private bool eliminado;

        public Tema(string nombre, string descripcion)
        {
            this.nombre = nombre;
            this.descripcion = descripcion;
            this.eliminado = false;
        }

        public string getNombre(){
            return nombre;
        }

        public string getDescripcion()
        {
            return descripcion;
        }

        public bool getEliminado()
        {
            return eliminado;
        }

        public void almacenarTema()
        {
            
            string sentencia;
            if (this.temaEliminado())
            {
                sentencia = "UPDATE Temas SET Descripcion ='" + descripcion + "', Eliminado='no' WHERE (Nombre = '" + nombre + "')";
            }
            else
            {
                sentencia = "INSERT INTO Temas VALUES ('"+nombre+"', '"+descripcion+"', 'no')";
            }

            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            com.ExecuteNonQuery();
            cnn.Close();

        }

        public bool existe()
        {
            String sentencia = "SELECT Nombre FROM Temas WHERE Nombre = '"+ nombre +"' and Eliminado = 'no'";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();

            bool ex;
            if (dr.Read())
            {
                ex = true;
            }
            else
            {
                ex = false;
            }
            dr.Close();
            cnn.Close();
            return ex;
        }

        public bool temaEliminado()
        {
            
            String sentencia = "SELECT Nombre FROM Temas WHERE Nombre = '" + nombre + "' and Eliminado = 'si'";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();

            bool ex;
            if (dr.Read())
            {
                ex = true;
            }
            else
            {
                ex = false;
            }
            dr.Close();
            cnn.Close();
            return ex;
        }

        public void eliminarTemaLogico()
        {
            

            //Elimina las publicaciones que no estan asociadas a ningun otro tema
            string sentenciaSQL2 = "SELECT publicacion FROM PUBLICACIONESTEMAS pt join PUBLICACIONES p ON (pt.publicacion = p.id) "+
                " WHERE TEMA = '" + nombre + "' and p.eliminada = 'no'";
            SqlConnection cnn2 = new SqlConnection();
            cnn2.ConnectionString = Estatica.getConnectionBD;
            cnn2.Open();
            SqlCommand com2 = new SqlCommand(sentenciaSQL2, cnn2);
            SqlDataReader dr2 = com2.ExecuteReader();

            while (dr2.Read())
            {
                Publicacion p = new Publicacion(dr2.GetInt32(0));
                if (p.getTemas().Count == 1)
                { //Era el unico tema al que estaba asociada esta publicacion
                    p.eliminarPublicLogico();
                }
            }
            dr2.Close();
            cnn2.Close();

            
            string sentenciaSQL = "UPDATE Temas SET Eliminado = 'si' WHERE (Nombre = '" + nombre + "')";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentenciaSQL, cnn);
            com.ExecuteNonQuery();
            cnn.Close();
           
            
            string sentenciaSQL3 = "DELETE FROM publicacionestemas WHERE (Tema = '" + nombre + "')";
            SqlConnection cnn3 = new SqlConnection();
            cnn3.ConnectionString = Estatica.getConnectionBD;
            cnn3.Open();
            SqlCommand com3 = new SqlCommand(sentenciaSQL3, cnn3);
            com3.ExecuteNonQuery();
            cnn3.Close();

            eliminarRSS();
            
        }

        public void eliminarTemaFisico()
        {
            string sentenciaSQL = "DELETE FROM Temas WHERE Nombre = '" + nombre + "'";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentenciaSQL, cnn);
            com.ExecuteNonQuery();
            cnn.Close();
        }

        public void crearRSS(string url, string ruta)
        {
            FileStream fich = new FileStream(ruta, FileMode.Create);
            StreamWriter writer = new StreamWriter(fich, System.Text.Encoding.UTF8);
            writer.WriteLine("<?xml version=\"1.0\" encoding=\"utf-8\" standalone=\"yes\"?>");
            writer.WriteLine("<rss version=\"2.0\">");
            writer.WriteLine("<channel>");
            writer.WriteLine("<title>Divulgacion Cientifica - " + nombre + "</title>");
            writer.WriteLine("<link>" + url + "</link>");
            writer.WriteLine("<description>" + descripcion + "</description>");
            writer.WriteLine("<language>es-ES</language>");
            writer.WriteLine("");
            writer.WriteLine("</channel>");
            writer.WriteLine("</rss>");
            writer.Close();
            fich.Close();
        }

        public void eliminarRSS()
        {
            string ruta = Estatica.getRutaProyecto + "feedsRSS" + Path.DirectorySeparatorChar + nombre + ".xml";
            if (File.Exists(ruta))
            {
                File.Delete(ruta);
            }
        }

        public static List<Tema> getTodosTemas()
        {
            List<Tema> lista = new List<Tema>();

            String sentencia = "SELECT nombre FROM Temas WHERE Eliminado = 'no'";
            SqlConnection cnn = new SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                Tema t = new Tema(dr.GetString(0), "");
                lista.Add(t);
            }
            dr.Close();
            cnn.Close();
            return lista;
        }

    }

 
}
