﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using MySql.Data;
using System.Text;
using System.Collections.Generic;
using System.Data.SqlClient;


namespace DivulgacionCientifica.CapaNegocio
{
    public class Usuario
    {
        private string id;
        private string contrasenaHash;
        private string nombre;
        private string apellidos;
        private string email;
        private Pais pais;
        private string sexo;
        private DateTime fechaRegistro;
        private bool eliminado;
        private string ocupacion;
        private string telefono1;
        private string telefono2;
        private string observaciones;
        private bool validado;

        public Usuario(string id)
        {
            
            String sentencia = "SELECT * FROM Usuarios WHERE (ID = '" + id + "')";
            System.Data.SqlClient.SqlConnection cnn = new System.Data.SqlClient.SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();
            if (dr.Read())
            {
                //Guardo el ID que se introdujo en la base de datos ya que al hacer las consultas no distingue entre mayusculas y minusculas MySQL
                this.id = dr.GetString(0);
                this.contrasenaHash = dr.GetString(1);
                this.nombre = dr.GetString(2);
                this.email = dr.GetString(3);
                this.apellidos = dr.GetString(4);
                this.pais = new Pais(dr.GetString(5));

                if (dr.IsDBNull(6)) { this.sexo = ""; }
                else { this.sexo = dr.GetString(6); }

                this.fechaRegistro = dr.GetDateTime(7);

                if (dr.GetString(8).Equals("si")) { this.eliminado = true; }
                else { this.eliminado = false; }

                this.ocupacion = dr.GetString(9);
                this.telefono1 = dr.GetString(10);
                this.telefono2 = dr.GetString(11);
                this.observaciones = dr.GetString(12);

                if (dr.GetString(13).Equals("si")) { this.validado = true; }
                else { this.validado = false; }
            }
            dr.Close();
            cnn.Close();
        }

        public Usuario(string id, string contras, string nombre,
            string ap, string mail, Pais pais, string sexo, string ocupacion,
            string telefono1, string telefono2, string observ)
        {
            this.id = id;
            contrasenaHash = FormsAuthentication.HashPasswordForStoringInConfigFile(
                                  contras, "sha1");
            this.nombre = nombre;
            apellidos = ap;
            email = mail;
            this.pais = pais;
            this.sexo = sexo;
            fechaRegistro = DateTime.Now;
            eliminado = false;
            this.ocupacion = ocupacion;
            this.telefono1 = telefono1;
            this.telefono2 = telefono2;
            this.observaciones = observ;
            this.validado = false;
        }

        
        public Usuario(string id, string nombre,
            string ap, string mail, Pais pais, string sexo,
            DateTime fecha, bool eli, string ocupacion, string telefono1,
            string telefono2, string observaciones, bool validado)
        {
            //Para cuando lo obtengo de la base de datos
            this.id = id;
            this.nombre = nombre;
            apellidos = ap;
            email = mail;
            this.pais = pais;
            this.sexo = sexo;
            fechaRegistro = fecha;
            eliminado = eli;
            this.ocupacion = ocupacion;
            this.telefono1 = telefono1;
            this.telefono2 = telefono2;
            this.observaciones = observaciones;
            this.validado = validado;
        }

        /* Selectores */
        public string getId() { return id; }
        public string getNombre(){ return nombre; }
        public string getApellidos() { return apellidos; }
        public string getEmail() { return email; }
        public string getSexo() { return sexo; }
        public Pais getPais() { return pais; }
        public DateTime getFechaRegistro() { return fechaRegistro; }
        public bool getEliminado() { return eliminado; }
        public string getOcupacion() { return ocupacion; }
        public string getTelefono1() { return telefono1; }
        public string getTelefono2() { return telefono2; }
        public string getObservaciones() { return observaciones; }
        public bool getValidado() { return validado; }

        public bool almacenarUsuario()
        {
            bool dev;
            string sexoBD = "NULL";
            if (sexo.Equals("hombre")) { sexoBD = "'hombre'"; }
            else if (sexo.Equals("mujer")) { sexoBD = "'mujer'"; }

            string strSQL;

            if (!idDisponible(this.id))
            {
                Usuario u = new Usuario(this.id);
                if (u.getEliminado())
                {
                    strSQL = "UPDATE Usuarios SET ContrasenaHash ='" + contrasenaHash + "', Nombre ='" + nombre + "', Email ='" +
                        email + "', Apellidos ='" + apellidos + "', Pais ='" + pais.getNombre() + "', Sexo =" + sexoBD + ", FechaRegistro = GETDATE(), Eliminado='no', Ocupacion='" +
                        ocupacion + "', Telefono1 = '" + telefono1 + "', Telefono2='" + telefono2 + "', Observaciones = '" + observaciones
                        + "', Validado='no' WHERE (Id = '" + id + "')";
                    dev = true;
                }
                else
                {
                    return false;
                }
            }
            else
            {
                /* Inserto en Usuarios */
                strSQL = "INSERT INTO Usuarios VALUES ('" + id + "', '" + contrasenaHash + "', '" + nombre + "', '" +
                  email + "', '" + apellidos + "', '" + pais.getNombre() + "', " + sexoBD + ", GETDATE(), 'no', '"+ocupacion+"', '"+
                  telefono1+"', '"+telefono2+"', '"+observaciones+"', 'no')";
                dev = true;
            }
            System.Data.SqlClient.SqlConnection cnn = new System.Data.SqlClient.SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(strSQL, cnn);
            com.ExecuteNonQuery();
            cnn.Close();
            return dev;

        }

        public static bool idDisponible(string id)
        {
            
            String sentencia = "SELECT * FROM Usuarios WHERE (ID = '" + id + "' AND Eliminado = 'no')";
            System.Data.SqlClient.SqlConnection cnn = new System.Data.SqlClient.SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();

            bool dev;
            if (dr.Read())
            {
                dev = false;
            }
            else
            {
                dev = true;
            }
            dr.Close();
            cnn.Close();
            return dev;
        }

        public static bool credencialesCorrectos(string idUsu, string contrasenaUsu)
        {
            
            string cHash = FormsAuthentication.HashPasswordForStoringInConfigFile(
                                  contrasenaUsu, "sha1");

            
            String sentencia = "SELECT * FROM Usuarios WHERE (ID = '" + idUsu + "' AND ContrasenaHash = '" + cHash + "' AND Eliminado = 'no' AND Validado= 'si')";
            System.Data.SqlClient.SqlConnection cnn = new System.Data.SqlClient.SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();

            bool dev;
            if (dr.Read())
            {
                dev = true;
            }
            else
            {
                dev = false;
            }
            dr.Close();
            cnn.Close();
            return dev;
        }

        public static bool esAdministrador(string id)
        {
            /*supongo que el administrador tiene id = admin*/
            return id.Equals("admin");
        }

        public void eliminarUsuarioLogico()
        {
            
            string sentenciaSQL = "UPDATE Usuarios SET Eliminado = 'si' WHERE (ID = '" + id + "')";
            System.Data.SqlClient.SqlConnection cnn = new System.Data.SqlClient.SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentenciaSQL, cnn);
            com.ExecuteNonQuery();     
            cnn.Close();

            string sentenciaSQL2 = "UPDATE Publicaciones SET Eliminada = 'si' WHERE (Creador = '" + id + "')";
            System.Data.SqlClient.SqlConnection cnn2 = new System.Data.SqlClient.SqlConnection();
            cnn2.ConnectionString = Estatica.getConnectionBD;
            cnn2.Open();
            SqlCommand com2 = new SqlCommand(sentenciaSQL2, cnn2);
            com2.ExecuteNonQuery();
            cnn2.Close();

        }

        public void eliminarUsuarioFisico()
        {
            
            string sentenciaSQL = "DELETE FROM Usuarios WHERE (ID = '" + id + "')";
            System.Data.SqlClient.SqlConnection cnn = new System.Data.SqlClient.SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentenciaSQL, cnn);
            com.ExecuteNonQuery();
            cnn.Close();
        }
        
        public void modificarUsuario(string nombre, string email,
            string apellidos, Pais pais, string sexo, string ocupacion, string telefono1,
            string telefono2)
        {
            string sexoBD = "NULL";
            if (sexo.Equals("hombre")) { sexoBD = "'hombre'"; }
            else if (sexo.Equals("mujer")) { sexoBD = "'mujer'"; }
            
            string sentenciaSQL = "UPDATE Usuarios SET Nombre ='" + nombre + "', Email ='" +
                    email + "', Apellidos ='" + apellidos + "', Pais ='" + pais.getNombre() + "', Sexo =" + sexoBD + ", Ocupacion='" +
                    ocupacion + "', Telefono1 = '" + telefono1 + "', Telefono2='" + telefono2 + "' WHERE (Id = '" + this.id + "')";
            
            System.Data.SqlClient.SqlConnection cnn = new System.Data.SqlClient.SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentenciaSQL, cnn);
            com.ExecuteNonQuery();
            cnn.Close();
        }
        
        public void modificarContrasena (string contrasena)
        {
            string contrasenaHash = FormsAuthentication.HashPasswordForStoringInConfigFile(
                                  contrasena, "sha1");
            string sentenciaSQL = "UPDATE Usuarios SET ContrasenaHash = '" + contrasenaHash + "' WHERE (ID = '" + id + "')";
            
            System.Data.SqlClient.SqlConnection cnn = new System.Data.SqlClient.SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentenciaSQL, cnn);
            com.ExecuteNonQuery();
            cnn.Close();
        }

        public static List<Usuario> getUsuarios(string filtrarPor, string filtro)
        {
            List<Usuario> lista = new List<Usuario>();

            string strSql = "";
            if (filtrarPor.Equals("Ninguno"))
            {
                strSql = "SELECT * FROM USUARIOS WHERE ELIMINADO = 'no' AND VALIDADO = 'si'";
            }
            else if (filtrarPor.Equals("Nombre de usuario"))
            {
                strSql = "SELECT * FROM USUARIOS WHERE ID LIKE '%" +
                    filtro + "%' AND ELIMINADO = 'no' AND VALIDADO = 'si'";
            }
            else if (filtrarPor.Equals("Nombre y apellidos"))
            {
                strSql = "SELECT * FROM USUARIOS WHERE NOMBRE + ' ' + APELLIDOS LIKE '%" +
                    filtro + "%' AND ELIMINADO = 'no' AND VALIDADO = 'si'";
            }
            else// if (filtrarPor.Equals("Pais"))
            {
                strSql = "SELECT * FROM USUARIOS WHERE Pais LIKE '%" + 
                    filtro + "%' and Eliminado = 'no' AND VALIDADO = 'si'";
            }

            System.Data.SqlClient.SqlConnection cnn = new System.Data.SqlClient.SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(strSql, cnn);
            SqlDataReader dr = com.ExecuteReader();
            
            while (dr.Read())
            {
                string nombre = "";
                if (!dr.IsDBNull(2)){ nombre = dr.GetString(2); }

                string apellidos = "";
                if (!dr.IsDBNull(4)){ apellidos = dr.GetString(4); }

                string sexo = "";
                if (!dr.IsDBNull(6)) { sexo = dr.GetString(6); }

                bool eli = false;
                if (dr.GetString(8).Equals("si")) { eli = true; }

                bool valid = true;
                if (dr.GetString(13).Equals("no")) { valid = false; }

                Usuario usu = new Usuario(dr.GetString(0), nombre, apellidos, dr.GetString(3),
                        new Pais(dr.GetString(5)), sexo, dr.GetDateTime(7), eli, dr.GetString(9),
                        dr.GetString(10), dr.GetString(11), dr.GetString(12), valid);
                lista.Add(usu);
            }
            dr.Close();
            cnn.Close();

            return lista;

        }

        public static List<Usuario> getUsuarios(string filtrarPor, string filtro, int pagSelecc, string numUsuPag)
        {
            //Cree la lista pq antes la necesitaba, ahora ya no, solo necesito el numero
            List<Usuario> lista = new List<Usuario>();

            string strSql = "";
            if (filtrarPor.Equals("Ninguno"))
            {
                strSql = "SELECT * FROM (SELECT ROW_NUMBER() OVER(ORDER BY u.Nombre DESC) AS rn, u.* FROM USUARIOS AS u "+
                    "WHERE ELIMINADO = 'no' AND VALIDADO = 'si' ) AS sub WHERE ( rn > " + pagSelecc * Int32.Parse(numUsuPag) +
                    " AND rn <= " + (pagSelecc * Int32.Parse(numUsuPag) + Int32.Parse(numUsuPag)) + ")";
            }
            else if (filtrarPor.Equals("Nombre de usuario"))
            {
                strSql = "SELECT * FROM (SELECT ROW_NUMBER() OVER(ORDER BY u.Nombre DESC) AS rn, u.* FROM USUARIOS AS u WHERE ID LIKE '%" + filtro +
                    "%' AND ELIMINADO = 'no' AND VALIDADO = 'si' ) AS sub WHERE ( rn > " + pagSelecc * Int32.Parse(numUsuPag) +
                    " AND rn <= " + (pagSelecc * Int32.Parse(numUsuPag) + Int32.Parse(numUsuPag)) + ")";
            }
            else if (filtrarPor.Equals("Nombre y apellidos"))
            {
                strSql = "SELECT * FROM (SELECT ROW_NUMBER() OVER(ORDER BY u.Nombre DESC) AS rn, u.* FROM USUARIOS AS u WHERE NOMBRE + ' ' + APELLIDOS LIKE '%"
                    + filtro + "%' AND ELIMINADO = 'no' AND VALIDADO = 'si' ) AS sub WHERE ( rn > " + pagSelecc * Int32.Parse(numUsuPag) +
                    " AND rn <= " + (pagSelecc * Int32.Parse(numUsuPag) + Int32.Parse(numUsuPag)) + ")";
            }
            else// if (filtrarPor.Equals("Pais"))
            {
                strSql = "SELECT * FROM (SELECT ROW_NUMBER() OVER(ORDER BY u.Nombre DESC) AS rn, u.* FROM USUARIOS AS u WHERE Pais LIKE '%" +
                    filtro + "%' and Eliminado = 'no' AND VALIDADO = 'si' ) AS sub WHERE ( rn > " + pagSelecc * Int32.Parse(numUsuPag) +
                    " AND rn <= " + (pagSelecc * Int32.Parse(numUsuPag) + Int32.Parse(numUsuPag)) + ")";
            }

            System.Data.SqlClient.SqlConnection cnn = new System.Data.SqlClient.SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(strSql, cnn);
            SqlDataReader dr = com.ExecuteReader();

            while (dr.Read())
            {
                string nombre = "";
                if (!dr.IsDBNull(3)) { nombre = dr.GetString(3); }

                string apellidos = "";
                if (!dr.IsDBNull(5)) { apellidos = dr.GetString(5); }

                string sexo = "";
                if (!dr.IsDBNull(7)) { sexo = dr.GetString(7); }

                bool eli = false;
                if (dr.GetString(9).Equals("si")) { eli = true; }

                bool valid = false;
                if (dr.GetString(14).Equals("si")) { valid = true; }

                Usuario usu = new Usuario(dr.GetString(1), nombre,
                    apellidos, dr.GetString(4), new Pais(dr.GetString(6)), sexo,
                    dr.GetDateTime(8), eli, dr.GetString(10), dr.GetString(11),
                    dr.GetString(12), dr.GetString(13), valid);
                lista.Add(usu);
            }
            dr.Close();
            cnn.Close();

            return lista;

        }

        public static int numPaginas(int numUsuarios, string numUsuPag)
        {
            Int32 numPaginas = (Int32)numUsuarios / Int32.Parse(numUsuPag);
            if (numUsuarios < Int32.Parse(numUsuPag))
            {
                numPaginas = 1;
            }
            else
            {
                if ((numUsuarios % Int32.Parse(numUsuPag)) != 0)
                {
                    numPaginas++;
                }
            }
            return numPaginas;
        }

        public static List<Usuario> getNoValidados()
        {
            List<Usuario> lista = new List<Usuario>();

            
            String sentencia = "SELECT * FROM Usuarios WHERE VALIDADO = 'no'";
            System.Data.SqlClient.SqlConnection cnn = new System.Data.SqlClient.SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            SqlDataReader dr = com.ExecuteReader();

            while (dr.Read())
            {
                bool eli; if (dr.GetString(8).Equals("si")){eli = true;} else{ eli = false;}
                bool val; if (dr.GetString(13).Equals("si")){val = true;} else{ val = false;}
                Usuario u = new Usuario(dr.GetString(0), dr.GetString(2), dr.GetString(4),
                    dr.GetString(3), new Pais(dr.GetString(5)), dr.GetString(6), dr.GetDateTime(7), eli,
                    dr.GetString(9), dr.GetString(10), dr.GetString(11), dr.GetString(12), val);
                lista.Add(u);
            }
            dr.Close();
            cnn.Close();
            return lista;
        }

        public void validar()
        {
            string sentencia = "Update Usuarios set validado = 'si' where id ='" + id + "'";
            System.Data.SqlClient.SqlConnection cnn = new System.Data.SqlClient.SqlConnection();
            cnn.ConnectionString = Estatica.getConnectionBD;
            cnn.Open();
            SqlCommand com = new SqlCommand(sentencia, cnn);
            com.ExecuteNonQuery();
            cnn.Close();
        }

        
    }
}
