﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using DivulgacionCientifica;
using DivulgacionCientifica.CapaNegocio;

namespace WebApplicationFloral
{
    public partial class WebFormDarBaja : System.Web.UI.Page
    {
        string idCurrentUser = HttpContext.Current.User.Identity.Name;
        protected void Page_Load(object sender, EventArgs e)
        {
            //Si el usuario no esta autenticado no se permite ver el
            //formulario DarBaja sino que se redirecciona a Inicio

            if (idCurrentUser.Equals(""))
            {
                Response.Redirect("~\\Inicio.aspx");
            }
            else
            {
                btAceptar.Focus();
                LabelError.Text = "";
                LabelOK.Text = "";
                LabelCabecera.Text = "Bienvenido, " + idCurrentUser;
            }
        }

        protected void btAceptar_Click(object sender, EventArgs e)
        {
            if (Usuario.esAdministrador(idCurrentUser))
            {
                LabelError.Text = "No puede darse de baja ya que es el administrador del sistema.";
            }
            else if (TextBoxUsuario.Text.ToLower().Equals(idCurrentUser.ToLower()) &&
                Usuario.credencialesCorrectos(idCurrentUser, TextBoxContrasena.Text))
            {
                Usuario u = new Usuario(idCurrentUser);
                u.eliminarUsuarioLogico();
                idCurrentUser = "";
                LabelOK.Text = "Has sido dado de baja correctamente.";
                LabelCabecera.Text = "Dar de baja";
            }
            else
            {
                LabelError.Text = "ERROR. El usuario o contraseña incorrectos.";
            }

        }
    }
}
