﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using DivulgacionCientifica.CapaNegocio;
using System.Data.SqlClient;
using System.Collections.Generic;

namespace DivulgacionCientifica
{
    public partial class GestionarPaises : System.Web.UI.Page
    {
        string idCurrentUser = HttpContext.Current.User.Identity.Name;
        protected void Page_Load(object sender, EventArgs e)
        {
            try
            {
                if (!Usuario.esAdministrador(idCurrentUser))
                {
                    Response.Redirect("~\\Inicio.aspx");
                }
                else
                {
                    LabelAnaCorr.Text = "";
                    LabelAnaErr.Text = "";
                    LabelEliCorr.Text = "";
                    LabelEliErr.Text = "";
                    if (ListBoxPaises.Items.Count == 0)
                    {
                        foreach (Pais p in Pais.getPaises())
                        {
                            ListBoxPaises.Items.Add(p.getNombre());
                        }
                    }
                }
            }
            catch (SqlException)
            {
                LabelEliErr.Text = "ERROR. Se ha producido un error en el acceso a la base de datos";
            } 
        }

        protected void btAñadir_Click(object sender, EventArgs e)
        {
            try
            {
                Pais p = new Pais(TextBoxNombre.Text);
                if (TextBoxNombre.Text.Length > 45)
                {
                    LabelAnaErr.Text = "ERROR. El nombre del país no puede exceder de 45 caracteres";
                }
                else if (p.existe())
                {
                    LabelAnaErr.Text = "ERROR. El país ya existe";
                }
                else
                {
                    p.almacenarPais();
                    ListBoxPaises.Items.Clear();
                    cargarPaises(ListBoxPaises);
                    LabelAnaCorr.Text = "El país ha sido añadido con éxito";
                    TextBoxNombre.Text = "";
                }
            }
            catch (SqlException)
            {
                LabelAnaErr.Text = "ERROR. Se ha producido un error al guardar el país.";
            }
        }

        protected void btEliminar_Click(object sender, EventArgs e)
        {
            try
            {
                Pais p = new Pais(ListBoxPaises.SelectedItem.Text);
                p.eliminarPais();
                LabelEliCorr.Text = "El país ha sido eliminado con éxito";
                ListBoxPaises.Items.Clear();
                cargarPaises(ListBoxPaises);
            }
            catch (NullReferenceException)
            {
                LabelEliErr.Text = "ERROR. Debe seleccionar un país";
            }
            catch (SqlException)
            {
                LabelEliErr.Text = "ERROR. No puede eliminar un país mientras que sea nación de algún usuario.";
            }
        }

        protected void btFiltrar_Click(object sender, EventArgs e)
        {
            ListBoxPaises.Items.Clear();
            try
            {
                foreach (Pais p in Pais.getPaises(TextBoxFiltro.Text))
                {
                    ListBoxPaises.Items.Add(p.getNombre());
                }
            }
            catch (SqlException)
            {
                LabelEliErr.Text = "ERROR. Se ha producido un error en el acceso a la base de datos";
            }
        }

        public void cargarPaises(ListBox l)
        {
            List<Pais> paises = Pais.getPaises();
            foreach (Pais p in paises)
            {
                l.Items.Add(p.getNombre());
            }
        }
    }
}
