﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using DivulgacionCientifica.CapaNegocio;
using System.Data.SqlClient;
using System.Collections.Generic;

namespace DivulgacionCientifica
{
    public partial class GestionarUsuarios : System.Web.UI.Page
    {
        string idCurrentUser = HttpContext.Current.User.Identity.Name;
        List<Usuario> l;

        protected void Page_Load(object sender, EventArgs e)
        {
            try
            {
                if (!Usuario.esAdministrador(idCurrentUser))
                {
                    Response.Redirect("~\\Inicio.aspx");
                }
                else
                {
                    PanelUsuarios.Controls.Clear();
                    cargarUsuarios();
                    LabelCorrecto.Text = "";
                    LabelError.Text = "";
                }
            }
            catch (SqlException)
            {
                LabelError.Text = "ERROR. Se ha producido un error relacionado con la base de datos.";
            }
        }

        protected void btBuscar_Click(object sender, EventArgs e)
        {
            
            string r = Estatica.getUrlProyecto + "GestionarUsuarios.aspx?pag=0&filtro=" + DropDownListFiltro.SelectedItem.Text + "&valorfiltro=" + TextBoxFiltro.Text + "&numUsuPag=" + DropDownListUsuPag.SelectedItem.Text;
            Response.Redirect(r);
             
        }

        private void cargarUsuarios()
        {
            try
            {
                l = Usuario.getUsuarios(Request.Params["filtro"], Request.Params["valorfiltro"]);
                int numUsuarios = l.Count;
                int numPaginas = Usuario.numPaginas(numUsuarios, Request.Params["numUsuPag"]);
                Int32 pagSelecc = Int32.Parse(Request.Params["pag"]);
                
                if (numUsuarios == 0)
                {
                    PanelNoUsuarios.Visible = true;
                    PanelUsuarios.Visible = false;
                }
                else
                {
                    PanelNoUsuarios.Visible = false;
                    PanelUsuarios.Visible = true;

                    if (numPaginas > 1)
                    {
                        LabelPaginador.Text = (Int32.Parse(Request.Params["pag"]) + 1) + " de " + numPaginas;
                        LabelPaginador2.Text = (Int32.Parse(Request.Params["pag"]) + 1) + " de " + numPaginas;
                        PanelPaginadorSup.Visible = true;
                        PanelInf.Visible = true;
                    }
                    else
                    {
                        PanelPaginadorSup.Visible = false;
                        PanelInf.Visible = false;
                    }
                    List<Usuario> listaUsuarios = Usuario.getUsuarios(Request.Params["filtro"], Request.Params["valorfiltro"],
                        Int32.Parse(Request.Params["pag"]), Request.Params["numUsuPag"]);
                    foreach (Usuario usu in listaUsuarios)
                    {
                    cargarUsuario(usu);
                    }
                }
            }
            catch (NullReferenceException)
            {
                LabelCorrecto.Text = "";
                LabelError.Text = "ERROR.";
            }
            catch (SqlException)
            {
                LabelCorrecto.Text = "";
                LabelError.Text = "ERROR. No se han podido cargar los datos.";
            }   
        }

        private void cargarUsuario(Usuario usu)
        {

            PanelUsuarios.Controls.Add(new LiteralControl("<h4 style=\"margin-right: 110px; margin-left: 150px\">"));
            PanelUsuarios.Controls.Add(new LiteralControl("<a href=" + Estatica.getUrlProyecto + "ModificarDatos.aspx?id=" + usu.getId()
                + " style=\"color: #669900\">" + usu.getId() + "</a></h4>"));
            PanelUsuarios.Controls.Add(new LiteralControl("<p style=\"margin: auto 110px auto 150px; width: auto; font-family: 'trebuchet MS'; left: 5px; font-size: small; right: 5px;\">"));
            PanelUsuarios.Controls.Add(new LiteralControl("Nombre: " + usu.getNombre() + "<br />"));
            PanelUsuarios.Controls.Add(new LiteralControl("Apellidos: " + usu.getApellidos() + "<br />"));
            PanelUsuarios.Controls.Add(new LiteralControl("Email: " + usu.getEmail() + "<br />"));
            PanelUsuarios.Controls.Add(new LiteralControl("País: " + usu.getPais().getNombre() + "<br />"));
            PanelUsuarios.Controls.Add(new LiteralControl("Sexo: " + usu.getSexo() + "<br />"));
            PanelUsuarios.Controls.Add(new LiteralControl("Fecha de registro: " + usu.getFechaRegistro().ToString() + "<br />"));

            HyperLink hpEditar = new HyperLink();
            hpEditar.ID = "hpEditar" + usu.getId();
            hpEditar.Text = "Ver/Editar";
            hpEditar.NavigateUrl = "ModificarDatos.aspx?id=" + usu.getId();
            PanelUsuarios.Controls.Add(hpEditar);
            PanelUsuarios.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));

            if (Usuario.esAdministrador(usu.getId()))
            {

            }
            else
            {
                LinkButton lbEliminar = new LinkButton();
                lbEliminar.ID = "lbEliminar" + usu.getId();
                lbEliminar.Text = "Eliminar";
                lbEliminar.Attributes.Add("language", "javascript");
                lbEliminar.Attributes.Add("OnClick", "return confirm('¿Esta seguro que desea eliminar al usuario?')");
                lbEliminar.Command += new CommandEventHandler(lbEliminar_Click);
                lbEliminar.CommandArgument = usu.getId().ToString();
                PanelUsuarios.Controls.Add(lbEliminar);
                PanelUsuarios.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));

                PanelUsuarios.Controls.Add(new LiteralControl("</p>"));
            }
        }

        protected void lbEliminar_Click(object sender, EventArgs e)
        {
            try
            {
                LinkButton lbtSender = (LinkButton)sender;
                if (Usuario.esAdministrador(lbtSender.CommandArgument))
                {
                    LabelError.Text = "ERROR. No se puede eliminar al administrador.";
                }
                else
                {
                    Usuario usu = new Usuario(lbtSender.CommandArgument);
                    usu.eliminarUsuarioLogico();
                    Page_Load(sender, e);
                }
            }
            catch (SqlException)
            {
                LabelError.Text = "ERROR. No se ha podido eliminar el usuario";
            }
        }

        protected void ButtonAnterior_Click(object sender, EventArgs e)
        {
            l = Usuario.getUsuarios(Request.Params["filtro"], Request.Params["valorfiltro"]);
            int numUsuarios = l.Count;
            int numPaginas = Usuario.numPaginas(numUsuarios, Request.Params["numUsuPag"]);
            Int32 pagSelecc = Int32.Parse(Request.Params["pag"]);
            Int32 anterior = 0;
            if (Int32.Parse(Request.Params["pag"]) > 0)
            {
                anterior = Int32.Parse(Request.Params["pag"]) - 1;
            }
            Response.Redirect("GestionarUsuarios.aspx?pag="+anterior.ToString()+"&filtro="+Request.Params["filtro"]+"&valorfiltro="+
                Request.Params["valorfiltro"]+"&numUsuPag="+Request.Params["numUsuPag"]);
        }

        protected void ButtonSiguiente_Click(object sender, EventArgs e)
        {
            int numUsuarios = l.Count;
            int numPaginas = Usuario.numPaginas(numUsuarios, Request.Params["numUsuPag"]);
            Int32 pagSelecc = Int32.Parse(Request.Params["pag"]);
            Int32 siguiente = (Int32)numPaginas - 1;
            if (Int32.Parse(Request.Params["pag"]) < (numPaginas - 1))
            {
                siguiente = Int32.Parse(Request.Params["pag"]) + 1;
            }
            Response.Redirect("GestionarUsuarios.aspx?pag=" + siguiente.ToString() + "&filtro=" + Request.Params["filtro"] + "&valorfiltro=" +
                Request.Params["valorfiltro"] + "&numUsuPag=" + Request.Params["numUsuPag"]);

        }
    }
}
