﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using DivulgacionCientifica;
using DivulgacionCientifica.CapaNegocio;
using System.Data.SqlClient;
using System.Collections.Generic;
using System.IO;

namespace WebApplicationFloral
{
    public partial class WebFormInicio : System.Web.UI.Page
    {
        Usuario currentUser;
        Publicacion not, hecho;

        protected void Page_Load(object sender, EventArgs e)
        {            
            try
            {
                LabelMensaje.Text = "";
                currentUser = new Usuario(HttpContext.Current.User.Identity.Name);
                cargarTemas();
                cargarPanelNewsNO();
                if (HttpContext.Current.User.Identity.Name.Equals(""))
                {
                    MenuAdministrador.Visible = false;
                    MenuUsuario.Visible = false;
                    LinkButtonCerrar.Visible = false;
                    PanelNews.Visible = false;
                    PanelNewsNO.Visible = true;
                }
                else if (!Usuario.esAdministrador(currentUser.getId()))
                {
                    MenuAdministrador.Visible = false;
                    MenuItem darDeBaja = new MenuItem();
                    darDeBaja.Text = "Dar de baja";
                    darDeBaja.NavigateUrl = "DarBaja.aspx";
                    MenuUsuario.Items.Add(darDeBaja);

                    HyperLinkRegistro.Visible = false;
                    PanelNews.Visible = true;
                    PanelNewsNO.Visible = false;
                    cargarDatosUsuarioEnInicio();
                }
                else
                {
                    PanelMenuUsuario.Visible = true;
                    HyperLinkRegistro.Visible = false;
                    PanelNews.Visible = true;
                    PanelNewsNO.Visible = false;
                    cargarDatosUsuarioEnInicio();
                }
                PanelNoticia.Controls.Clear();
                cargarNoticia();
                PanelHecho.Controls.Clear();
                cargarHecho();

            }
            catch (SqlException exp)
            {
                LabelMensaje.Text = exp.Message;
            }
        }

        protected void ButtonAceptar_Click(object sender, EventArgs e)
        {
            try
            {
                if (Usuario.credencialesCorrectos(TextBoxUsuario.Text, TextBoxContrasena.Text))
                {
                    Usuario u = new Usuario(TextBoxUsuario.Text);
                    cargarDatosUsuarioEnInicio();
                    FormsAuthentication.RedirectFromLoginPage(u.getId(), false);
                }
                else
                {
                    LabelMensaje.Text = "ERROR. Usuario o contraseña incorrectos";
                }
            }
            catch (SqlException)
            {
                LabelMensaje.Text = "ERROR. Relacionado con la base de datos";
            }
        }

        protected void LinkButtonCerrar_Click(object sender, EventArgs e)
        {
            FormsAuthentication.SignOut();
            LabelInicio.Text = "Inicio";
            LabelIniciaCierra.Text = "INICIAR SESIÓN";
            LabelUsuario.Text = "Usuario";
            TextBoxUsuario.Visible = true;
            LabelContrasena.Text = "Contraseña";
            TextBoxContrasena.Visible = true;
            ButtonAceptar.Visible = true;
            HyperLinkOlvide.Visible = true;
            MenuAdministrador.Visible = false;
            PanelMenuUsuario.Visible = false;
            HyperLinkRegistro.Visible = true;
            PanelNews.Visible = false;
            PanelNewsNO.Visible = true;
            LinkButtonCerrar.Visible = false;
            HyperLinkOlvide.Text = "Olvidé mi contraseña";
            HyperLinkOlvide.NavigateUrl = Request.Url.GetLeftPart(UriPartial.Authority) + "/OlvideContrasena.aspx";
        }
    
        public void cargarDatosUsuarioEnInicio()
        {
            try
            {
                LabelInicio.Text = "Bienvenido, " + currentUser.getId();
                LabelIniciaCierra.Text = "Novedades en sus publicaciones";
                int numNovedades = (int)Comentario.numComentariosSinLeer(currentUser);
                if (numNovedades == 0)
                {
                    LabelMensaje.Text = "";
                    HyperLinkOlvide.Text = "";
                    LabelContrasena.Text = "No tiene ningun comentario nuevo en sus publicaciones.";
                }
                else
                {
                    LabelMensaje.Text = "";
                    if (numNovedades == 1) { LabelContrasena.Text = "Tiene 1 comentario no leído en sus publicaciones"; }
                    else { LabelContrasena.Text = "Tiene " + numNovedades + " comentarios no leídos en sus publicaciones"; }
                    HyperLinkOlvide.Text = "Ver mis comentarios no leídos";
                    HyperLinkOlvide.NavigateUrl = Request.Url.GetLeftPart(UriPartial.Authority) + 
                        "/MisPublicaciones.aspx?pag=0&filtro=Todos&numNotPag=5&idUsu="
                        + currentUser.getId() + "&todas=no";
                }
                TextBoxUsuario.Visible = false;
                LabelUsuario.Text = "";
                TextBoxContrasena.Visible = false;
                ButtonAceptar.Visible = false;
            }
            catch (SqlException)
            {
                LabelMensaje.Text = "ERROR. No se han podido cargar sus datos";
            }
        }

        private void cargarTemas()
        {
            try
            {
                List<Tema> lista = Tema.getTodosTemas();
                foreach (Tema tema in lista)
                {
                    HyperLink mit = new HyperLink();
                    mit.NavigateUrl = Request.Url.GetLeftPart(UriPartial.Authority) + "/ListarPublicaciones.aspx?pag=0&filtroTema=" + tema.getNombre() +
                        "&filtroAutor=Todos&contenido=&categ=Todas&numNotPag=5";
                    mit.Text = tema.getNombre() + "  ";
                    PanelTemas.Controls.Add(mit);
                }
            }
            catch (SqlException)
            {
                LabelMensaje.Text = "ERROR. No se han podido cargar los temas.";
            }
        }

        private void cargarNoticia()
        {
            try
            {
                not = Publicacion.getAleatoria("Noticias");

                PanelNoticia.Controls.Add(new LiteralControl("<div style=\"margin-left: 10px; margin-right: 10px; text-align: justify;\">"));
                if (not == null)
                {
                    PanelNoticia.Controls.Add(new LiteralControl("<br />No se han encontrado noticias."));
                }
                else
                {
                    LabelTituloNoticia.Text = not.getTitulo();
                    if (not.getImagen() != null)
                    {
                        if (not.getContenido().Length < 620)
                        {
                            //No muestra la imagen porque se saldria del recuadro ya que el texto es muy pequeño y por tanto el recuadro tb
                        }
                        else
                        {
                            PanelNoticia.Controls.Add(new LiteralControl("<div class=\"templatemo_img_texto\">"));
                            string url = not.getImagen();
                            Image img = new Image();
                            img.ID = "ImageNoticia";
                            img.ImageUrl = not.getImagen();
                            PanelNoticia.Controls.Add(img);
                            PanelNoticia.Controls.Add(new LiteralControl("</div>"));
                        }
                    }
                    PanelNoticia.Controls.Add(new LiteralControl("<p>"));
                    PanelNoticia.Controls.Add(new LiteralControl(Auxiliares.textoPlanoAHtml(Auxiliares.vistaPreviaTextoPlano(
                        Auxiliares.htmlATextoPlano(not.getContenido()), 15, 1200))));
                    hpLeerMas.NavigateUrl = "VisualizarPublicacion.aspx?id=" + not.getID();
                    PanelNoticia.Controls.Add(new LiteralControl("</p>"));
                }
                PanelNoticia.Controls.Add(new LiteralControl("</div>"));
            }
            catch (SqlException)
            {
                PanelNoticia.Controls.Add(new LiteralControl("<div style=\"margin-left: 10px; margin-right: 10px; text-align: justify;\">"));
                PanelNoticia.Controls.Add(new LiteralControl("<br />ERROR al cargar la publicacion"));
                PanelNoticia.Controls.Add(new LiteralControl("</div>"));
            }
        }

        private void cargarHecho()
        {
            try
            {
                hecho = Publicacion.getAleatoria("Hechos");

                if (hecho == null)
                {
                    PanelHecho.Controls.Add(new LiteralControl("&nbsp &nbsp No se han encontrado hechos."));
                }
                else
                {
                    LabelTitulo2.Text = hecho.getTitulo();
                    if (hecho.getImagen() != null)
                    {
                        if (hecho.getContenido().Length < 620)
                        {
                            //No muestra la imagen porque se saldria del recuadro ya que el texto es muy pequeño y por tanto el recuadro tb
                        }
                        else
                        {
                            PanelHecho.Controls.Add(new LiteralControl("<div class=\"templatemo_img_texto\">"));
                            PanelHecho.Controls.Add(new LiteralControl("<img src=\"" + hecho.getImagen() + "\" />"));
                            PanelHecho.Controls.Add(new LiteralControl("</div>"));
                        }

                    }
                    PanelHecho.Controls.Add(new LiteralControl("<p>"));
                    PanelHecho.Controls.Add(new LiteralControl(Auxiliares.textoPlanoAHtml(Auxiliares.vistaPreviaTextoPlano(
                        Auxiliares.htmlATextoPlano(hecho.getContenido()), 15, 300))));
                    hpLeer2.NavigateUrl = "VisualizarPublicacion.aspx?id=" + hecho.getID();
                    PanelHecho.Controls.Add(new LiteralControl("</p>"));
                }
            }
            catch (SqlException)
            {
                PanelHecho.Controls.Add(new LiteralControl("ERROR al cargar el hecho."));
            }
        }

        public void cargarPanelNewsNO()
        {
            try
            {
                //No funciona si la imagen tiene espacios, debo no consentir que se guarde con espacios
                Archivo arch = Archivo.getImagen();
                if (arch != null)
                {
                    string nombre = arch.getRuta().Substring(arch.getRuta().LastIndexOf(Path.DirectorySeparatorChar) + 1);
                    string URL = Request.Url.GetLeftPart(UriPartial.Authority) + "/Archivos/" + nombre;

                    PanelNewsNO.Controls.Add(new LiteralControl("<div class=\"templatemo_left_top\" style=\"text-align: center\">"));
                    PanelNewsNO.Controls.Add(new LiteralControl("&nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp"));
                    PanelNewsNO.Controls.Add(new LiteralControl("<a href=\"VisualizarPublicacion.aspx?id="+arch.getPublicac().getID()+"\">"));
                    PanelNewsNO.Controls.Add(new LiteralControl("<img src=\"" + URL + "\" />"));
                    PanelNewsNO.Controls.Add(new LiteralControl("</a>"));
                    PanelNewsNO.Controls.Add(new LiteralControl("<p style=\"text-align: center color: #008000; font-weight: bold;\">&nbsp;&nbsp;&nbsp;"+
                        "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
                        +arch.getPublicac().getTitulo()+"</p>"));
                    PanelNewsNO.Controls.Add(new LiteralControl("</div>"));
                }
            }
            catch (SqlException)
            {
            }
        }
    }
}
