﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using DivulgacionCientifica.CapaNegocio;
using System.Data.SqlClient;
using System.Collections.Generic;

namespace DivulgacionCientifica
{
    public partial class ListarPublicaciones : System.Web.UI.Page
    {
        string idCurrentUser = HttpContext.Current.User.Identity.Name;

        protected void Page_Load(object sender, EventArgs e)
        {
            try
            {
                if ((Request.Params["pag"] == null) || (Request.Params["filtroTema"] == null)
                    || (Request.Params["numNotPag"] == null))
                {
                    Response.Redirect(Estatica.getUrlProyecto + "ListarPublicaciones.aspx?pag=0&filtroTema=Todos&filtroAutor=Todos&contenido=&categ=Todas&numNotPag=5");
                }
                else if (DropDownListTemas.Items.Count == 0)
                {
                    PanelError.Visible = false;

                    DropDownListTemas.Items.Add("Todos");
                    Auxiliares.cargarTemas(DropDownListTemas);
                    DropDownListTemas.Items.FindByText(Request.Params["filtroTema"]).Selected = true;

                    DropDownListAutores.Items.Add("Todos");
                    Auxiliares.cargarUsuarios(DropDownListAutores);
                    DropDownListAutores.Items.FindByText(Request.Params["filtroAutor"]).Selected = true;

                    TextBoxContenido.Text = Request.Params["contenido"];

                    string cat;
                    if (Request.Params["categ"] == null)
                    {
                        cat = "Todas";
                    }
                    else
                    {
                        cat = Request.Params["categ"];
                    }
                    RadioButtonList1.Items.FindByText(cat).Selected = true;

                    DropDownListNotPag.Items.FindByText(Request.Params["numNotPag"]).Selected = true;
                }

                int pagActual = Int32.Parse(Request.Params[0]);
                //Lista de publicaciones que se muestran en la pagina actual, depende de los filtros y del numero de Publicaciones por pagina
                List<Publicacion> listaPublicaciones = Publicacion.getPublics(pagActual, Request.Params["filtroTema"],
                    Request.Params["filtroAutor"], Request.Params["contenido"], Request.Params["categ"],
                    Int32.Parse(Request.Params["numNotPag"]));
                if (listaPublicaciones.Count > 0)
                {
                    PanelNoPublicaciones.Visible = false;
                    PanelPublicaciones.Visible = true;
                    PanelPublicaciones.Controls.Clear();
                    cargarPublicaciones(listaPublicaciones);
                    int numPags = Publicacion.numPaginas(Request.Params["filtroTema"],
                        Request.Params["filtroAutor"], Request.Params["contenido"], Request.Params["categ"],
                    Int32.Parse(Request.Params["numNotPag"]));

                    LabelPaginador.Text = (Int32.Parse(Request.Params["pag"]) + 1) + " de " + numPags;
                    LabelPaginador2.Text = (Int32.Parse(Request.Params["pag"]) + 1) + " de " + numPags;
                    if (numPags > 1)
                    {
                        PanelPaginadorSup.Visible = true;
                        PanelPaginadorInf.Visible = true;
                    }
                    else
                    {
                        PanelPaginadorSup.Visible = false;
                        PanelPaginadorInf.Visible = false;
                    }
                }
                else
                {
                    PanelNoPublicaciones.Visible = true;
                    PanelPublicaciones.Visible = false;
                    PanelPaginadorSup.Visible = false;
                    PanelPaginadorInf.Visible = false;
                }

            }
            catch (SqlException)
            {
                PanelNoPublicaciones.Visible = false;
                PanelPublicaciones.Visible = false;
                PanelPaginadorInf.Visible = false;
                PanelPaginadorSup.Visible = false;
                PanelError.Visible = true;
            }
            catch (NullReferenceException)
            {
                LabelError.Text = "ERROR. Página no disponible.";
            }
        }

        protected void ButtonBuscar_Click(object sender, EventArgs e)
        {
            Response.Redirect(Request.Url.GetLeftPart(UriPartial.Authority) + "/ListarPublicaciones.aspx?pag=0&filtroTema="+DropDownListTemas.SelectedItem.Text+
                "&filtroAutor="+DropDownListAutores.SelectedItem.Text+"&contenido="+TextBoxContenido.Text+
                "&categ="+RadioButtonList1.SelectedItem.Text + "&numNotPag=" + DropDownListNotPag.SelectedItem.Text);
        }

        public void cargarPublicaciones(List<Publicacion> listaPublicaciones)
        {
            foreach (Publicacion pub in listaPublicaciones)
            {
                //Titulo
                PanelPublicaciones.Controls.Add(new LiteralControl("<h3 style=\"margin-right: 70px; margin-left: 70px\">"));
                HyperLink hpTitulo = new HyperLink();
                hpTitulo.ID = "hpTitulo" + pub.getID();
                hpTitulo.Text = pub.getTitulo();
                hpTitulo.NavigateUrl = Request.Url.GetLeftPart(UriPartial.Authority) + "/VisualizarPublicacion.aspx?id=" + pub.getID();
                hpTitulo.ForeColor = System.Drawing.Color.ForestGreen;
                PanelPublicaciones.Controls.Add(hpTitulo);
                PanelPublicaciones.Controls.Add(new LiteralControl("</h3>"));

                //Contenido
                PanelPublicaciones.Controls.Add(new LiteralControl("<div class=\"vprevia\">"));
                string textoPrevio = Auxiliares.textoPlanoAHtml(Auxiliares.vistaPreviaTextoPlano(
                    Auxiliares.htmlATextoPlano(pub.getContenido()), 15, 900));
                if (pub.getImagen() != null)
                {
                    if (textoPrevio.Length < 300)
                    {
                        //No muestra la imagen porque se saldria del recuadro ya que el texto es muy pequeño y por tanto el recuadro tb
                    }
                    else
                    {
                        PanelPublicaciones.Controls.Add(new LiteralControl("<div class=\"templatemo_img_texto\">"));
                        PanelPublicaciones.Controls.Add(new LiteralControl("<img src=\"" + pub.getImagen() + "\" />"));
                        PanelPublicaciones.Controls.Add(new LiteralControl("</div>"));
                    }

                }
                PanelPublicaciones.Controls.Add(new LiteralControl("<p>"));
                PanelPublicaciones.Controls.Add(new LiteralControl(textoPrevio));
                PanelPublicaciones.Controls.Add(new LiteralControl("</p>"));
                PanelPublicaciones.Controls.Add(new LiteralControl("</div>"));

                //Datos varios
                PanelPublicaciones.Controls.Add(new LiteralControl("<div class=\"vprevia\">"));
                PanelPublicaciones.Controls.Add(new LiteralControl("<p style=\"font-family: 'trebuchet MS'; left: 5px; font-size: x-small; right: 5px; color: #808080;\">"));
                string autor = pub.getCreador().getNombre();
                string ocupacion = pub.getCreador().getOcupacion();
                PanelPublicaciones.Controls.Add(new LiteralControl("Publicada por " + autor + " ("+ocupacion+") el " 
                    + pub.getFechaCreacion().ToString()));
                PanelPublicaciones.Controls.Add(new LiteralControl("</p>"));

                //Opciones
                HyperLink hpVer = new HyperLink();
                hpVer.ID = "hpVer" + pub.getID();
                hpVer.Text = "Ver";
                hpVer.NavigateUrl = "VisualizarPublicacion.aspx?id=" + pub.getID();
                PanelPublicaciones.Controls.Add(hpVer);
                PanelPublicaciones.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));

                if (idCurrentUser.Equals(pub.getCreador().getId()))
                {
                    if (Usuario.esAdministrador(idCurrentUser))
                    {
                        HyperLink hpEditar = new HyperLink();
                        hpEditar.ID = "hpEditar" + pub.getID();
                        hpEditar.Text = "Editar";
                        hpEditar.NavigateUrl = "EditarPublicAdmin.aspx?id=" + pub.getID();
                        PanelPublicaciones.Controls.Add(hpEditar);
                        PanelPublicaciones.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));

                        LinkButton lbEliminar = new LinkButton();
                        lbEliminar.ID = "lbEliminar" + pub.getID();
                        lbEliminar.Text = "Eliminar";
                        lbEliminar.Attributes.Add("language", "javascript");
                        lbEliminar.Attributes.Add("OnClick", "return confirm('¿Esta seguro que desea eliminar la publicación?')");
                        lbEliminar.Command += new CommandEventHandler(lbEliminar_Click);
                        lbEliminar.CommandArgument = pub.getID().ToString();
                        PanelPublicaciones.Controls.Add(lbEliminar);
                        PanelPublicaciones.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));

                        LinkButton lbEliminarFeed = new LinkButton();
                        lbEliminarFeed.ID = "lbEliminarFeed" + pub.getID();
                        lbEliminarFeed.Text = "Eliminar del feed";
                        lbEliminarFeed.Attributes.Add("language", "javascript");
                        lbEliminarFeed.Attributes.Add("OnClick", "return confirm('¿Esta seguro que desea eliminar la publicación del feed RSS? Recuerde que si no se encontraba en el feed esta accion no tendrá ningún efecto.')");
                        lbEliminarFeed.Command += new CommandEventHandler(lbEliminarFeed_Click);
                        lbEliminarFeed.CommandArgument = pub.getID().ToString();
                        PanelPublicaciones.Controls.Add(lbEliminarFeed);
                        PanelPublicaciones.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));
                    }
                    else
                    {
                        HyperLink hpEditar = new HyperLink();
                        hpEditar.ID = "hpEditar" + pub.getID();
                        hpEditar.Text = "Editar";
                        hpEditar.NavigateUrl = "EditarPublicUsu.aspx?id=" + pub.getID();
                        PanelPublicaciones.Controls.Add(hpEditar);
                        PanelPublicaciones.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));

                        LinkButton lbEliminar = new LinkButton();
                        lbEliminar.ID = "lbEliminar" + pub.getID();
                        lbEliminar.Text = "Eliminar";
                        lbEliminar.Attributes.Add("language", "javascript");
                        lbEliminar.Attributes.Add("OnClick", "return confirm('¿Esta seguro que desea eliminar la publicación?')");
                        lbEliminar.Command += new CommandEventHandler(lbEliminar_Click);
                        lbEliminar.CommandArgument = pub.getID().ToString();
                        PanelPublicaciones.Controls.Add(lbEliminar);
                        PanelPublicaciones.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));
                    }

                    if (pub.tieneComentarios())
                    {
                        HyperLink hpAnadirObserv = new HyperLink();
                        hpAnadirObserv.ID = "hpVerComent" + pub.getID();
                        int numNL = (int)pub.numComentariosNoLeidas();
                        if (numNL == 0)
                        {
                            hpAnadirObserv.Text = "Ver Comentarios";
                        }
                        else if (numNL == 1)
                        {
                            hpAnadirObserv.Text = "Ver Comentarios (1 no leído)";
                        }
                        else
                        {
                            hpAnadirObserv.Text = "Ver Comentarios (" + numNL + " no leídos)";
                        }
                        hpAnadirObserv.NavigateUrl = "VerComentarios.aspx?id=" + pub.getID();
                        PanelPublicaciones.Controls.Add(hpAnadirObserv);
                    }

                    PanelPublicaciones.Controls.Add(new LiteralControl("<br />"));
                    PanelPublicaciones.Controls.Add(new LiteralControl("<br />"));
                }
                else
                {
                    if (Usuario.esAdministrador(idCurrentUser))
                    {
                        HyperLink hpEditar = new HyperLink();
                        hpEditar.ID = "hpEditar" + pub.getID();
                        hpEditar.Text = "Editar";
                        hpEditar.NavigateUrl = "EditarPublicAdmin.aspx?id=" + pub.getID();
                        PanelPublicaciones.Controls.Add(hpEditar);
                        PanelPublicaciones.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));

                        LinkButton lbEliminar = new LinkButton();
                        lbEliminar.ID = "lbEliminar" + pub.getID();
                        lbEliminar.Text = "Eliminar";
                        lbEliminar.Attributes.Add("language", "javascript");
                        lbEliminar.Attributes.Add("OnClick", "return confirm('¿Esta seguro que desea eliminar la publicación?')");
                        lbEliminar.Command += new CommandEventHandler(lbEliminar_Click);
                        lbEliminar.CommandArgument = pub.getID().ToString();
                        PanelPublicaciones.Controls.Add(lbEliminar);
                        PanelPublicaciones.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));

                        LinkButton lbEliminarFeed = new LinkButton();
                        lbEliminarFeed.ID = "lbEliminarFeed" + pub.getID();
                        lbEliminarFeed.Text = "Eliminar del feed";
                        lbEliminarFeed.Attributes.Add("language", "javascript");
                        lbEliminarFeed.Attributes.Add("OnClick", "return confirm('¿Esta seguro que desea eliminar la publicación del feed RSS? Recuerde que si no se encontraba en el feed esta accion no tendrá ningún efecto.')");
                        lbEliminarFeed.Command += new CommandEventHandler(lbEliminarFeed_Click);
                        lbEliminarFeed.CommandArgument = pub.getID().ToString();
                        PanelPublicaciones.Controls.Add(lbEliminarFeed);
                        PanelPublicaciones.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));

                        if (pub.tieneComentarios())
                        {
                            HyperLink hpAnadirObserv = new HyperLink();
                            hpAnadirObserv.ID = "hpVerComent" + pub.getID();
                            int numNL = (int)pub.numComentariosNoLeidas();
                            if (numNL == 0)
                            {
                                hpAnadirObserv.Text = "Ver Comentarios";
                            }
                            else if (numNL == 1)
                            {
                                hpAnadirObserv.Text = "Ver Comentarios (1 no leído)";
                            }
                            else
                            {
                                hpAnadirObserv.Text = "Ver Comentarios (" + numNL + " no leídos)";
                            }
                            hpAnadirObserv.NavigateUrl = "VerComentarios.aspx?id=" + pub.getID();
                            PanelPublicaciones.Controls.Add(hpAnadirObserv);
                            PanelPublicaciones.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));
                        }
                    }
                    if (!idCurrentUser.Equals(""))
                    {
                        HyperLink hpAnadirObserv = new HyperLink();
                        hpAnadirObserv.ID = "hpAnadirObserv" + pub.getID();
                        hpAnadirObserv.Text = "Añadir comentario";
                        hpAnadirObserv.NavigateUrl = "AnadirComentario.aspx?id=" + pub.getID();
                        PanelPublicaciones.Controls.Add(hpAnadirObserv);
                        PanelPublicaciones.Controls.Add(new LiteralControl("<br />"));
                        PanelPublicaciones.Controls.Add(new LiteralControl("<br />"));
                    }
                }
                PanelPublicaciones.Controls.Add(new LiteralControl("</div>"));
            }

        }

        protected void ButtonAnterior_Click(object sender, EventArgs e)
        {
            int pag = paginaAnterior();
            Response.Redirect(Request.Url.GetLeftPart(UriPartial.Authority) + "/ListarPublicaciones.aspx?pag="+pag+"&filtroTema="+Request.Params["filtroTema"]+
                "&filtroAutor=" + Request.Params["filtroAutor"] + "&contenido=" + Request.Params["contenido"] + "&categ=" + Request.Params["categ"]+
                "&numNotPag=" + Request.Params["numNotPag"]);
        }

        protected void ButtonSiguiente_Click(object sender, EventArgs e)
        {
            int pag = paginaSiguiente();
            Response.Redirect(Request.Url.GetLeftPart(UriPartial.Authority) + "/ListarPublicaciones.aspx?pag=" + pag + "&filtroTema=" + Request.Params["filtroTema"] +
                "&filtroAutor=" + Request.Params["filtroAutor"] + "&contenido=" + Request.Params["contenido"] + "&categ=" + 
                Request.Params["categ"] + "&numNotPag=" + Request.Params["numNotPag"]);
        }

        public int paginaSiguiente()
        {
            Int32 actual = Int32.Parse(Request.Params[0]);
            //Depende del filtro (para obtener el numero de publicaciones) y del numero de publicaciones por pagina
            //No confundir con que numPaginas es ListaPublicaciones.Count aunque ambas funciones reciban los mismos parametros
            //ListaPublicaciones contendra numNotPag elementos y numPaginas seran el numero de paginas
            int numPaginas = Publicacion.numPaginas(Request.Params["filtroTema"],
                        Request.Params["filtroAutor"], Request.Params["contenido"], Request.Params["categ"],
                        Int32.Parse(Request.Params["numNotPag"]));
            Int32 siguiente = (Int32)numPaginas - 1;
            if (actual < (numPaginas - 1))
            {
                siguiente = actual + 1;
            }
            return siguiente;
        }

        public int paginaAnterior()
        {
            Int32 actual = Int32.Parse(Request.Params[0]);
            Int32 anterior = 0;
            if (actual > 0)
            {
                anterior = actual - 1;
            }
            return anterior;
        }

        public void lbEliminar_Click(object sender, EventArgs e)
        {
            try
            {
                LinkButton lbtSender = (LinkButton)sender;
                int idPub = Int32.Parse(lbtSender.CommandArgument);
                Publicacion pub = new Publicacion(idPub);
                pub.eliminarPublicLogico();
                Page_Load(sender, e);
            }
            catch (SqlException)
            {
                LabelError.Text = "ERROR. No se ha podido eliminar la publicación";
            }
        }

        public void lbEliminarFeed_Click(object sender, EventArgs e)
        {
            try
            {
                LinkButton lbtSender = (LinkButton)sender;
                int idPub = Int32.Parse(lbtSender.CommandArgument);
                Publicacion pub = new Publicacion(idPub);
                pub.eliminarDeLosFeeds();
                Page_Load(sender, e);
            }
            catch (SqlException)
            {
                LabelError.Text = "ERROR. No se ha podido eliminar la publicación";
            }
        }
    }
}
