﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using DivulgacionCientifica.CapaNegocio;
using System.Data.SqlClient;
using System.Collections.Generic;

namespace DivulgacionCientifica
{
    public partial class MisPublicaciones : System.Web.UI.Page
    {
        int numPaginas;
        string idCurrentUser = HttpContext.Current.User.Identity.Name;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (idCurrentUser.Equals(""))
            {
                Response.Redirect("~\\SolicitarAutenticacion.aspx");
            }
            else if ((Request.Params["pag"] == null) || (Request.Params["filtro"] == null)
                    || (Request.Params["numNotPag"] == null)){
                Response.Redirect(Estatica.getUrlProyecto+"MisPublicaciones.aspx?pag=0&filtro=Todos&numNotPag=5&idUsu="+idCurrentUser+"&todas=si");
            }
            else
            {
                PanelPublic.Controls.Clear();
                PanelError.Visible = false;
                PanelNoPublic.Visible = false;
                if (DropDownListTemas.Items.Count == 0)
                {
                    DropDownListTemas.Items.Clear();
                    DropDownListTemas.Items.Add("Todos");
                    Auxiliares.cargarTemas(DropDownListTemas);
                    if ((Request.Params["filtro"] != null) && (Request.Params["numNotPag"] != null))
                    {
                        string tema = Request.Params["filtro"];
                        DropDownListTemas.Items.FindByText(tema).Selected = true;
                        DropDownListNotPag.Items.FindByText(Request.Params["numNotPag"]).Selected = true;
                    }
                    if (!Request.Params["todas"].Equals("si"))
                    {
                        rbtListTodas.Items[1].Selected = true;
                    }
                }
                PanelPublic.Controls.Clear();
                cargarPublicaciones();
            }
        }

        private void cargarPublicaciones()
        {
            try
            {
                numPaginas = Publicacion.numPaginas(Request.Params["filtro"], Request.Params["idUsu"], 
                    Int32.Parse(Request.Params["numNotPag"]), Request.Params["todas"]);
                if (numPaginas <= 1)
                {
                    PanelPaginadorSup.Visible = false;
                    PanelInf.Visible = false;
                }
                else
                {
                    LabelPaginador.Text = (Int32.Parse(Request.Params["pag"]) + 1) + " de " + numPaginas;
                    LabelPaginador2.Text = (Int32.Parse(Request.Params["pag"]) + 1) + " de " + numPaginas;
                }
                List<Publicacion> listaPublicaciones = Publicacion.getPublics(Request.Params["filtro"],
                    Int32.Parse(Request.Params["pag"]), Request.Params["numNotPag"],
                    Request.Params["todas"], Request.Params["idUsu"]);
                if (listaPublicaciones.Count == 0)
                {
                    PanelNoPublic.Visible = true;
                }
                else
                {
                    foreach (Publicacion pub in listaPublicaciones)
                    {
                        //Titulo
                        PanelPublic.Controls.Add(new LiteralControl("<h3 style=\"margin-right: 70px; margin-left: 70px\">"));
                        HyperLink hpTitulo = new HyperLink();
                        hpTitulo.ID = "hpTitulo" + pub.getID();
                        hpTitulo.Text = pub.getTitulo();
                        hpTitulo.NavigateUrl = Estatica.getUrlProyecto + "VisualizarPublicacion.aspx?id=" + pub.getID();
                        hpTitulo.ForeColor = System.Drawing.Color.ForestGreen;
                        PanelPublic.Controls.Add(hpTitulo);
                        PanelPublic.Controls.Add(new LiteralControl("</h3>"));

                        //Contenido
                        string textoPrevio = Auxiliares.textoPlanoAHtml(Auxiliares.vistaPreviaTextoPlano(
                            Auxiliares.htmlATextoPlano(pub.getContenido()), 15, 900));
                        PanelPublic.Controls.Add(new LiteralControl("<div class=\"vprevia\">"));
                        if (pub.getImagen() != null)
                        {
                            if (textoPrevio.Length < 300)
                            {
                                //No muestra la imagen porque se saldria del recuadro ya que el texto es muy pequeño y por tanto el recuadro tb
                            }
                            else
                            {
                                PanelPublic.Controls.Add(new LiteralControl("<div class=\"templatemo_img_texto\">"));
                                PanelPublic.Controls.Add(new LiteralControl("<img src=\"" + pub.getImagen() + "\" />"));
                                PanelPublic.Controls.Add(new LiteralControl("</div>"));
                            }
                        }
                        PanelPublic.Controls.Add(new LiteralControl("<p>"));
                        PanelPublic.Controls.Add(new LiteralControl(textoPrevio));
                        PanelPublic.Controls.Add(new LiteralControl("</p>"));
                        PanelPublic.Controls.Add(new LiteralControl("</div>"));

                        //Datos varios
                        PanelPublic.Controls.Add(new LiteralControl("<div class=\"vprevia\">"));
                        PanelPublic.Controls.Add(new LiteralControl("<p style=\"font-family: 'trebuchet MS'; left: 5px; font-size: x-small; right: 5px; color: #808080;\">"));
                        PanelPublic.Controls.Add(new LiteralControl("Publicada el " + pub.getFechaCreacion().ToString()));
                        PanelPublic.Controls.Add(new LiteralControl("</p></div>"));

                        //Opciones
                        PanelPublic.Controls.Add(new LiteralControl("<div class=\"vprevia\">"));
                        HyperLink hpVer = new HyperLink();
                        hpVer.ID = "hpVer" + pub.getID();
                        hpVer.Text = "Ver";
                        hpVer.NavigateUrl = "VisualizarPublicacion.aspx?id=" + pub.getID();
                        PanelPublic.Controls.Add(hpVer);
                        PanelPublic.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));

                        if (idCurrentUser.Equals(pub.getCreador().getId()))
                        {
                            if (Usuario.esAdministrador(idCurrentUser))
                            {
                                HyperLink hpEditar = new HyperLink();
                                hpEditar.ID = "hpEditar" + pub.getID();
                                hpEditar.Text = "Editar";
                                hpEditar.NavigateUrl = "EditarPublicAdmin.aspx?id=" + pub.getID();
                                PanelPublic.Controls.Add(hpEditar);
                                PanelPublic.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));

                                LinkButton lbEliminar = new LinkButton();
                                lbEliminar.ID = "lbEliminar" + pub.getID();
                                lbEliminar.Text = "Eliminar";
                                lbEliminar.Attributes.Add("language", "javascript");
                                lbEliminar.Attributes.Add("OnClick", "return confirm('¿Esta seguro que desea eliminar la publicación?')");
                                lbEliminar.Command += new CommandEventHandler(lbEliminar_Click);
                                lbEliminar.CommandArgument = pub.getID().ToString();
                                PanelPublic.Controls.Add(lbEliminar);
                                PanelPublic.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));

                                LinkButton lbEliminarFeed = new LinkButton();
                                lbEliminarFeed.ID = "lbEliminarFeed" + pub.getID();
                                lbEliminarFeed.Text = "Eliminar del feed";
                                lbEliminarFeed.Attributes.Add("language", "javascript");
                                lbEliminarFeed.Attributes.Add("OnClick", "return confirm('¿Esta seguro que desea eliminar la publicación del feed RSS? Recuerde que si no se encontraba en el feed esta accion no tendrá ningún efecto.')");
                                lbEliminarFeed.Command += new CommandEventHandler(lbEliminarFeed_Click);
                                lbEliminarFeed.CommandArgument = pub.getID().ToString();
                                PanelPublic.Controls.Add(lbEliminarFeed);
                                PanelPublic.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));
                            }
                            else
                            {
                                HyperLink hpEditar = new HyperLink();
                                hpEditar.ID = "hpEditar" + pub.getID();
                                hpEditar.Text = "Editar";
                                hpEditar.NavigateUrl = "EditarPublicUsu.aspx?id=" + pub.getID();
                                PanelPublic.Controls.Add(hpEditar);
                                PanelPublic.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));

                                LinkButton lbEliminar = new LinkButton();
                                lbEliminar.ID = "lbEliminar" + pub.getID();
                                lbEliminar.Text = "Eliminar";
                                lbEliminar.Attributes.Add("language", "javascript");
                                lbEliminar.Attributes.Add("OnClick", "return confirm('¿Esta seguro que desea eliminar la publicación?')");
                                lbEliminar.Command += new CommandEventHandler(lbEliminar_Click);
                                lbEliminar.CommandArgument = pub.getID().ToString();
                                PanelPublic.Controls.Add(lbEliminar);
                                PanelPublic.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));
                            }

                            if (pub.tieneComentarios())
                            {
                                HyperLink hpAnadirObserv = new HyperLink();
                                hpAnadirObserv.ID = "hpVerComent" + pub.getID();
                                int numNL = (int)pub.numComentariosNoLeidas();
                                if (numNL == 0)
                                {
                                    hpAnadirObserv.Text = "Ver Comentarios";
                                }
                                else if (numNL == 1)
                                {
                                    hpAnadirObserv.Text = "Ver Comentarios (1 no leído)";
                                }
                                else
                                {
                                    hpAnadirObserv.Text = "Ver Comentarios (" + numNL + " no leídos)";
                                }
                                hpAnadirObserv.NavigateUrl = "VerComentarios.aspx?id=" + pub.getID();
                                PanelPublic.Controls.Add(hpAnadirObserv);
                            }

                            PanelPublic.Controls.Add(new LiteralControl("<br />"));
                            PanelPublic.Controls.Add(new LiteralControl("<br />"));
                        }
                        else
                        {
                            if (Usuario.esAdministrador(idCurrentUser))
                            {
                                HyperLink hpEditar = new HyperLink();
                                hpEditar.ID = "hpEditar" + pub.getID();
                                hpEditar.Text = "Editar";
                                hpEditar.NavigateUrl = "EditarPublicAdmin.aspx?id=" + pub.getID();
                                PanelPublic.Controls.Add(hpEditar);
                                PanelPublic.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));

                                LinkButton lbEliminar = new LinkButton();
                                lbEliminar.ID = "lbEliminar" + pub.getID();
                                lbEliminar.Text = "Eliminar";
                                lbEliminar.Attributes.Add("language", "javascript");
                                lbEliminar.Attributes.Add("OnClick", "return confirm('¿Esta seguro que desea eliminar la publicación?')");
                                lbEliminar.Command += new CommandEventHandler(lbEliminar_Click);
                                lbEliminar.CommandArgument = pub.getID().ToString();
                                PanelPublic.Controls.Add(lbEliminar);
                                PanelPublic.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));

                                LinkButton lbEliminarFeed = new LinkButton();
                                lbEliminarFeed.ID = "lbEliminarFeed" + pub.getID();
                                lbEliminarFeed.Text = "Eliminar del feed";
                                lbEliminarFeed.Attributes.Add("language", "javascript");
                                lbEliminarFeed.Attributes.Add("OnClick", "return confirm('¿Esta seguro que desea eliminar la publicación del feed RSS? Recuerde que si no se encontraba en el feed esta accion no tendrá ningún efecto.')");
                                lbEliminarFeed.Command += new CommandEventHandler(lbEliminarFeed_Click);
                                lbEliminarFeed.CommandArgument = pub.getID().ToString();
                                PanelPublic.Controls.Add(lbEliminarFeed);
                                PanelPublic.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));

                                if (pub.tieneComentarios())
                                {
                                    HyperLink hpAnadirObserv = new HyperLink();
                                    hpAnadirObserv.ID = "hpVerComent" + pub.getID();
                                    int numNL = (int)pub.numComentariosNoLeidas();
                                    if (numNL == 0)
                                    {
                                        hpAnadirObserv.Text = "Ver Comentarios";
                                    }
                                    else if (numNL == 1)
                                    {
                                        hpAnadirObserv.Text = "Ver Comentarios (1 no leído)";
                                    }
                                    else
                                    {
                                        hpAnadirObserv.Text = "Ver Comentarios (" + numNL + " no leídos)";
                                    }
                                    hpAnadirObserv.NavigateUrl = "VerComentarios.aspx?id=" + pub.getID();
                                    PanelPublic.Controls.Add(hpAnadirObserv);
                                    PanelPublic.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));
                                }
                            }
                            if (!idCurrentUser.Equals(""))
                            {
                                HyperLink hpAnadirObserv = new HyperLink();
                                hpAnadirObserv.ID = "hpAnadirObserv" + pub.getID();
                                hpAnadirObserv.Text = "Añadir comentario";
                                hpAnadirObserv.NavigateUrl = "AnadirComentario.aspx?id=" + pub.getID();
                                PanelPublic.Controls.Add(hpAnadirObserv);
                                PanelPublic.Controls.Add(new LiteralControl("<br />"));
                                PanelPublic.Controls.Add(new LiteralControl("<br />"));
                            }
                        }
                        PanelPublic.Controls.Add(new LiteralControl("</div>"));
                    }
                }
            }
            catch (AccessViolationException)//(SqlException)
            {
                PanelError.Visible = true;
                LabelError.Text = "ERROR. Se ha producido un error relacionado con la base de datos.";
            }
            catch (FormatException)
            {
                //No se puede realizar la conversion del numero de pagina seleccionado
            }
            catch (ArgumentNullException)
            {
                //Dara error si no se le pasa el parametro
            } 
        }

        private int paginaAnterior()
        {
            try
            {
                Int32 pagSelecc = Int32.Parse(Request.Params[0]);

                Int32 anterior = 0;
                if ((Int32.Parse(Request.Params[0]) > 0))
                {
                    anterior = Int32.Parse(Request.Params[0]) - 1;
                }
                return anterior;
            }
            catch (SqlException)
            {
                PanelError.Visible = true;
                LabelError.Text = "ERROR. No se ha podido cargar la pagina anterior.";
                return 0;
            }
            catch (NullReferenceException)
            {
                PanelError.Visible = true;
                LabelError.Text = "ERROR. No se ha podido cargar la pagina anterior.";
                return 0;
            }
        }

        private int paginaSiguiente()
        {
            try
            {
                Int32 pagSelecc = Int32.Parse(Request.Params[0]);
                Int32 siguiente = (Int32)numPaginas - 1;
                if (Int32.Parse(Request.Params[0]) < (numPaginas - 1))
                {
                    siguiente = Int32.Parse(Request.Params[0]) + 1;
                }
                return siguiente;
            }
            catch (SqlException)
            {
                PanelError.Visible = true;
                LabelError.Text = "ERROR. No se ha podido cargar la pagina siguiente.";
                return 0;
            }
            catch (NullReferenceException)
            {
                PanelError.Visible = true;
                LabelError.Text = "ERROR. No se ha podido cargar la pagina siguiente.";
                return 0;
            }
        }

        protected void ButtonAnterior_Click(object sender, EventArgs e)
        {
            Response.Redirect(Estatica.getUrlProyecto + "MisPublicaciones.aspx?pag="+
                paginaAnterior()+"&filtro="+Request.Params["filtro"]+"&numNotPag="+
                Request.Params["numNotPag"] + "&idUsu=" + idCurrentUser
                + "&todas="+Request.Params["todas"]);
        }

        protected void ButtonSiguiente_Click(object sender, EventArgs e)
        {
            Response.Redirect(Estatica.getUrlProyecto + "MisPublicaciones.aspx?pag=" +
               paginaSiguiente() + "&filtro=" + Request.Params["filtro"] + "&numNotPag=" +
               Request.Params["numNotPag"] + "&idUsu=" + idCurrentUser
               + "&todas=" + Request.Params["todas"]);
        }

        public void lbEliminar_Click(object sender, EventArgs e)
        {
            try
            {
                LinkButton lbtSender = (LinkButton)sender;
                int idPub = Int32.Parse(lbtSender.CommandArgument);
                Publicacion pub = new Publicacion(idPub);
                pub.eliminarPublicLogico();
                Page_Load(sender, e);
            }
            catch (SqlException)
            {
                LabelError.Text = "ERROR. No se ha podido eliminar el comentario";
            }
        }

        protected void ButtonBuscar_Click(object sender, EventArgs e)
        {
            string todas = "no";
            if (rbtListTodas.SelectedItem.Text.Equals("Todas")) { todas = "si"; }
                Response.Redirect(Estatica.getUrlProyecto + "MisPublicaciones.aspx?pag=0&filtro=" + DropDownListTemas.SelectedItem.Text +
                    "&numNotPag=" + DropDownListNotPag.SelectedItem.Text + "&idUsu=" + Request.Params["idUsu"] + "&todas="+todas);
        }

        public void lbEliminarFeed_Click(object sender, EventArgs e)
        {
            try
            {
                LinkButton lbtSender = (LinkButton)sender;
                int idPub = Int32.Parse(lbtSender.CommandArgument);
                Publicacion pub = new Publicacion(idPub);
                pub.eliminarDeLosFeeds();
                Page_Load(sender, e);
            }
            catch (SqlException)
            {
                LabelError.Text = "ERROR. No se ha podido eliminar la publicación";
            }
        }

    }
}
