﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using DivulgacionCientifica;
using DivulgacionCientifica.CapaNegocio;
using System.Data.SqlClient;
using System.Net.Mail;
using System.Collections.Generic;

namespace DivulgacionCientifica
{
    public partial class WebFormModificarDatos : System.Web.UI.Page
    {
        string idCurrentUser = HttpContext.Current.User.Identity.Name;
        private Usuario u; //Usuario a modificar, se carga en el load
        protected void Page_Load(object sender, EventArgs e)
        {
            lBtValidar.Attributes.Add("language", "javascript");
            lBtValidar.Attributes.Add("OnClick", "return confirm('¿Esta seguro que desea VALIDAR la petición de registro? Recuerde que se le enviará un email al usuario informándole de la decisión.'')");

            btEliminar.Attributes.Add("language", "javascript");
            btEliminar.Attributes.Add("OnClick", "return confirm('¿Esta seguro que desea eliminar el usuario seleccionado? Recuerde que además se eliminarán sus publicaciones.')");

            lBtRechazar.Attributes.Add("language", "javascript");
            lBtRechazar.Attributes.Add("OnClick", "return confirm('¿Esta seguro que desea RECHAZAR la petición de registro? Recuerde que se le enviará un email al usuario informándole de la decisión.')");
            try
            {
                if (idCurrentUser.Equals(""))
                {
                    Response.Redirect("~\\Inicio.aspx");
                }
                else
                {
                    if (Usuario.esAdministrador(idCurrentUser) && (Request.Params["id"] != null))
                    {
                        PanelContrActual.Visible = false;
                        string idUsu = Request.Params["id"].ToString();
                        u = new Usuario(idUsu);
                        if (u.getValidado())
                        {
                            PanelValidar.Visible = false;
                            btEliminar.Visible = true;
                        }
                        else
                        {
                            PanelValidar.Visible = true;
                            btEliminar.Visible = false;
                        }
                    }
                    else
                    {
                        PanelContrActual.Visible = true;
                        PanelValidar.Visible = false;
                        string idUsu = idCurrentUser;
                        u = new Usuario(idUsu);
                    }
                    LabelCabecera.Text = "Bienvenido, " + idCurrentUser;

                    TextBoxContrasena.Enabled = false;
                    TextBoxContrasena1.Enabled = false;
                    TextBoxContrasenaAnt.Enabled = false;

                    LabelNombre.Text = u.getNombre();
                    LabelNombre.Visible = true;
                    TextBoxNombre.Visible = false;

                    LabelApellidos.Text = u.getApellidos();
                    LabelApellidos.Visible = true;
                    TextBoxApellidos.Visible = false;

                    LabelEmail.Text = u.getEmail();
                    LabelEmail.Visible = true;
                    TextBoxEmail.Visible = false;

                    LabelOcupacion.Text = u.getOcupacion();
                    LabelOcupacion.Visible = true;
                    TextBoxOcupacion.Visible = false;

                    LabelTlf1.Text = u.getTelefono1();
                    LabelTlf1.Visible = true;
                    TextBoxTelefono1.Visible = false;

                    LabelTlf2.Text = u.getTelefono2();
                    LabelTlf2.Visible = true;
                    TextBoxTelefono2.Visible = false;

                    LabelPais.Text = u.getPais().getNombre();
                    LabelPais.Visible = true;
                    DropDownListPais.Visible = false;

                    LabelFechaR.Text = u.getFechaRegistro().ToString();

                    string sexo = u.getSexo();
                    LabelSexo.Visible = true;
                    if (sexo != null && sexo.Equals("hombre"))
                    {
                        LabelSexo.Text = "hombre";
                    }
                    else if (sexo != null && sexo.Equals("mujer"))
                    {
                        LabelSexo.Text = "mujer";
                    }
                    else
                    {
                        LabelSexo.Text = "";
                    }
                    RadioButtonHombre.Visible = false;
                    RadioButtonMujer.Visible = false;
                    LabelSexo.Visible = true;
                    PanelMotivo.Visible = false;
                    TextBoxMotivo.Text = "";
                }
            }
            catch (SqlException)
            {
                LabelMensajes.Text = "ERROR. Ha ocurrido un error relacionado con la base de datos.";
            }
        }
       
        protected void modContrasena()
        {
            try
            {
                    if (Usuario.esAdministrador(idCurrentUser) || Usuario.credencialesCorrectos(u.getId(), TextBoxContrasenaAnt.Text))
                    {
                        if (TextBoxContrasena.Text.Equals(TextBoxContrasena1.Text))
                        {
                            if (TextBoxContrasena.Text.Equals(""))
                            {
                                LabelMensajes.Text = "";
                                LabelMensajes.Text = "ERROR. El campo contraseña no puede ser vacio.";
                            }
                            else
                            {
                                u.modificarContrasena(TextBoxContrasena.Text);
                                LabelMensajes.Text = "";
                                LabelCorrecto.Text = "La contraseña ha sido modificada con éxito.";
                            }
                        }
                        else
                        {
                            LabelCorrecto.Text = "";
                            LabelMensajes.Text = "ERROR. Las contraseñas no coinciden.";
                        }
                    }
                    else
                    {
                        LabelCorrecto.Text = "";
                        LabelMensajes.Text = "ERROR. Contraseña actual incorrecta, no ha sido modificada.";
                    }
            }
            catch (SqlException)
            {
                LabelMensajes.Text = "ERROR. No se ha modificado la contraseña ya que ha ocurrido un error relacionado con la base de datos.";
            }
        }       

        protected void btModificar_Click(object sender, EventArgs e)
        {
            try
            {
                if (btModificar.Text.Equals("Modificar"))
                {
                    btModificar.Text = "Aceptar";
                    btModificarCont.Text = "Modificar";
                    if (Usuario.esAdministrador(idCurrentUser))
                    {
                        PanelMotivo.Visible = false;
                        PanelContrActual.Visible = false;
                    }
                    else
                    {
                        PanelContrActual.Visible = true;
                        PanelMotivo.Visible = true;
                    }

                    TextBoxEmail.Visible = true;
                    TextBoxEmail.Text = LabelEmail.Text;
                    LabelEmail.Visible = false;

                    TextBoxNombre.Visible = true;
                    TextBoxNombre.Text = LabelNombre.Text;
                    LabelNombre.Visible = false;

                    TextBoxApellidos.Visible = true;
                    TextBoxApellidos.Text = LabelApellidos.Text;
                    LabelApellidos.Visible = false;

                    TextBoxOcupacion.Visible = true;
                    TextBoxOcupacion.Text = LabelOcupacion.Text;
                    LabelOcupacion.Visible = false;

                    TextBoxTelefono1.Visible = true;
                    TextBoxTelefono1.Text = LabelTlf1.Text;
                    LabelTlf1.Visible = false;

                    TextBoxTelefono2.Visible = true;
                    TextBoxTelefono2.Text = LabelTlf2.Text;
                    LabelTlf2.Visible = false;

                    DropDownListPais.Items.Clear();
                    cargarPaises(DropDownListPais);
                    DropDownListPais.Visible = true;
                    LabelPais.Visible = false;

                    if (LabelSexo.Text.Equals("hombre"))
                    {
                        RadioButtonHombre.Checked = true;
                    }
                    else if (LabelSexo.Text.Equals("mujer"))
                    {
                        RadioButtonMujer.Checked = true;
                    }
                    RadioButtonHombre.Visible = true;
                    RadioButtonMujer.Visible = true;
                    LabelSexo.Visible = false;
                    
                    LabelMensajes.Text = "";
                    LabelCorrecto.Text = "";
                }
                else if (btModificar.Text.Equals("Aceptar"))
                {
                    btModificar.Text = "Modificar";
                    if (Usuario.esAdministrador(idCurrentUser))
                    {
                        //Se modifican los datos del usuario de inmediato
                        bool cond1 = Auxiliares.EmailCorrecto(TextBoxEmail.Text);
                        bool cond2 = !TextBoxNombre.Text.Equals("");
                        bool cond3 = (!TextBoxApellidos.Text.Equals(""));
                        bool cond4 = (!TextBoxOcupacion.Text.Equals(""));
                        bool cond5 = Auxiliares.soloNumeros(TextBoxTelefono1.Text);
                        bool cond6 = Auxiliares.soloNumeros(TextBoxTelefono2.Text);
                        if ( cond1 && cond2 && cond3 && cond4 && cond5 && cond6)
                        {
                            string sexo;
                            if (RadioButtonMujer.Checked){sexo = "mujer";}
                            else if (RadioButtonHombre.Checked) { sexo = "hombre"; }
                            else { sexo = ""; }
                        
                            u.modificarUsuario(TextBoxNombre.Text, TextBoxEmail.Text, TextBoxApellidos.Text,
                                new Pais(DropDownListPais.SelectedItem.Text), sexo, TextBoxOcupacion.Text,
                                TextBoxTelefono1.Text, TextBoxTelefono2.Text);
                            LabelMensajes.Text = "";
                            LabelCorrecto.Text = "Los datos han sido modificados con éxito";
                            Page_Load(sender, e);
                        }
                        else
                        {
                            LabelCorrecto.Text = "";
                            LabelMensajes.Text = "ERROR. Revise que los datos introducidos sean correctos";
                        }

                    }
                    else
                    {
                        if (Auxiliares.EmailCorrecto(TextBoxEmail.Text) && !TextBoxNombre.Text.Equals("") &&
                            (!TextBoxApellidos.Text.Equals("")) && (!TextBoxOcupacion.Text.Equals("")) &&
                            Auxiliares.soloNumeros(TextBoxTelefono1.Text) && Auxiliares.soloNumeros(TextBoxTelefono2.Text))
                        {
                            string sexo;
                            if (RadioButtonMujer.Checked) { sexo = "mujer"; }
                            else if (RadioButtonHombre.Checked) { sexo = "hombre"; }
                            else { sexo = ""; }

                            ModifUsuario pet = new ModifUsuario(idCurrentUser, TextBoxNombre.Text,
                                TextBoxApellidos.Text, TextBoxEmail.Text, new Pais(DropDownListPais.Text),
                                sexo, TextBoxOcupacion.Text, TextBoxTelefono1.Text, TextBoxTelefono2.Text,
                                TextBoxMotivo.Text);
                            pet.almacenar();

                            Page_Load(sender, e);
                            PanelMotivo.Visible = false;
                            LabelMensajes.Text = "";
                            LabelCorrecto.Text = "Se ha enviado la petición. Recuerde que deberán ser validados, recibirá un email con la resolución.";
                        }
                        else
                        {
                            LabelCorrecto.Text = "";
                            LabelMensajes.Text = "ERROR. Compruebe que todos los campos sean correctos.";
                        }
                    }
                }
            }
            catch (SqlException)
            {
                LabelMensajes.Text = "ERROR. No se han modificado los datos.";
            }       
        }

        protected void btModificarCont_Click(object sender, EventArgs e)
        {
            try
            {
                if (btModificarCont.Text.Equals("Modificar"))
                { 
                    Page_Load(sender, e);
                    LabelEmail.Visible = true;
                    LabelNombre.Visible = true;
                    LabelApellidos.Visible = true;
                    LabelSexo.Visible = true;
                    LabelPais.Visible = true;
                    btModificar.Text = "Modificar";
                    btModificarCont.Text = "Aceptar";
                    TextBoxContrasenaAnt.Enabled = true;
                    TextBoxContrasena.Enabled = true;
                    TextBoxContrasena1.Enabled = true;
                }
                else if (btModificarCont.Text.Equals("Aceptar"))
                {
                    btModificarCont.Text = "Modificar";
                    modContrasena();
                }
            }
            catch (SqlException)
            {
                LabelMensajes.Text = "ERROR. Ha ocurrido un error al modificar la contraseña.";
            }
        }

        protected void btCancelarCont_Click(object sender, EventArgs e)
        {
            if (btModificarCont.Text.Equals("Aceptar"))
            {
                btModificarCont.Text = "Modificar";
                TextBoxContrasenaAnt.Enabled = false;
                TextBoxContrasena.Enabled = false;
                TextBoxContrasena1.Enabled = false;

            }
        }

        protected void btCancelar_Click(object sender, EventArgs e)
        {
            if (btModificar.Text.Equals("Aceptar"))
            {
                btModificar.Text = "Modificar";

                if (Usuario.esAdministrador(idCurrentUser) && !(Request.Params["id"] == null))
                {

                    string idUsu = Request.Params["id"].ToString();
                    u = new Usuario(idUsu);

                    TextBoxContrasena.Enabled = false;
                    TextBoxContrasena1.Enabled = false;
                    TextBoxContrasenaAnt.Enabled = false;

                    LabelNombre.Text = u.getNombre();
                    LabelNombre.Visible = true;
                    TextBoxNombre.Visible = false;

                    LabelApellidos.Text = u.getApellidos();
                    LabelApellidos.Visible = true;
                    TextBoxApellidos.Visible = false;

                    LabelOcupacion.Text = u.getOcupacion();
                    LabelOcupacion.Visible = true;
                    TextBoxOcupacion.Visible = false;

                    LabelEmail.Text = u.getEmail();
                    LabelEmail.Visible = true;
                    TextBoxEmail.Visible = false;

                    LabelPais.Text = u.getPais().getNombre();
                    LabelPais.Visible = true;
                    DropDownListPais.Visible = false;

                    LabelSexo.Visible = true;
                    string sexo = u.getSexo();
                    if (sexo != null && sexo.Equals("hombre"))
                    {
                        LabelSexo.Text = "hombre";
                    }
                    else if (sexo != null && sexo.Equals("mujer"))
                    {
                        LabelSexo.Text = "mujer";
                    }
                    else
                    {
                        LabelSexo.Text = "";
                    }
                    RadioButtonHombre.Visible = false;
                    RadioButtonMujer.Visible = false;
                }
                else
                {
                    u = new Usuario(idCurrentUser);

                    TextBoxContrasena.Enabled = false;
                    TextBoxContrasena1.Enabled = false;
                    TextBoxContrasenaAnt.Enabled = false;

                    LabelNombre.Text = u.getNombre();
                    LabelNombre.Visible = true;
                    TextBoxNombre.Visible = false;

                    LabelApellidos.Text = u.getApellidos();
                    LabelApellidos.Visible = true;
                    TextBoxApellidos.Visible = false;

                    LabelOcupacion.Text = u.getOcupacion();
                    LabelOcupacion.Visible = true;
                    TextBoxOcupacion.Visible = false;

                    LabelEmail.Text = u.getEmail();
                    LabelEmail.Visible = true;
                    TextBoxEmail.Visible = false;

                    LabelPais.Text = u.getPais().getNombre();
                    LabelPais.Visible = true;
                    DropDownListPais.Visible = false;

                    LabelSexo.Visible = true;
                    string sexo = u.getSexo();
                    if (sexo != null && sexo.Equals("hombre"))
                    {
                        LabelSexo.Text = "hombre";
                    }
                    else if (sexo != null && sexo.Equals("mujer"))
                    {
                        LabelSexo.Text = "mujer";
                    }
                    else
                    {
                        LabelSexo.Text = "";
                    }
                    RadioButtonHombre.Visible = false;
                    RadioButtonMujer.Visible = false;
                }


            }
        }

        protected void btEliminar_Click(object sender, EventArgs e)
        {
            try{
                Usuario u = new Usuario(Request.Params["id"]);
                u.eliminarUsuarioLogico();
                Response.Redirect("GestionarUsuarios.aspx?filtro=Ninguno");
            }
            catch(SqlException)
            {
                LabelCorrecto.Text = "";
                LabelMensajes.Text = "ERROR. Se produjo un error al intentar eliminar el usuario.";
            }
        }

        //El registro es efectivo
        protected void lBtValidar_Click(object sender, EventArgs e)
        {
            try
            {
                Usuario u = new Usuario(Request.Params["id"]);
                u.validar();
                enviarEmailAfirm();
                Response.Redirect("Peticiones.aspx");
            }
            catch (SqlException)
            {
                LabelCorrecto.Text = "";
                LabelMensajes.Text = "ERROR. No se ha podido validar la petición de registro.";
            }
        }

        //Rechaza el registro
        protected void lBtRechazar_Click(object sender, EventArgs e)
        {
            try
            {
                Usuario u = new Usuario(Request.Params["id"]);
                enviarEmailNegat();
                u.eliminarUsuarioFisico();
                Response.Redirect("Peticiones.aspx");
            }
            catch (SqlException)
            {
                LabelCorrecto.Text = "";
                LabelMensajes.Text = "ERROR. No se ha podido rechazar la petición de registro.";
            }
        }

        private void enviarEmailAfirm()
        {
            try
            {
                MailMessage correo = new MailMessage();
                correo.From = new System.Net.Mail.MailAddress(Estatica.getMailAdress, "Divulgacion Científica", System.Text.Encoding.UTF8);
                correo.To.Add(u.getEmail());
                correo.Subject = "Registro aceptado";
                correo.Body = "Hola " + u.getNombre() + @",

Le comunicamos que ha sido aceptada su petición de registro.

Recuerde que su  nombre de usuario es " + u.getId() + ", con él podrá a partir de este momento acceder a nuestra web "
                    + Estatica.getUrlProyecto + "Inicio.aspx " + @"

Gracias.";
                correo.IsBodyHtml = false;
                correo.Priority = System.Net.Mail.MailPriority.Normal;

                SmtpClient smtp = new SmtpClient();
                smtp.Host = Estatica.getSmtp;
                smtp.EnableSsl = Estatica.getSmtpUsaSSL;
                if (Estatica.getSmtpUsaSSL)
                {
                    smtp.Credentials = new System.Net.NetworkCredential(Estatica.getMailAdress, Estatica.getMailPassw);
                }
                smtp.Send(correo);
            }
            catch (FormatException)
            {
                LabelMensajes.Text = "AVISO. No se ha podido enviar el email al creador debido ya que su dirección no tiene el formato correcto.";
            }
            catch (SmtpException)
            {
                LabelMensajes.Text = "AVISO. No se ha podido enviar el email al creador.";
            }
        }

        private void enviarEmailNegat()
        {
            try
            {
                MailMessage correo = new MailMessage();
                correo.From = new System.Net.Mail.MailAddress(Estatica.getMailAdress, "Divulgacion Científica", System.Text.Encoding.UTF8);
                correo.To.Add(u.getEmail());
                correo.Subject = "Registro rechazado";
                correo.Body = "Hola " + u.getNombre() + @",

Le informamos que su petición de registro ha sido rechazada.
                
Lo sentimos.";

                correo.IsBodyHtml = false;
                correo.Priority = System.Net.Mail.MailPriority.Normal;

                SmtpClient smtp = new SmtpClient();
                smtp.Host = Estatica.getSmtp;
                smtp.EnableSsl = Estatica.getSmtpUsaSSL;
                if (Estatica.getSmtpUsaSSL)
                {
                    smtp.Credentials = new System.Net.NetworkCredential(Estatica.getMailAdress, Estatica.getMailPassw);
                }
                smtp.Send(correo);
            }
            catch (FormatException)
            {
                LabelMensajes.Text = "AVISO. No se ha podido enviar el email al creador debido ya que su direccion no tiene el formato correcto.";
            }
            catch (SmtpException)
            {
                LabelMensajes.Text = "AVISO. No se ha podido enviar el email al creador.";
            }
        }

        public void cargarPaises(DropDownList ddl)
        {
            List<Pais> paises = Pais.getPaises();
            foreach(Pais p in paises)
            {
                ddl.Items.Add(p.getNombre());
            }
        }

    }
}
