﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using DivulgacionCientifica.CapaNegocio;
using System.Data.SqlClient;
using System.Net.Mail;
using System.Text;

namespace DivulgacionCientifica
{
    public partial class OlvideContrasena : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            btEnviar.Focus();
        }

        protected void btEnviar_Click(object sender, EventArgs e)
        {
            try
            {
                if (Usuario.idDisponible(TextBoxUsuario.Text)) //El usuario no existe
                {
                    LabelMensajes.Text = "";
                    LabelOK.Text = "";
                    LabelError.Text = "ERROR. El nombre de usuario no existe";
                }
                else
                {
                    string nuevaContras = cadenaAleatoria(8);
                    Usuario u = new Usuario(TextBoxUsuario.Text);
                    u.modificarContrasena(nuevaContras);
                    enviarContrasena(TextBoxUsuario.Text, nuevaContras);
                    LabelMensajes.Text = "";
                    LabelError.Text = "";
                    LabelOK.Text = "La contraseña ha sido enviada a su direccion de email";
                }
            }
            catch (SqlException)
            {
                LabelMensajes.Text = "";
                LabelError.Text = "ERROR. Se ha producido un error en la base de datos.";
            }
            catch (NullReferenceException)//SmtpException)
            {
                LabelMensajes.Text = "";
                LabelError.Text = "ERROR. No ha sido posible enviar el email.";
            }
            
        }

        public void enviarContrasena(string id, string nuevaContrasena)
        {
            Usuario u = new Usuario(id);
            try
            {
                MailMessage correo = new MailMessage();
                correo.From = new System.Net.Mail.MailAddress(Estatica.getMailAdress, "Divulgacion Científica", System.Text.Encoding.UTF8);
                correo.To.Add(u.getEmail());
                correo.Subject = "Nueva contraseña";
                correo.Body = "Hola " + u.getNombre() + @",

Atendiendo a su solicitud de una nueva contraseña le facilitamos los siguientes datos con los que podrá a partir de este momento acceder a nuestra web "
                    + Estatica.getUrlProyecto + "Inicio.aspx " +
                    @"

Usuario: " + TextBoxUsuario.Text +
                    @"
Contraseña: " + nuevaContrasena +
                    @"

Gracias.";


                correo.IsBodyHtml = false;
                correo.Priority = System.Net.Mail.MailPriority.Normal;

                SmtpClient smtp = new SmtpClient();
                smtp.Host = Estatica.getSmtp;
                smtp.EnableSsl = Estatica.getSmtpUsaSSL;
                if (Estatica.getSmtpUsaSSL)
                {
                    smtp.Credentials = new System.Net.NetworkCredential(Estatica.getMailAdress, Estatica.getMailPassw);
                }
                try
                {
                    smtp.Send(correo);
                }
                catch (SmtpException)
                {
                    LabelMensajes.Text = "AVISO. No se ha podido enviar el e-mail.";
                }
                catch (SqlException)
                {
                }
            }
            catch (FormatException)
            {
                LabelMensajes.Text = "AVISO. No se ha podido enviar la nueva contraseña debido a que su e-mail no es correcto.";
            }
        }

        public string cadenaAleatoria(int longitud)
        {
            StringBuilder str = new StringBuilder(longitud);
            int semilla = DateTime.Now.Millisecond;
            Random rnd = new Random(semilla);

            for (int i = 0; i < longitud; i++)
            {
                str.Append((char) rnd.Next(97, 123)); //Caracteres de la 'a' a la 'z'
            }
            return str.ToString();
        }
    }
}
