﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Data.SqlClient;
using DivulgacionCientifica.CapaNegocio;
using System.Net.Mail;

namespace DivulgacionCientifica
{
    public partial class PetModifDatos : System.Web.UI.Page
    {
        string idCurrentUser = HttpContext.Current.User.Identity.Name;
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Usuario.esAdministrador(idCurrentUser))
                Response.Redirect("Inicio.aspx");
            try
            {
                lBtRechazar.Attributes.Add("language", "javascript");
                lBtRechazar.Attributes.Add("OnClick", "return confirm('¿Esta seguro que desea RECHAZAR la petición del usuario para modificar sus datos personales?')");

                lBtValidar.Attributes.Add("language", "javascript");
                lBtValidar.Attributes.Add("OnClick", "return confirm('¿Esta seguro que desea VALIDAR la petición del usuario para modificar sus datos personales?')");

                string id = Request.Params["id"];
                Usuario u = new Usuario(id);
                ModifUsuario mod = new ModifUsuario(id);

                LabelNombre.Text = u.getNombre(); LabelNombre0.Text = mod.getNombre();
                if (!u.getNombre().Equals(mod.getNombre())) LabelNombre0.Font.Bold = true;

                LabelApellidos.Text = u.getApellidos(); LabelApellidos0.Text = mod.getApellidos();
                if (!u.getApellidos().Equals(mod.getApellidos())) LabelApellidos0.Font.Bold = true;

                LabelEmail.Text = u.getEmail(); LabelEmail0.Text = mod.getEmail();
                if (!u.getEmail().Equals(mod.getEmail())) LabelEmail0.Font.Bold = true;

                LabelOcupacion.Text = u.getOcupacion(); LabelOcupacion0.Text = mod.getOcupacion();
                if (!u.getOcupacion().Equals(mod.getOcupacion())) LabelOcupacion0.Font.Bold = true;

                LabelTlf1.Text = u.getTelefono1(); LabelTlf10.Text = mod.getTelefono1();
                if (!u.getTelefono1().Equals(mod.getTelefono1())) LabelTlf10.Font.Bold = true;

                LabelTlf2.Text = u.getTelefono2(); LabelTlf20.Text = mod.getTelefono2();
                if (!u.getTelefono2().Equals(mod.getTelefono2())) LabelTlf20.Font.Bold = true;

                LabelPais.Text = u.getPais().getNombre(); LabelPais0.Text = mod.getPais().getNombre();
                if (!u.getPais().getNombre().Equals(mod.getPais().getNombre())) LabelPais0.Font.Bold = true;

                LabelSexo.Text = u.getSexo(); LabelSexo0.Text = mod.getSexo();
                if (!u.getSexo().Equals(mod.getSexo())) LabelSexo0.Font.Bold = true;

                LabelFechaR.Text = u.getFechaRegistro().ToString();

                if (mod.getObservaciones().Equals("")) { LabelMotivo.Text = "El usuario no especificó ningún motivo"; }
                else { LabelMotivo.Text = mod.getObservaciones(); }
            }
            catch (SqlException)
            {
                LabelMensajes.Text = "ERROR. No se han podido cargar los datos.";
            }
            catch (NullReferenceException)
            {
                LabelMensajes.Text = "ERROR. No se han podido cargar los datos, revise si el usuario existe.";
            }
        }

        protected void lBtValidar_Click(object sender, EventArgs e)
        {
            try
            {
                ModifUsuario mod = new ModifUsuario(Request.Params["id"]);
                try
                {
                    mod.eliminar();
                }
                catch (SqlException)
                {
                    LabelMensajes.Text = "ERROR. No se han podido validar la petición de usuario.";
                }
                Usuario u = new Usuario(Request.Params["id"]);
                u.modificarUsuario(mod.getNombre(), mod.getEmail(), mod.getApellidos(),
                    mod.getPais(), mod.getSexo(), mod.getOcupacion(), mod.getTelefono1(),
                    mod.getTelefono2());
                enviarEmailAfirm();
                Response.Redirect("Peticiones.aspx");
            }
            catch (SqlException)
            {
                LabelMensajes.Text = "ERROR. No se han podido modificar los datos";
            }
        }

        protected void lBtRechazar_Click(object sender, EventArgs e)
        {
            try
            {
                ModifUsuario mod = new ModifUsuario(Request.Params["id"]);
                enviarEmailNegat();
                mod.eliminar();
                Response.Redirect("Peticiones.aspx");
            }
            catch (SqlException)
            {
                LabelMensajes.Text = "ERROR. Inténtelo de nuevo más tarde.";
            }
        }

        private void enviarEmailAfirm()
        {
            try
            {
                Usuario u = new Usuario(Request.Params["id"]);
                MailMessage correo = new MailMessage();
                correo.From = new System.Net.Mail.MailAddress(Estatica.getMailAdress, "Divulgación Científica", System.Text.Encoding.UTF8);
                correo.To.Add(u.getEmail());
                correo.Subject = "Datos modificados";
                correo.Body = "Hola " + u.getNombre() + @",

Atendiendo a su solicitud de modificar sus datos personales le informamos que la petición ha sido aceptada.

Recuerde que puede acceder a nuestra Web en " + Request.Url.GetLeftPart(UriPartial.Authority) + "/Inicio.aspx " + @"

Gracias.";


                correo.IsBodyHtml = false;
                correo.Priority = System.Net.Mail.MailPriority.Normal;

                SmtpClient smtp = new SmtpClient();
                smtp.Host = Estatica.getSmtp;
                smtp.EnableSsl = Estatica.getSmtpUsaSSL;
                if (Estatica.getSmtpUsaSSL)
                {
                    smtp.Credentials = new System.Net.NetworkCredential(Estatica.getMailAdress, Estatica.getMailPassw);
                }
                smtp.Send(correo);
            }
            catch (FormatException)
            {
                LabelMensajes.Text = "AVISO. No se ha podido enviar el email al creador debido ya que su dirección no tiene el formato correcto.";
            }
            catch (SmtpException)
            {
                LabelMensajes.Text = "AVISO. No se ha podido enviar el email al creador.";
            }
        }

        private void enviarEmailNegat()
        {
            try
            {
                Usuario u = new Usuario(Request.Params["id"]);

                MailMessage correo = new MailMessage();
                correo.From = new System.Net.Mail.MailAddress(Estatica.getMailAdress, "Divulgación Científica", System.Text.Encoding.UTF8);
                correo.To.Add(u.getEmail());
                correo.Subject = "Datos no modificados";
                correo.Body = "Hola " + u.getNombre() + @",

Atendiendo a su solicitud de modificar sus datos personales le informamos que la petición ha sido rechazada.

Recuerde que puede acceder a nuestra Web en " + Request.Url.GetLeftPart(UriPartial.Authority) + "/Inicio.aspx " + @"

Gracias.";


                correo.IsBodyHtml = false;
                correo.Priority = System.Net.Mail.MailPriority.Normal;

                SmtpClient smtp = new SmtpClient();
                smtp.Host = Estatica.getSmtp;
                smtp.EnableSsl = Estatica.getSmtpUsaSSL;
                if (Estatica.getSmtpUsaSSL)
                {
                    smtp.Credentials = new System.Net.NetworkCredential(Estatica.getMailAdress, Estatica.getMailPassw);
                }
                smtp.Send(correo);
            }
            catch (FormatException)
            {
                LabelMensajes.Text = "AVISO. No se ha podido enviar el email al creador debido ya que su dirección no tiene el formato correcto.";
            }
            catch (SmtpException)
            {
                LabelMensajes.Text = "AVISO. No se ha podido enviar el email al creador.";
            }
        }
    }
}
