﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using DivulgacionCientifica.CapaNegocio;
using System.Collections.Generic;
using System.Data.SqlClient;

namespace DivulgacionCientifica
{
    public partial class Peticiones : System.Web.UI.Page
    {
        string idCurrentUser = HttpContext.Current.User.Identity.Name;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Usuario.esAdministrador(idCurrentUser))
            {
                Response.Redirect("Inicio.aspx");
            }
            else
            {
                try
                {
                    PanelError.Visible = false;
                    PanelNoPeticiones.Visible = false;

                    if ((Usuario.getNoValidados().Count + ModifUsuario.getPeticionesUsuario().Count +
                        Publicacion.getNoValidadas().Count + EditPublic.getPeticionesPublic().Count) == 0)
                    {
                        PanelNoPeticiones.Visible = true;
                        PanelPeticiones.Visible = false;
                    }
                    else
                    {
                        PanelNoPeticiones.Visible = false;
                        PanelPeticiones.Visible = true;
                        if (CBList.Items.FindByText("Registro").Selected) { cargarRegistros(Usuario.getNoValidados()); }
                        if (CBList.Items.FindByText("Modificación de datos").Selected) { cargarModifDatos(ModifUsuario.getPeticionesUsuario()); }
                        if (CBList.Items.FindByText("Publicación").Selected) { cargarPublic(Publicacion.getNoValidadas()); }
                        if (CBList.Items.FindByText("Edición de publicación").Selected) { cargarEdicPublicaciones(EditPublic.getPeticionesPublic()); }
                    }
                }
                catch (SqlException)
                {
                    PanelError.Visible = true;
                }
            }
        }

        public void cargarRegistros(List<Usuario> lista)
        {
            foreach (Usuario u in lista)
            {
                PanelPeticiones.Controls.Add(new LiteralControl("<h3 style=\"margin-right: 70px; margin-left: 115px\">"));
                HyperLink hpNombre = new HyperLink();
                hpNombre.ID = "hpNombre" + u.getId();
                hpNombre.Text = "Registro - "+u.getNombre() + " " + u.getApellidos();
                hpNombre.NavigateUrl = Estatica.getUrlProyecto + "ModificarDatos.aspx?id=" + u.getId();
                hpNombre.ForeColor = System.Drawing.Color.ForestGreen;
                PanelPeticiones.Controls.Add(hpNombre);
                PanelPeticiones.Controls.Add(new LiteralControl("</h3>"));

                PanelPeticiones.Controls.Add(new LiteralControl("<div class=\"vprevia2\">"));
                PanelPeticiones.Controls.Add(new LiteralControl(Auxiliares.textoPlanoAHtml(u.getObservaciones())));
                PanelPeticiones.Controls.Add(new LiteralControl("</div>"));
                
                PanelPeticiones.Controls.Add(new LiteralControl("<div class=\"vprevia2\">"));
                PanelPeticiones.Controls.Add(new LiteralControl("<p style=\"font-family: 'trebuchet MS'; left: 5px; font-size: x-small; right: 5px; color: #808080;\">"));
                PanelPeticiones.Controls.Add(new LiteralControl("Emitida el " + u.getFechaRegistro()));
                PanelPeticiones.Controls.Add(new LiteralControl("</p>"));
                
                HyperLink hpVerU = new HyperLink();
                hpVerU.ID = "hpVerU" + u.getId();
                hpVerU.Text = "Acceder";
                hpVerU.NavigateUrl = "ModificarDatos.aspx?id=" + u.getId();
                PanelPeticiones.Controls.Add(hpVerU);
                PanelPeticiones.Controls.Add(new LiteralControl("</div>"));
            }
        }

        public void cargarPublic(List<Publicacion> listaPubls)
        {
            foreach (Publicacion not in listaPubls)
            {
                //Titulo
                PanelPeticiones.Controls.Add(new LiteralControl("<h3 style=\"margin-right: 70px; margin-left: 115px\">"));
                HyperLink hpTitulo = new HyperLink();
                hpTitulo.ID = "hpTitulo" + not.getID();
                hpTitulo.Text = "Publicar - "+not.getTitulo();
                hpTitulo.NavigateUrl = Estatica.getUrlProyecto + "VisualizarPublicacion.aspx?id=" + not.getID();
                hpTitulo.ForeColor = System.Drawing.Color.ForestGreen;
                PanelPeticiones.Controls.Add(hpTitulo);
                PanelPeticiones.Controls.Add(new LiteralControl("</h3>"));

                //Contenido
                PanelPeticiones.Controls.Add(new LiteralControl("<div class=\"vprevia2\">"));
                if (not.getImagen() != null)
                {
                    PanelPeticiones.Controls.Add(new LiteralControl("<div class=\"templatemo_img_texto\">"));
                    PanelPeticiones.Controls.Add(new LiteralControl("<img src=\"" + not.getImagen() + "\" />"));
                    PanelPeticiones.Controls.Add(new LiteralControl("</div>"));

                }
                PanelPeticiones.Controls.Add(new LiteralControl("<p>"));
                PanelPeticiones.Controls.Add(new LiteralControl(Auxiliares.textoPlanoAHtml(Auxiliares.vistaPreviaTextoPlano(
                    Auxiliares.htmlATextoPlano(not.getContenido()), 15, 900))));
                PanelPeticiones.Controls.Add(new LiteralControl("</p>"));
                PanelPeticiones.Controls.Add(new LiteralControl("</div>"));

                //Datos varios
                PanelPeticiones.Controls.Add(new LiteralControl("<div class=\"vprevia2\">"));
                PanelPeticiones.Controls.Add(new LiteralControl("<p style=\"font-family: 'trebuchet MS'; left: 5px; font-size: x-small; right: 5px; color: #808080;\">"));
                string autor = not.getCreador().getNombre();
                string ocupacion = not.getCreador().getOcupacion();
                PanelPeticiones.Controls.Add(new LiteralControl("Solicitud de " + autor + " (" + ocupacion + ") el " +
                    not.getFechaCreacion().ToString()));
                PanelPeticiones.Controls.Add(new LiteralControl("</p>"));

                //Opciones
                HyperLink hpVer = new HyperLink();
                hpVer.ID = "hpVer" + not.getID();
                hpVer.Text = "Acceder";
                hpVer.NavigateUrl = "VisualizarPublicacion.aspx?id=" + not.getID();
                PanelPeticiones.Controls.Add(hpVer);
                PanelPeticiones.Controls.Add(new LiteralControl("</div>"));
            }
        }

        public void cargarModifDatos(List<ModifUsuario> lista)
        {
            foreach (ModifUsuario mod in lista)
            {
                Usuario u = new Usuario(mod.getId());

                PanelPeticiones.Controls.Add(new LiteralControl("<h3 style=\"margin-right: 70px; margin-left: 115px\">"));
                HyperLink hpNombreM = new HyperLink();
                hpNombreM.ID = "hpNombreM" + u.getId();
                hpNombreM.Text = "Modificar datos - " + u.getNombre() + " " + u.getApellidos();
                hpNombreM.NavigateUrl = Estatica.getUrlProyecto + "PetModifDatos.aspx?id=" + mod.getId();
                hpNombreM.ForeColor = System.Drawing.Color.ForestGreen;
                PanelPeticiones.Controls.Add(hpNombreM);
                PanelPeticiones.Controls.Add(new LiteralControl("</h3>"));

                PanelPeticiones.Controls.Add(new LiteralControl("<div class=\"vprevia2\">"));
                PanelPeticiones.Controls.Add(new LiteralControl(mod.getObservaciones()));
                PanelPeticiones.Controls.Add(new LiteralControl("</div>"));

                PanelPeticiones.Controls.Add(new LiteralControl("<div class=\"vprevia2\">"));
                PanelPeticiones.Controls.Add(new LiteralControl("<p style=\"font-family: 'trebuchet MS'; left: 5px; font-size: x-small; right: 5px; color: #808080;\">"));
                PanelPeticiones.Controls.Add(new LiteralControl("Solicitada el " + mod.getFechaModif()));
                PanelPeticiones.Controls.Add(new LiteralControl("</p>"));

                HyperLink hpVerMU = new HyperLink();
                hpVerMU.ID = "hpVerMU" + mod.getId();
                hpVerMU.Text = "Acceder";
                hpVerMU.NavigateUrl = "PetModifDatos.aspx?id=" + mod.getId();
                PanelPeticiones.Controls.Add(hpVerMU);
                PanelPeticiones.Controls.Add(new LiteralControl("</div>"));
            }
        }

        public void cargarEdicPublicaciones(List<EditPublic> lista)
        {
            foreach (EditPublic modNot in lista)
            {
                //Titulo
                PanelPeticiones.Controls.Add(new LiteralControl("<h3 style=\"margin-right: 70px; margin-left: 115px\">"));
                HyperLink hpTitulo = new HyperLink();
                hpTitulo.ID = "hpTitulo" + modNot.getID();
                hpTitulo.Text = "Editar - " + modNot.getTitulo();
                hpTitulo.NavigateUrl = Estatica.getUrlProyecto + "PetEditPublic.aspx?id=" + modNot.getID();
                hpTitulo.ForeColor = System.Drawing.Color.ForestGreen;
                PanelPeticiones.Controls.Add(hpTitulo);
                PanelPeticiones.Controls.Add(new LiteralControl("</h3>"));

                //Contenido
                PanelPeticiones.Controls.Add(new LiteralControl("<div class=\"vprevia2\"><p>"));
                PanelPeticiones.Controls.Add(new LiteralControl(Auxiliares.textoPlanoAHtml(Auxiliares.vistaPreviaTextoPlano(
                    Auxiliares.htmlATextoPlano(modNot.getContenido()), 9, 900))));
                PanelPeticiones.Controls.Add(new LiteralControl("</p></div>"));

                //Datos varios
                PanelPeticiones.Controls.Add(new LiteralControl("<div class=\"vprevia2\">"));
                PanelPeticiones.Controls.Add(new LiteralControl("<p style=\"font-family: 'trebuchet MS'; left: 5px; font-size: x-small; right: 5px; color: #808080;\">"));
                Publicacion not = new Publicacion(modNot.getID());
                string autor = not.getCreador().getNombre();
                string ocupacion = not.getCreador().getOcupacion();
                PanelPeticiones.Controls.Add(new LiteralControl("Solicitud de " + autor + " (" + ocupacion + ") el " + 
                    modNot.getFechaSolic().ToString().Substring(0, 10)));
                PanelPeticiones.Controls.Add(new LiteralControl("</p>"));

                //Opciones
                HyperLink hpVer = new HyperLink();
                hpVer.ID = "hpVer" + modNot.getID();
                hpVer.Text = "Acceder";
                hpVer.NavigateUrl = "PetEditPublic.aspx?id=" + modNot.getID();
                PanelPeticiones.Controls.Add(hpVer);
                PanelPeticiones.Controls.Add(new LiteralControl("</div>"));
            }
        }

    }
}
