﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Data.SqlClient;
using DivulgacionCientifica.CapaNegocio;
using System.IO;
using System.Drawing;
using System.Drawing.Imaging;
using System.Collections.Generic;
using System.Windows.Forms;

namespace DivulgacionCientifica
{

    public partial class Publicar : System.Web.UI.Page
    {
        string idCurrentUser = HttpContext.Current.User.Identity.Name;
        protected void Page_Load(object sender, EventArgs e)
        {
            if (idCurrentUser.Equals(""))
            {
                Response.Redirect("~\\SolicitarAutenticacion.aspx");
            }
            else
            {
                try
                {
                    LabelError.Text = "";
                    LabelCorrecto.Text = "";

                    if (!IsPostBack) //Cuando entro a publicar una noticia borro los archivos por si otra vez salio sin guardar y se quedaron ahi
                    {
                        if (Directory.Exists(Estatica.getRutaProyecto + "temp" + Path.DirectorySeparatorChar + idCurrentUser))
                        {
                            Directory.Delete(Estatica.getRutaProyecto + "temp" + Path.DirectorySeparatorChar + idCurrentUser, true);
                        }
                        PanelAvanzado.Visible = false; //Ademas pongo el panel avanzado a false
                        if (DropDownListTemas.Items.Count == 0) //y cargo los temas
                        {
                            Auxiliares.cargarTemas(DropDownListTemas);
                        }
                    }
                }
                catch (SqlException)
                {
                    LabelError.Text = "ERROR. Se ha producido un error relacionado con la base de datos";
                }
            }
        }

        public List<Tema> temas()
        {
            List<Tema> t = new List<Tema>();
            for (int i = 0; i < DropDownListTemas0.Items.Count; i++)
            {
                t.Add(new Tema(DropDownListTemas0.Items[i].Text, ""));
            }
            return t;
        }

        protected void btPublicar_Click(object sender, EventArgs e)
        {
            string fe;
            if (Calendar1.SelectedDate.CompareTo(DateTime.Now) < 0)
            {
                fe = "NULL";
            }
            else
            {
                fe = "'" + Calendar1.SelectedDate.Year.ToString() + "-" + Calendar1.SelectedDate.Month.ToString() + "-" +
                Calendar1.SelectedDate.Day.ToString() + " " + Calendar1.SelectedDate.Hour.ToString() +
                ":" + Calendar1.SelectedDate.Minute.ToString() + ":" + Calendar1.SelectedDate.Second.ToString() + "'";
            }
            string contenido;
            if (PanelBasico.Visible)
            {
                contenido = TextBoxDescripcion.Text;
            }
            else
            {
                contenido = FreeTextBox.Text;
            }
            Publicacion not = new Publicacion(idCurrentUser, contenido, temas(),
                TextBoxTitulo.Text, RadioButtonList1.SelectedItem.ToString(), fe);
            try
            {
                if (DropDownListTemas.Items.Count == 0)
                {
                    LabelCorrecto.Text = "";
                    LabelError.Text = "No puede publicar ya que no hay temas habilitados";
                }
                if (DropDownListTemas0.Items.Count == 0)
                {
                    LabelCorrecto.Text = "";
                    LabelError.Text = "ERROR. Debe relacionar la publicación con al menos un tema.";
                }
                else if (not.getTitulo().Equals("") ||
                    not.getTitulo().Contains('\\') || not.getTitulo().Contains('/') ||
                    not.getTitulo().Contains(':') || not.getTitulo().Contains('*') ||
                    not.getTitulo().Contains('?') || not.getTitulo().Contains('"') ||
                    not.getTitulo().Contains('<') || not.getTitulo().Contains('>') ||
                    not.getTitulo().Contains('|') || (not.getTitulo().Length > 45))
                {
                    LabelCorrecto.Text = "";
                    LabelError.Text = "El titulo no puede ser vacio, ni exceder de 45 caracteres, ni contener los caracteres \\ / : * ? \" < > |";
                }
                else if (not.getContenido().Length > 60000)
                {
                    LabelCorrecto.Text = "";
                    LabelError.Text = "El contenido no puede exceder de 60000 caracteres.";
                }
                else
                {
                    try
                    {
                        //Hasta el momento de almacenar no calculo ID (pq si lo calculo antes en el intervalo desde que lo
                        //calculo hasta que lo almaceno lo puede haber calculado otro usuario y dar error en la base de datos
                        //si es mas rapido que nosotros publicando publica la noticia antes que nosotros con el mismo id que
                        //teniamos y a nosotros nos da error de restriccion de clave primaria
                        not.almacenarPublic(); //Ademas se actualiza su id
                        guardarReferencias(not.getID());
                        limpiar();
                    }
                    catch (SqlException)
                    {
                        LabelError.Text = " pero no se han podido guardar las referencias.";
                    }
                    catch (IOException)
                    {
                        not.eliminarPublicFisico();
                        LabelCorrecto.Text = "";
                        LabelError.Text = "ERROR. Se ha producido un error en el feed RSS";
                    }

                    try
                    {
                        guardarArchivos(not.getID());
                        LabelCorrecto.Text = "Publicacion realizada con ÉXITO, recuerde que deberá ser validada antes de que sea visible.";
                    }
                    catch (IOException)
                    {
                        LabelCorrecto.Text = "";
                        LabelError.Text = "Puede que alguno de sus archivos adjuntos no se haya guardado (IO)";
                    }
                    catch (SqlException)
                    {
                        LabelCorrecto.Text = "";
                        LabelError.Text = "Puede que alguno de sus archivos adjuntos no se haya guardado (BD)";
                    }
                }
            }
            catch (SqlException)
            {
                LabelCorrecto.Text = "";
                LabelError.Text = "ERROR. Se ha producido un error relacionado con la base de datos";
            }
            catch (NullReferenceException)
            {
                LabelCorrecto.Text = "";
                LabelError.Text = "ERROR. No puede publicar ya que no hay temas habilitados.";
            }
        }

        protected void btEliminar_Click(object sender, EventArgs e)
        {
            try
            {
                if ((DropDownListTemp.SelectedItem != null) && (DropDownListTemp.SelectedItem.Text.StartsWith("http://")))
                {
                    string nombre = DropDownListTemp.SelectedItem.Text.Substring(DropDownListTemp.SelectedItem.Text.LastIndexOf("/") + 1);
                    string rutaAElim = Estatica.getRutaProyecto + "Archivos" + Path.DirectorySeparatorChar + nombre;
                    if (File.Exists(rutaAElim))
                    {
                        File.Delete(rutaAElim);
                    }
                    DropDownListTemp.Items.Remove(DropDownListTemp.SelectedItem);
                }
                else
                {
                    string nombre = DropDownListTemp.SelectedItem.Text.Substring(DropDownListTemp.SelectedItem.Text.LastIndexOf("/") + 1);
                    string rutaAElim = Estatica.getRutaProyecto + "temp" + Path.DirectorySeparatorChar + idCurrentUser + Path.DirectorySeparatorChar + nombre;
                    if (File.Exists(rutaAElim))
                    {
                        File.Delete(rutaAElim);
                    }
                    DropDownListTemp.Items.Remove(DropDownListTemp.SelectedItem);
                }
            }
            catch (IOException)
            {
                LabelError.Text = "Se ha producido un error al intentar eliminar el archivo.";
            }
        }        

        protected void btAnadirTema_Click(object sender, EventArgs e)
        {
            if ((DropDownListTemas.Items.Count > 0) &&
                (DropDownListTemas0.Items.FindByText(DropDownListTemas.SelectedItem.Text) == null))
            {
                DropDownListTemas0.Items.Add(DropDownListTemas.SelectedItem.Text);
            }
            else
            {
                LabelError.Text = "Debe seleccionar un tema o el tema ya ha sido añadido.";
            }
        }

        protected void btEiminarTema_Click(object sender, EventArgs e)
        {
            try
            {
                DropDownListTemas0.Items.Remove(DropDownListTemas0.SelectedItem.Text);
            }
            catch (NullReferenceException)
            {
                LabelError.Text = "Debe seleccionar el tema a eliminar.";
            }
        }

        protected void LinkButtonEditor_Click(object sender, EventArgs e)
        {
            if (LinkButtonEditor.Text.Equals("Usar el editor avanzado"))
            {
                PanelBasico.Visible = false;
                PanelAvanzado.Visible = true;
                LinkButtonEditor.Text = "Usar el editor básico";
                FreeTextBox.Text = TextBoxDescripcion.Text;
                /*if (Directory.Exists(Estatica.getRutaProyecto + "temp" + Path.DirectorySeparatorChar + currentUser))
                {
                    string[] files = Directory.GetFiles(Estatica.getRutaProyecto + "temp" + Path.DirectorySeparatorChar +
                                currentUser + Path.DirectorySeparatorChar);
                    for (int i = 0; i < files.Length; i++)
                    {
                        File.Delete(files[i]);
                    }
                }*/
            }
            else
            {
                PanelBasico.Visible = true;
                PanelAvanzado.Visible = false;
                TextBoxDescripcion.Text = FreeTextBox.Text;
                LinkButtonEditor.Text = "Usar el editor avanzado";
            }
        }

        protected void btAnadirRef_Click(object sender, EventArgs e)
        {
            if (TextBoxRef.Text.Equals(""))
            {
                LabelError.Text = "No puede añadir una referencia vacía";
            }
            else
            {
                DropDownListRef.Items.Add(TextBoxRef.Text);
                TextBoxRef.Text = "";
            }
        }

        protected void btEliminarRef_Click(object sender, EventArgs e)
        {
            DropDownListRef.Items.Remove(DropDownListRef.SelectedItem.Text);
        }

        private void guardarReferencias(int idNot)
        {
            if (idNot == -1) { }//es que se ha producido un error
            else
            {
                for (int i = 0; i < DropDownListRef.Items.Count; i++)
                {
                    Referencia reff = new Referencia(DropDownListRef.Items[i].Text, new Publicacion(idNot));
                    reff.almacenar();
                }
            }
        }

        //Los guarda en la carpeta temporal del usuario
        protected void btGuardar_Click(object sender, EventArgs e)
        {
            try
            {
                string rutaTemp = Estatica.getRutaProyecto + "temp" + Path.DirectorySeparatorChar + idCurrentUser;
                if (!Directory.Exists(rutaTemp))
                {
                    Directory.CreateDirectory(rutaTemp);
                }

                if (FileUploadArch.HasFile && FileUploadArch.PostedFile.ContentLength < 10485760)
                {

                    if (FileUploadArch.FileName.ToLower().EndsWith(".jpg") ||
                        FileUploadArch.FileName.ToLower().EndsWith(".jpeg") ||
                        FileUploadArch.FileName.ToLower().EndsWith(".bmp") ||
                        FileUploadArch.FileName.ToLower().EndsWith(".gif") ||
                        FileUploadArch.FileName.ToLower().EndsWith(".tiff") ||
                        FileUploadArch.FileName.ToLower().EndsWith(".tif") ||
                        FileUploadArch.FileName.ToLower().EndsWith(".png"))
                    {
                        //Cambio los caracteres que al subir al servidor da error la URL
                        string nombre = FileUploadArch.FileName;
                        nombre = nombre.Replace('%', '-');
                        nombre = nombre.Replace('#', '-');
                        nombre = nombre.Replace('_', '-');
                        nombre = nombre.Replace(" ", "");

                        if (CheckBoxAsoc.Checked)
                        {
                            FileUploadArch.SaveAs(rutaTemp + Path.DirectorySeparatorChar + "red" + nombre);
                            Auxiliares.redimensionar(rutaTemp + Path.DirectorySeparatorChar + "red" + nombre,
                                                     rutaTemp + Path.DirectorySeparatorChar + nombre, 800, 800);
                            Auxiliares.redimensionar(rutaTemp + Path.DirectorySeparatorChar + "red" + nombre,
                                                     rutaTemp + Path.DirectorySeparatorChar + "vp_" +nombre, 175, 175);
                            File.Delete(rutaTemp + Path.DirectorySeparatorChar + "red" + nombre);

                            //Si el archivo con ese nombre existia en la carpeta se sobreescribe y en ese caso ya estaba en el 
                            //dropdownlist asi que no lo vuelvo a agregar
                            if (DropDownListTemp.Items.FindByText(nombre) == null)
                            {
                                DropDownListTemp.Items.Add(nombre);
                            }
                        }
                        else
                        {
                            FileUploadArch.SaveAs(rutaTemp + Path.DirectorySeparatorChar + "red"+ nombre);
                            Auxiliares.redimensionar(rutaTemp + Path.DirectorySeparatorChar+ "red" + nombre,
                                rutaTemp + Path.DirectorySeparatorChar + nombre, 800, 800);
                            File.Delete(rutaTemp + Path.DirectorySeparatorChar + "red" + nombre);

                            Archivo arch = new Archivo(rutaTemp + Path.DirectorySeparatorChar + nombre, new Usuario(idCurrentUser), new Publicacion(-1));
                            string nombreFinal = arch.almacenar();

                            //Si el archivo con ese nombre existia en la carpeta se sobreescribe y en ese caso ya estaba en el 
                            //dropdownlist asi que no lo vuelvo a agregar
                            if (DropDownListTemp.Items.FindByText(Estatica.getUrlProyecto + "Archivos/" + nombreFinal) == null)
                            {
                                DropDownListTemp.Items.Add(Estatica.getUrlProyecto + "Archivos/" + nombreFinal);
                            }

                        }
                    }
                    else if (FileUploadArch.FileName.ToLower().EndsWith(".wmv") ||
                        FileUploadArch.FileName.ToLower().EndsWith(".avi") ||
                        FileUploadArch.FileName.ToLower().EndsWith(".mov") ||
                        FileUploadArch.FileName.ToLower().EndsWith(".mpg") ||
                        FileUploadArch.FileName.ToLower().EndsWith(".mpeg") ||
                        FileUploadArch.FileName.ToLower().EndsWith(".mid") ||
                        FileUploadArch.FileName.ToLower().EndsWith(".midi") ||
                        FileUploadArch.FileName.ToLower().EndsWith(".mp3"))
                    {
                        string nombre = FileUploadArch.FileName;
                        nombre = nombre.Replace('%', '-');
                        nombre = nombre.Replace('#', '-');
                        nombre = nombre.Replace('_', '-'); //Lo usare como separador del id y para saber si son multimedia o no
                        nombre = nombre.Replace(" ", "");

                        //Si el archivo no debe ir asociado a una noticia lo reconozco pq empieza por a_
                        if (CheckBoxAsoc.Checked)
                        {
                            FileUploadArch.SaveAs(rutaTemp +Path.DirectorySeparatorChar+ nombre);
                            if (DropDownListTemp.Items.FindByText(nombre) == null)
                                DropDownListTemp.Items.Add(nombre);
                        }
                        else
                        {
                            FileUploadArch.SaveAs(rutaTemp + Path.DirectorySeparatorChar + nombre);
                            Archivo arch = new Archivo(rutaTemp + Path.DirectorySeparatorChar + nombre, new Usuario(idCurrentUser), new Publicacion(-1));
                            string nombreFinal = arch.almacenar();

                            
                            if (DropDownListTemp.Items.FindByText(Estatica.getUrlProyecto + "Archivos/" + nombreFinal) == null)
                                DropDownListTemp.Items.Add(Estatica.getUrlProyecto + "Archivos/" + nombreFinal);

                        }
                        
                    }
                    else
                    {
                        LabelError.Text = "ERROR. Tipo de archivo no soportado";
                    }
                }
                else if (FileUploadArch.PostedFile.ContentLength > 52428800)
                {
                    LabelError.Text = "ERROR. El archivo no puede tener un tamaño superior a 50Mb";
                }
                else
                {
                    LabelError.Text = "ERROR. El archivo indicado no existe o no es accesible.";
                }
            }
            catch (IOException)
            {
                LabelError.Text = "Se ha producido un error al intentar guardar el archivo.";
            }
        }

        //Cuando se pulsa publicar debo guardar los archivos en la base de datos y en la
        //carpeta Archivos
        private void guardarArchivos(int idNot)
        {
            if (Directory.Exists(Estatica.getRutaProyecto + "temp" + Path.DirectorySeparatorChar + idCurrentUser))
            {
                string[] archs = Directory.GetFiles(Estatica.getRutaProyecto + "temp" + Path.DirectorySeparatorChar + idCurrentUser);
                if ((archs != null) && (archs.Length > 0))
                {
                    foreach (string arch in archs)
                    {
                        string nombre = arch.Substring(arch.LastIndexOf(Path.DirectorySeparatorChar) + 1);
                        Archivo a = new Archivo(arch, new Usuario(idCurrentUser), new Publicacion(idNot));
                        a.almacenar();
                    }
                }
            }
        }

        protected void btUsar_Click(object sender, EventArgs e)
        {

            if (TextBoxDescripcion.Visible)
            {
                TextBoxDescripcion.Text = TextBoxDescripcion.Text + DropDownListTemp.SelectedItem.Text;
            }
            else
            {
                FreeTextBox.Text = FreeTextBox.Text + DropDownListTemp.SelectedItem.Text;
            }
        }

        private void limpiar()
        {
            DropDownListTemas0.Items.Clear();
            TextBoxTitulo.Text = "";
            DropDownListTemp.Items.Clear();
            TextBoxDescripcion.Text = "";
            FreeTextBox.Text = "";
            DropDownListRef.Items.Clear();
        }

    }
}
