﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using DivulgacionCientifica.CapaNegocio;
using System.Data.SqlClient;
using System.IO;

namespace DivulgacionCientifica
{
    public partial class RSS : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            try
            {
                LabelConfirmar.Text = "";
                if (ListBoxTemas.Items.Count == 0)
                {
                    Auxiliares.cargarTemas(ListBoxTemas);
                }
                //eoc es que ya los habia cargado con anterioridad
            }
            catch(SqlException)
            {
                LabelError.Text = "ERROR. No se pueden cargar los temas de la base de datos";
            }
        }

        protected void btSuscribir_Click(object sender, EventArgs e)
        {
            try
            {
                string ruta = Estatica.getRutaProyecto + "feedsRSS" + Path.DirectorySeparatorChar +
                    ListBoxTemas.SelectedItem.ToString() + ".xml";

                if (System.IO.File.Exists(ruta))
                {
                    String url = "~" + Path.DirectorySeparatorChar + "feedsRSS" +
                        Path.DirectorySeparatorChar + ListBoxTemas.SelectedItem.ToString() + ".xml";
                    Response.Redirect(url);
                }
                else
                {
                    LabelError.Text = "ERROR. El archivo XML no se encuentra disponible en estos momentos.";
                }
            }
            catch (NullReferenceException)
            {
                LabelError.Text = "Debe escoger un tema de la lista";
            }
        }
    }
}
