﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Security.Cryptography;
using DivulgacionCientifica;
using DivulgacionCientifica.CapaNegocio;
using System.Data.SqlClient;
using System.Collections.Generic;

namespace WebApplicationFloral
{
    public partial class WebFormRegistro : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            try
            {
                LabelMensajes.Text = "";
                LabelDisponible.Text = "";
                LabelCorrecto.Text = "";
                HyperLinkVolver.Visible = false;
                DropDownListPais.Items.Clear();
                cargarPaises(DropDownListPais);
            }
            catch (SqlException)
            {
                LabelMensajes.Text = "ERROR. Se ha producido un error en la base de datos.";
            }
        }

        protected void btAceptar_Click(object sender, EventArgs e)
        {
            try
            {

                if (TextBoxUsuario.Text.Equals("") || TextBoxUsuario.Text.Contains(" ") || (TextBoxUsuario.Text.Length > 45))
                {
                    LabelMensajes.Text = "ERROR. El nombre de usuario no puede ser vacio, exceder de 45 caracteres ni contener espacios.";
                }
                else if (!Usuario.idDisponible(TextBoxUsuario.Text))
                {
                    LabelMensajes.Text = "ERROR. Nombre de usuario no disponible.";
                }
                else if (!TextBoxContrasena.Text.Equals(TextBoxContrasena1.Text))
                {
                    LabelMensajes.Text = "ERROR. Las contraseñas no coinciden";
                }
                else if (TextBoxContrasena.Text.Equals(""))
                {
                    LabelMensajes.Text = "ERROR. Debe introducir la contraseña.";
                }
                else if (TextBoxNombre.Text.Equals("") || TextBoxApellidos.Text.Equals(""))
                {
                    LabelMensajes.Text = "ERROR. Debe introducir su nombre y apellidos.";
                }
                else if (TextBoxEmail.Text.Equals("") || !Auxiliares.EmailCorrecto(TextBoxEmail.Text) || (TextBoxEmail.Text.Length > 45))
                {
                    LabelMensajes.Text = "ERROR. Email incorrecto.";
                }
                else if (TextBoxOcupacion.Text.Equals(""))
                {
                    LabelMensajes.Text = "ERROR. Debe indicar su ocupación.";
                }
                else if (!(soloNumeros(TextBoxTelefono1.Text) && soloNumeros(TextBoxTelefono2.Text)))
                {
                    LabelMensajes.Text = "ERROR. No ha intruducido correctamente algún número de teléfono.";
                }
                else
                {
                    string sexo = "";
                    if (RadioButtonHombre.Checked)
                    {
                        sexo = "hombre";
                    }
                    else if (RadioButtonMujer.Checked)
                    {
                        sexo = "mujer";
                    }
                    else
                    {
                        LabelMensajes.Text = "ERROR. Debe marcar su sexo.";
                    }

                    Usuario user = new Usuario(TextBoxUsuario.Text, TextBoxContrasena.Text, TextBoxNombre.Text,
                    TextBoxApellidos.Text, TextBoxEmail.Text, new Pais(DropDownListPais.SelectedItem.Text), sexo, TextBoxOcupacion.Text,
                    TextBoxTelefono1.Text, TextBoxTelefono2.Text, TextBoxObserv.Text);

                    try
                    {
                        user.almacenarUsuario();

                        btLimpiar_Click(sender, e);
                        LabelCorrecto.Text = "Registro realizado con ÉXITO. Recuerde que deberá ser validado antes de que sea efectivo.";
                        HyperLinkVolver.Visible = true;
                    }
                    catch (SqlException)
                    {
                        LabelMensajes.Text = "ERROR. Se ha producido un error al almacenar sus datos.";
                    }

                }
            }
            catch (SqlException)
            {
                LabelMensajes.Text = "ERROR. No se ha podido realizar la petición de registro.";
            }
        }

        public bool soloNumeros(string cad)
        {
            try
            {
                if (cad.Equals(""))
                {   
                }
                else
                {
                    Int64.Parse(cad);
                }
                return true;
            }
            catch (FormatException)
            {
                return false;
            }
        }

        protected void btDisponible_Click(object sender, EventArgs e)
        {
            try
            {
                bool disp = Usuario.idDisponible(TextBoxUsuario.Text);
                if (!disp || TextBoxUsuario.Text.Equals(""))
                {
                    LabelDisponible.Text = "No";
                }
                else
                {
                    LabelDisponible.Text = "Sí";
                }
            }
            catch (SqlException)
            {
                LabelMensajes.Text = "ERROR. Se ha producido un error al hacer la comprobación de disponibilidad.";
            }
        }       

        protected void btLimpiar_Click(object sender, EventArgs e)
        {
            TextBoxUsuario.Text = "";
            TextBoxContrasena.Text = "";
            TextBoxContrasena1.Text = "";
            TextBoxNombre.Text = "";
            TextBoxApellidos.Text = "";
            TextBoxEmail.Text = "";
            RadioButtonHombre.Checked = false;
            RadioButtonMujer.Checked = false;
            LabelMensajes.Text = "";
            LabelCorrecto.Text = "";
            TextBoxOcupacion.Text = "";
            TextBoxTelefono1.Text = "";
            TextBoxTelefono2.Text = "";
            TextBoxObserv.Text = "";
        }

        public void cargarPaises(DropDownList ddl)
        {
            List<Pais> paises = Pais.getPaises();
            foreach (Pais p in paises)
            {
                ddl.Items.Add(p.getNombre());
            }
        }
    }
}
