﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Data.SqlClient;
using System.Collections.Generic;
using DivulgacionCientifica.CapaNegocio;

namespace DivulgacionCientifica.images
{
    public partial class VerObservaciones : System.Web.UI.Page
    {
        //string idCurrentUser = HttpContext.Current.User.Identity.Name;
        Usuario currentUser = new Usuario(HttpContext.Current.User.Identity.Name);
        Publicacion pub;

        protected void Page_Load(object sender, EventArgs e)
        {
            LabelError.Text = "";
            try
            {
                pub = new Publicacion(Int32.Parse(Request.Params["id"]));
                if (currentUser.getId().Equals(pub.getCreador().getId()))
                {
                    LabelTitulo.Text = pub.getTitulo();
                    PanelComentarios.Controls.Clear();
                    cargarComentarios(Comentario.getComentarios(pub, currentUser), false);
                }
                else if (Usuario.esAdministrador(currentUser.getId()))
                {
                    LabelTitulo.Text = pub.getTitulo();
                    PanelComentarios.Controls.Clear();
                    cargarComentarios(Comentario.getComentarios(pub, pub.getCreador()), true);
                }
                else{
                    //Se ha accedido copiando la direccion en el navegador pq los hyperlink estan ocultos
                    Response.Redirect("Inicio.aspx");
                }
            }
            catch(SqlException)
            {
                LabelError.Text = "ERROR. No se han podido cargar los comentarios.";
            }
        }

        private void cargarComentarios(List<Comentario> coments, bool esAdmin)
        {
            foreach (Comentario c in coments)
            {
                //Titulo
                PanelComentarios.Controls.Add(new LiteralControl("<h3>"));
                Label lbAutor = new Label();
                lbAutor.ID = "LbAutor" + c.getID();
                lbAutor.Text = c.getCreador().getNombre() + " " + c.getCreador().getApellidos() + ":";
                lbAutor.ForeColor = System.Drawing.Color.ForestGreen;
                PanelComentarios.Controls.Add(lbAutor);
                PanelComentarios.Controls.Add(new LiteralControl("</h3>"));

                //Contenido
                PanelComentarios.Controls.Add(new LiteralControl("<div>"));
                if (!c.getRevisada())
                    PanelComentarios.Controls.Add(new LiteralControl("<p style=\"font-weight: bold\">"));
                else
                    PanelComentarios.Controls.Add(new LiteralControl("<p>"));
                PanelComentarios.Controls.Add(new LiteralControl(c.getDescripcion()));
                PanelComentarios.Controls.Add(new LiteralControl("</p>"));
                PanelComentarios.Controls.Add(new LiteralControl("</div>"));

                //Datos varios
                PanelComentarios.Controls.Add(new LiteralControl("<div>"));
                PanelComentarios.Controls.Add(new LiteralControl("<p style=\"font-family: 'trebuchet MS'; left: 5px; font-size: x-small; right: 5px; color: #808080;\">"));
                PanelComentarios.Controls.Add(new LiteralControl("Enviada el " + c.getFecha().ToString()));
                PanelComentarios.Controls.Add(new LiteralControl("</p>"));

                //Opciones
                LinkButton lbEliminar = new LinkButton();
                lbEliminar.ID = "lbEliminar" + c.getID();
                lbEliminar.Text = "Eliminar";
                lbEliminar.Command += new CommandEventHandler(lbEliminar_Click);
                lbEliminar.CommandArgument = c.getID().ToString();
                PanelComentarios.Controls.Add(lbEliminar);
                PanelComentarios.Controls.Add(new LiteralControl("</div>"));

                if (!esAdmin)
                {
                    c.marcarRevisado();
                }
            }
        }

        public void lbEliminar_Click(object sender, EventArgs e)
        {
            try
            {
                LinkButton lbtSender = (LinkButton)sender;
                int idCom = Int32.Parse(lbtSender.CommandArgument);
                Comentario c = new Comentario(idCom);
                c.eliminar();
                Response.Redirect("VisualizarPublicacion.aspx?id=" + pub.getID());
            }
            catch (SqlException)
            {
                LabelError.Text = "ERROR. No se ha podido eliminar el comentario";
            }
        }
    }
}
