﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Data.SqlClient;
using DivulgacionCientifica.CapaNegocio;
using System.Collections.Generic;
using System.Net.Mail;
using System.IO;

namespace DivulgacionCientifica
{
    public partial class VisualizarPublicacion : System.Web.UI.Page
    {
        string idCurrentUser = HttpContext.Current.User.Identity.Name;
        Publicacion pub;

        protected void Page_Load(object sender, EventArgs e)
        {
            LabelError.Text = "";
            PanelOpciones.Controls.Clear();
            PanelValidar.Visible = false; //Por si se produce un error al cargar la publicación y no llega a la línea donde la oculto
            if (Request.Params["id"] == null)
            {
                Response.Redirect("Inicio.aspx");
            }
            else
            {
                lBtRechazar.Attributes.Add("language", "javascript");
                lBtRechazar.Attributes.Add("OnClick", "return confirm('¿Esta seguro que desea que la publicación NO se haga efectiva?')");
                try
                {
                    pub = new Publicacion(Int32.Parse(Request.Params["id"]));
                    if (!Usuario.esAdministrador(idCurrentUser) || pub.getValidada())
                    { PanelValidar.Visible = false; }
                    else
                    {
                        PanelValidar.Visible = true;
                    }
                    if ((pub.getValidada() && !pub.getEliminada()) || Usuario.esAdministrador(idCurrentUser))
                    {
                        PanelValidar.Visible = false;
                        if (Usuario.esAdministrador(idCurrentUser) && !pub.getValidada()) { PanelValidar.Visible = true; }
                        PanelOpciones.Visible = true;
                        LabelTitulo.Text = pub.getTitulo();

                        //Contenido
                        //PanelNoticias.Controls.Add(new LiteralControl("<p style=\"margin: auto 70px auto 70px; width: auto; font-family: 'trebuchet MS'; left: 5px; font-size: small; right: 5px; text-align: justify;\">"));
                        PanelPublicacion.Controls.Add(new LiteralControl("<div class=\"vprevia\">"));
                        PanelPublicacion.Controls.Add(new LiteralControl(Auxiliares.textoPlanoAHtml(pub.getContenido())));
                        PanelPublicacion.Controls.Add(new LiteralControl("</div>"));
                        PanelPublicacion.Controls.Add(new LiteralControl("<br />"));

                        //Contenido multimedia
                        if (PanelValidar.Visible == true)
                        {
                            Auxiliares.cargarArchivos(PanelArchivos, pub.getArchivosNoValidados(false)); //Todavia no se han validado
                        }
                        else
                        {
                            Auxiliares.cargarArchivos(PanelArchivos, pub.getArchivos(false));
                        }

                        //Referencias
                        Auxiliares.cargarReferencias(PanelReferencias, pub.getReferencias(true));

                        //Datos varios
                        PanelOpciones.Controls.Add(new LiteralControl("<div class=\"vprevia\">"));
                        PanelOpciones.Controls.Add(new LiteralControl("<p style=\"font-family: 'trebuchet MS'; left: 5px; font-size: x-small; right: 5px; color: #808080;\">"));
                        string autor = pub.getCreador().getNombre();
                        PanelOpciones.Controls.Add(new LiteralControl("Publicada por " + autor + " el " + pub.getFechaCreacion().ToString()));
                        PanelOpciones.Controls.Add(new LiteralControl("</p>"));
                        PanelOpciones.Controls.Add(new LiteralControl("<br />"));
                        PanelOpciones.Controls.Add(new LiteralControl("</div>"));

                        //Opciones
                        PanelOpciones.Controls.Add(new LiteralControl("<div class=\"vprevia\">"));
                        if (Usuario.esAdministrador(idCurrentUser) && (!pub.getValidada()))
                        {
                            PanelValidar.Visible = true;
                            PanelOpciones.Visible = false;
                        }
                        if (idCurrentUser.Equals(pub.getCreador().getId()))
                        {
                            if (Usuario.esAdministrador(idCurrentUser))
                            {
                                HyperLink hpEditar = new HyperLink();
                                hpEditar.ID = "hpEditar" + pub.getID();
                                hpEditar.Text = "Editar";
                                hpEditar.NavigateUrl = "EditarPublicAdmin.aspx?id=" + pub.getID();
                                PanelOpciones.Controls.Add(hpEditar);
                                PanelOpciones.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));

                                LinkButton lbEliminar = new LinkButton();
                                lbEliminar.ID = "lbEliminar" + pub.getID();
                                lbEliminar.Text = "Eliminar";
                                lbEliminar.Attributes.Add("language", "javascript");
                                lbEliminar.Attributes.Add("OnClick", "return confirm('¿Esta seguro que desea eliminar la publicación?')");
                                lbEliminar.Command += new CommandEventHandler(lBtEliminar_Click);
                                lbEliminar.CommandArgument = pub.getID().ToString();
                                PanelOpciones.Controls.Add(lbEliminar);
                                PanelOpciones.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));

                                LinkButton lbEliminarFeed = new LinkButton();
                                lbEliminarFeed.ID = "lbEliminarFeed" + pub.getID();
                                lbEliminarFeed.Text = "Eliminar del feed";
                                lbEliminarFeed.Attributes.Add("language", "javascript");
                                lbEliminarFeed.Attributes.Add("OnClick", "return confirm('¿Esta seguro que desea eliminar la publicación del feed RSS? Recuerde que si no se encontraba en el feed esta accion no tendrá ningún efecto.')");
                                lbEliminarFeed.Command += new CommandEventHandler(lbEliminarFeed_Click);
                                lbEliminarFeed.CommandArgument = pub.getID().ToString();
                                PanelOpciones.Controls.Add(lbEliminarFeed);
                                PanelOpciones.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));
                            }
                            else
                            {
                                HyperLink hpEditar = new HyperLink();
                                hpEditar.ID = "hpEditar" + pub.getID();
                                hpEditar.Text = "Editar";
                                hpEditar.NavigateUrl = "EditarPublicUsu.aspx?id=" + pub.getID();
                                PanelOpciones.Controls.Add(hpEditar);
                                PanelOpciones.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));

                                LinkButton lbEliminar = new LinkButton();
                                lbEliminar.ID = "lbEliminar" + pub.getID();
                                lbEliminar.Text = "Eliminar";
                                lbEliminar.Attributes.Add("language", "javascript");
                                lbEliminar.Attributes.Add("OnClick", "return confirm('¿Esta seguro que desea eliminar la publicación?')");
                                lbEliminar.Command += new CommandEventHandler(lBtEliminar_Click);
                                lbEliminar.CommandArgument = pub.getID().ToString();
                                PanelOpciones.Controls.Add(lbEliminar);
                                PanelOpciones.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));
                            }

                            if (pub.tieneComentarios())
                            {
                                HyperLink hpAnadirObserv = new HyperLink();
                                hpAnadirObserv.ID = "hpVerComent" + pub.getID();
                                int numNL = (int)pub.numComentariosNoLeidas();
                                if (numNL == 0)
                                {
                                    hpAnadirObserv.Text = "Ver Comentarios";
                                }
                                else if (numNL == 1)
                                {
                                    hpAnadirObserv.Text = "Ver Comentarios (1 no leído)";
                                }
                                else
                                {
                                    hpAnadirObserv.Text = "Ver Comentarios (" + numNL + " no leídos)";
                                }
                                hpAnadirObserv.NavigateUrl = "VerComentarios.aspx?id=" + pub.getID();
                                PanelOpciones.Controls.Add(hpAnadirObserv);
                            }

                            PanelOpciones.Controls.Add(new LiteralControl("<br />"));
                            PanelOpciones.Controls.Add(new LiteralControl("<br />"));
                        }
                        else
                        {
                            if (Usuario.esAdministrador(idCurrentUser))
                            {
                                HyperLink hpEditar = new HyperLink();
                                hpEditar.ID = "hpEditar" + pub.getID();
                                hpEditar.Text = "Editar";
                                hpEditar.NavigateUrl = "EditarPublicAdmin.aspx?id=" + pub.getID();
                                PanelOpciones.Controls.Add(hpEditar);
                                PanelOpciones.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));

                                LinkButton lbEliminar = new LinkButton();
                                lbEliminar.ID = "lbEliminar" + pub.getID();
                                lbEliminar.Text = "Eliminar";
                                lbEliminar.Attributes.Add("language", "javascript");
                                lbEliminar.Attributes.Add("OnClick", "return confirm('¿Esta seguro que desea eliminar la publicación?')");
                                lbEliminar.Command += new CommandEventHandler(lBtEliminar_Click);
                                lbEliminar.CommandArgument = pub.getID().ToString();
                                PanelOpciones.Controls.Add(lbEliminar);
                                PanelOpciones.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));

                                LinkButton lbEliminarFeed = new LinkButton();
                                lbEliminarFeed.ID = "lbEliminarFeed" + pub.getID();
                                lbEliminarFeed.Text = "Eliminar del feed";
                                lbEliminarFeed.Attributes.Add("language", "javascript");
                                lbEliminarFeed.Attributes.Add("OnClick", "return confirm('¿Esta seguro que desea eliminar la publicación del feed RSS? Recuerde que si no se encontraba en el feed esta accion no tendrá ningún efecto.')");
                                lbEliminarFeed.Command += new CommandEventHandler(lbEliminarFeed_Click);
                                lbEliminarFeed.CommandArgument = pub.getID().ToString();
                                PanelOpciones.Controls.Add(lbEliminarFeed);
                                PanelOpciones.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));

                                if (pub.tieneComentarios())
                                {
                                    HyperLink hpAnadirObserv = new HyperLink();
                                    hpAnadirObserv.ID = "hpVerComent" + pub.getID();
                                    int numNL = (int)pub.numComentariosNoLeidas();
                                    if (numNL == 0)
                                    {
                                        hpAnadirObserv.Text = "Ver Comentarios";
                                    }
                                    else if (numNL == 1)
                                    {
                                        hpAnadirObserv.Text = "Ver Comentarios (1 no leído)";
                                    }
                                    else
                                    {
                                        hpAnadirObserv.Text = "Ver Comentarios (" + numNL + " no leídos)";
                                    }
                                    hpAnadirObserv.NavigateUrl = "VerComentarios.aspx?id=" + pub.getID();
                                    PanelOpciones.Controls.Add(hpAnadirObserv);
                                    PanelOpciones.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));
                                }
                            }
                            if (!idCurrentUser.Equals(""))
                            {
                                HyperLink hpAnadirObserv = new HyperLink();
                                hpAnadirObserv.ID = "hpAnadirObserv" + pub.getID();
                                hpAnadirObserv.Text = "Añadir comentario";
                                hpAnadirObserv.NavigateUrl = "AnadirComentario.aspx?id=" + pub.getID();
                                PanelOpciones.Controls.Add(hpAnadirObserv);
                                PanelOpciones.Controls.Add(new LiteralControl("<br />"));
                                PanelOpciones.Controls.Add(new LiteralControl("<br />"));
                            }
                        } 
                        PanelOpciones.Controls.Add(new LiteralControl("</div>"));
                    }
                    else
                    {
                        LabelTitulo.Text = "ERROR";
                        LabelError.Text = "La publicac no existe o ha sido eliminada.";
                        PanelPublicacion.Visible = false;
                    }
                }
                catch (SqlException)
                {
                    LabelError.Text = "ERROR. Se ha producido un error al cargar la publicación.";
                }
                catch (NullReferenceException)
                {
                    //Se produce cuando la noticia no existe
                    Response.Redirect("Inicio.aspx");
                }
                catch (FormatException)
                {
                    LabelError.Text = "ERROR. Se ha producido un error al obtener el identificador de la publicac.";
                }
            }
        }

        protected void lBtEliminar_Click(object sender, EventArgs e)
        {
            try
            {
                pub.eliminarPublicLogico();
                Response.Redirect("Inicio.aspx");
            }
            catch (SqlException)
            {
                LabelError.Text = "ERROR. No se ha podido cargar la publicac.";
            }
            catch (FormatException)
            {
                LabelError.Text = "ERROR";
            }
        }

        protected void lBtValidar_Click(object sender, EventArgs e)
        {
            try
            {
                int importancia = Int32.Parse(RadioButtonList1.SelectedItem.Text);
                pub.validarYAsingarImportancia(importancia);
                pub.añadirALosFeeds();
                PanelValidar.Visible = false;
                enviarEmailAfirmativo();
                Response.Redirect("VisualizarPublicacion.aspx?id=" + pub.getID());
            }
            catch (SqlException)
            {
                LabelError.Text = "ERROR. No se ha podido cargar la publicac.";
            }
            catch (FormatException)
            {
                LabelError.Text = "AVISO. No se ha podido enviar un email al autor ya que su dirección no es correcta.";
            }
            catch (IOException)
            {
                LabelError.Text = "AVISO. No se ha podido añadir la publicación a los feeds RSS.";
            }
        }

        protected void lBtRechazar_Click(object sender, EventArgs e)
        {
            enviarEmailNegativo();
            pub.eliminarPublicFisico();
            Response.Redirect("Peticiones.aspx");
        }

        public void enviarEmailAfirmativo()
        {
            try
            {
                MailMessage correo = new MailMessage();
                correo.From = new System.Net.Mail.MailAddress(Estatica.getMailAdress, "Divulgacion Científica", System.Text.Encoding.UTF8);
                string to = pub.getCreador().getEmail();
                correo.To.Add(to);
                correo.Subject = "Publicación aceptada";
                correo.Body = "Hola " + pub.getCreador().getNombre() + @",

Le comunicamos que ha sido publicada la publicación con título: " + pub.getTitulo() + @".

Puede verla a partir de este momento en " + Estatica.getUrlProyecto + "VisualizarPublicacion.aspx?id=" + pub.getID() + @"

Gracias.";
                correo.IsBodyHtml = false;
                correo.Priority = System.Net.Mail.MailPriority.Normal;

                SmtpClient smtp = new SmtpClient();
                smtp.Host = Estatica.getSmtp;
                smtp.EnableSsl = Estatica.getSmtpUsaSSL;
                if (Estatica.getSmtpUsaSSL)
                {
                    smtp.Credentials = new System.Net.NetworkCredential(Estatica.getMailAdress, Estatica.getMailPassw);
                }
                smtp.Send(correo);
            }
            catch (ArgumentException)
            {
                LabelError.Text = "AVISO. No se ha podido enviar el email al creador debido ya que su dirección no tiene el formato correcto.";
            }
            catch (SmtpException)
            {
                LabelError.Text = "AVISO. No se ha podido enviar el email al creador.";
            }
        }

        public void enviarEmailNegativo()
        {
            try
            {
                MailMessage correo = new MailMessage();
                correo.From = new System.Net.Mail.MailAddress(Estatica.getMailAdress, "Divulgacion Científica", System.Text.Encoding.UTF8);
                string email = pub.getCreador().getEmail();
                correo.To.Add(email);
                correo.Subject = "Publicación rechazada";
                correo.Body = "Hola " + pub.getCreador().getNombre() + @",

Le comunicamos que NO ha sido aceptada la publicación con título " + pub.getTitulo() + @".

Lo sentimos.";
                correo.IsBodyHtml = false;
                correo.Priority = System.Net.Mail.MailPriority.Normal;

                SmtpClient smtp = new SmtpClient();
                smtp.Host = Estatica.getSmtp;
                smtp.EnableSsl = Estatica.getSmtpUsaSSL;
                if (Estatica.getSmtpUsaSSL)
                {
                    smtp.Credentials = new System.Net.NetworkCredential(Estatica.getMailAdress, Estatica.getMailPassw);
                }
                smtp.Send(correo);
            }
            catch (FormatException)
            {
                LabelError.Text = "AVISO. No se ha podido enviar el email al creador debido ya que su dirección no tiene el formato correcto.";
            }
            catch (SmtpException)
            {
                LabelError.Text = "AVISO. No se ha podido enviar el email al creador.";
            }
        }

        public void lbEliminarFeed_Click(object sender, EventArgs e)
        {
            try
            {
                LinkButton lbtSender = (LinkButton)sender;
                int idPub = Int32.Parse(lbtSender.CommandArgument);
                Publicacion pub = new Publicacion(idPub);
                pub.eliminarDeLosFeeds();
            }
            catch (SqlException)
            {
                LabelError.Text = "ERROR. No se ha podido eliminar la publicación";
            }
        }
    }
}
